/*
 * Collection of StoreDetail model
 */
 var storeCnt = -1; 
var ClinicDetailList = Backbone.Collection.extend({
	
	initialize: function(options) {
		this.self = this;
        this.fromPage = "";
	},
	
	model: StoreDetail,
	
    /* Set preferred store with local storage */
	setPreferredClinic: function() {
		/* Get correct store number */
		var storeNum = null;
		 if(localStorage.getItem("CurrentClinic")){		/* Has current store */
			storeNum = JSON.parse(localStorage.getItem("CurrentClinic")).ClinicNumber;
		}else{
			return;
		}
		
		/* Exception check */
		if(!storeNum) return;
		
		/* Unset current preferred store */
		if(this.preferredClinic)
			this.preferredClinic.resetPreferredClinic();
		
		/* Update */
		var newStore = this.findWhere({StoreNumber: storeNum});
		
		/* set model's isPreferred attribute */
		if(newStore){
			/* This change will notify collection to change preferredStore */
			newStore.setPreferredClinic();	
		}else{
			this.preferredClinic = null;
		}
			
	},

	fetchMoreClinicCallBack: function(data, self) {
		/* Set start point */
		var newStartIndex = self.length;	/* self.length - 1 + 1 */
		var l = data.Clinic.length-1;
		
		var t = 0;
		
		storeCnt = data.Clinic.length;
        var CurrentClinicNum = null;
		if(localStorage.getItem("CurrentClinic")){		/* Has current store */
			CurrentClinicNum = JSON.parse(localStorage.getItem("CurrentClinic")).ClinicNumber;
		}
        var updated = false;
        console.log("clinicFilterView.serviceList:" + clinicFilterView.serviceList + " storeCnt:" + storeCnt);
		/* populate data */
        if (data.Success == 1) {	/* Success on StoreList webservice call */ 
            for (var i = 0; i <= l; i++) {
                var isExist = 1;
                
                for (var j = 0;j < newStartIndex;j++) {
                    if (self.models[j].attributes.ClinicNumber == data.Clinic[i].ClinicNumber) {
                        isExist = 0;
                        break;
                    }
                }

                //if (data.Store[i].StoreServices.indexOf("Medical Clinic") >= 0 && newStartIndex > 0 && isExist == 1) {		
                if (newStartIndex > 0 && isExist == 1) {		
                    if (data.Clinic[i].ClinicNumber == CurrentClinicNum)
                            data.Clinic[i].isPreferredClinic = true;

                    if (clinicFilterView.serviceList.toString().indexOf("OPEN") >= 0) {
                        if (self.storeIsOpen(data.Clinic[i])) {
                            t++;
                            self.create(data.Clinic[i]);
                            updated = true;
                        }
                    }
                    else {
                        t++;
                        self.create(data.Clinic[i]);
                        updated = true;
                    }
                    
                }
                if (t >= 4)
                    break;
            }
            /* Show pullup icon */
            if (!updated) {
                clinicListView.listScroller.refresh();
               
            }
        }
        else {					/* Some error has occured */
            /* ** Need Exception Handler here */
        	jAlert("We could not find the store you specified.","Please Try Again");
            //alert("We could not find the store you specified");
        }
		
	},
	
    fetchClinicDataCallBack: function (data, self) {
        var i = 0;
        /* reset the collection */
        self.reset();
        console.log("fetchClinicDataCallBack from page:" + clinicLocatorView.searchFromPage);
//        var CurrentClinicNum = null;
////        if (localStorage.getItem("CurrentClinic")) {		/* Has current store */
////            CurrentClinicNum = JSON.parse(localStorage.getItem("CurrentClinic")).ClinicNumber;
////        }
        /* populate data */
        if (data.Success == 1) {	/* Success on StoreList webservice call */ 
            $.each(data.Clinic, function(index, value) {
                console.log("clinicFilterView.serviceList:" + clinicFilterView.serviceList.toString() + "index:" + index + " value:" + value);
//                if (data.Clinic[i].ClinicNumber == CurrentClinicNum)
//                    data.Clinic[i].isPreferredClinic = true;

                if (clinicFilterView.serviceList.toString().indexOf("OPEN") >= 0) {
                    if (self.storeIsOpen(value)) {
                        i++;
                        self.create(value).setCollection(self); 
                    }
                }
                else {
                    i++;
                    self.create(value).setCollection(self); 
                }
                if (i >= 4) {
                    return false;
                }	
                //}
            });
			

            /* Check if there are any result */
            if (self.length < 1) {
                jAlert("No Store Found.", "Please Try Again");
                if (clinicLocatorView.searchFromPage == "clinicFilter")
                    clinicLocatorView.clinicSearchFilter();
            }
            else {
                clinicListView.refreshScroller();
                clinicListMapView.showMap()
            }
        }
        else {					/* Some error has occured */
            /* ** Need Exception Handler here */
        	  jAlert("We could not find the store you specified.", "Please Try Again");
        }
    },
	
	
	phoneGapClinicSuccess: function (position) {

		/* Hide spinner */
		$("#clinic-geo-search-load").css("visibility", "hidden");
		/* Remove spinner */
		$("#clinic-page").find(".rexall-page-header").html("<p>MEDICAL CLINIC LOCATOR</p><div class='rexall-page-header-info'></div>");

		//alert("Success! Populating stores...");
		clinicDetailList.fetchClinicDataWithLocation(position.coords.latitude, position.coords.longitude, 400);
	},
	
	/*
	 * Error Call back function for phoneGap geolocation call 
	 */
	phoneGapError: function () {
	
		/* Hide spinner */
		$("#clinic-geo-search-load").css("visibility", "hidden");
		/* Remove spinner */
		$("#clinic-page").find(".rexall-page-header").html("<p>MEDICAL CLINIC LOCATOR</p><div class='rexall-page-header-info'></div>");

		jAlert("Unable to determine your location. Please check your phone settings.", "Location Service");
	},
	 
	//url: "http://api.rexall.ca/v1/Rexall.svc/StoreList?APIKey=Ni878Yb4UjMef91G&latitude=43.6317&longitude=-79.6756&NumStores=5",
	url:"http://api.rexall.ca/",
	
	/*
	 * Fetch data with a fix location, for debugging only
	 */
//	fetchData123: function() {
//		
//		/* Set the search center of this collection */
//		this.lat = 43.6317;
//		this.lng = -79.6756;
//		
//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: "http://api.rexall.ca/v2/standard/Rexall.svc/StoreList",
//			"parameter"		: {
//								"APIKey" 	: getWebserviceAPIKey(),	
//								"latitude"	: 43.6317, 
//								"longitude"	: -79.6756,
//								"NumResults":4 
//								//"NumStores"	: 4
//							  },
//			"callBack"		: this.fetchDataCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
//		
//		//this.fetch();
//		
//		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
//	},
	
	/*
	 * Fetch data with a specific location
	 */
//	fetchDataWithLocation123: function(lat, lng, num) {
//		
//		/* Set the search center of this collection */
//		this.lat = lat;
//		this.lng = lng;
//		
//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: "http://api.rexall.ca/v2/standard/Rexall.svc/StoreList",
//			"parameter"		: {
//								"APIKey" 	: getWebserviceAPIKey(),	
//								"latitude"	: lat, 
//								"longitude"	: lng,
//								"NumResults":4 
//								//"NumStores"	: num
//							  },
//			"callBack"		: this.fetchDataCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
//		//this.fetch();
//		
//		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
//		
//	},
	
	/*
	 * Fetch Clinic data with a specific location
	 */
	fetchClinicDataWithLocation: function(lat, lng, num) {

		/* Set the search center of this collection */
		this.lat = lat;
		this.lng = lng;

        var self = this;
        var data = {
			
            APIKey 	: getWebserviceAPIKey(),	
            latitude	: this.lat, 
            longitude	: this.lng,
            NumResults	: num ? num : 4,
            //"NumStores"	: num ? num : 4,
            ReturnRadius : 100,
							 
        };

         /* Show spinner */
		$("#global-spinner").css("visibility", "visible");
		$("#clinic-search-input").attr("readOnly",true);

        $.ajax({
            url: getRexallWebserviceRoot() + "v3/standard/Rexall.svc/ClinicList",
            type: 'GET',
            data: data,
            crossDomain: true,
            dataType: 'json',
            success: function(res) {	
                console.log("fetchClinicDataWithLocation ");
                 /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                self.fetchClinicDataCallBack(res, self);
            },
            error: function(XHR, textStatus, error) {
                //alert(JSON.stringify(XHR) + "\n" +textStatus +"\n" + error + "\n");
                 /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                jAlert("An error occurs when trying to get the data, please try again.", "Rexall");
            },
            complete:function(XHR, textStatus) {
                // self.afterFetch();
            }
        }); 

//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: getRexallWebserviceRoot() + "v2/standard/Rexall.svc/StoreList",
//			"parameter"		: {
//								"APIKey" 	: "Ni878Yb4UjMef91G",	
//								"latitude"	: lat, 
//								"longitude"	: lng,
//								"NumResults"	: num ? num : 4,
//								//"NumStores"	: num ? num : 4,
//								"FilterAttributeList" : "[{ \"StoreServices.ServiceName\": \"Medical Clinic\"}]",
//                                //"StoreServices.ServiceName": "Medical Clinic",
//							  },
//			"callBack"		: this.fetchClinicDataCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
//		//this.fetch();
//		 console.log("fetchClinicDataWithLocation ");
//		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
//		
	},

	 /*
	 * Fetch data with default location stored in this model
	 * For now I'm assuming this location is geolocation, but later on can be use with smarter method
	 */
	fetchClinicDataWithDefaultLocation: function(num) {
		
		/* !! IMPORTANT
		 * Have to Remeber the storeFilterView.serviceList here for this search, 
		 * since in the callback for this search the serviceList will be reset and fetchMore will not behave correctly. */
		this.fetchMoreServiceList = clinicFilterView.serviceList ? clinicFilterView.serviceList : "";
		
		/* Check if default location exist */
		if(!this.lat || !this.lng){
			this.fetchDataWithGeo();
			return;
		}
		
       var self = this;
        var data =  {
			
						APIKey 	: getWebserviceAPIKey(),	
						latitude	: this.lat, 
						longitude	: this.lng,
						NumResults	: num ? num : 4,
						//"NumStores"	: num ? num : 4,
						ReturnRadius : 100,
							 
		};

         /* Show spinner */
		$("#global-spinner").css("visibility", "visible");
		$("#clinic-search-input").attr("readOnly",true);

        $.ajax({
                url: getRexallWebserviceRoot() + "v3/standard/Rexall.svc/ClinicList",
                type: 'GET',
                data: data,
                crossDomain: true,
                dataType: 'json',
                success: function(res) {	
                    console.log("fetchClinicDataWithDefaultLocation call back");
                      /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                    self.fetchClinicDataCallBack(res, self);
                    
                },
                error: function(XHR, textStatus, error) {
                    //alert(JSON.stringify(XHR) + "\n" +textStatus +"\n" + error + "\n");
                    /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                    jAlert("An error occurs when trying to get the data, please try again.", "Something Went Wrong");
                },
                complete:function(XHR, textStatus) {
                    // self.afterFetch();
                }
            }); 
	
//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: getRexallWebserviceRoot() + "v2/standard/Rexall.svc/StoreList",
//			"parameter"		: {
//								"APIKey" 	: "Ni878Yb4UjMef91G",	
//								"latitude"	: this.lat, 
//								"longitude"	: this.lng,
//								"NumResults"	: num ? num : 4,
//								//"NumStores"	: num ? num : 4,
//								"FilterAttributeList" : [{ 'StoreServices.ServiceName': 'Medical Clinic'}],
//							  },
//			"callBack"		: this.fetchClinicDataCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
		
		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
		//storeFilterView.serviceList =[];
		
	},
	
	/*
	 * Fetch data with geolocation of the device
	 */
	fetchDataWithGeo:function (callBackFunction) {
		var maximumAge = 5000;				/* Maxium age for cache of location, (PhoneGap function parameter) */
		var timeout = 15000;				/* Maxium time for sensing geolocation signal, (PhoneGap function parameter) */
		
		/* Show spinner */
		//$("#locatore-geo-search-load").css("visibility", "visible");
		/* Add spinner */
		$("#clinic-page").find(".rexall-page-header").html("Detecting your location &nbsp;&nbsp <div id='circleG'><div id='circleG_1' class='circleG'></div><div id='circleG_2' class='circleG'></div><div id='circleG_3' class='circleG'></div></div>");
		
		/* PhoneGap call */
		if(callBackFunction){
			navigator.geolocation.getCurrentPosition(callBackFunction, this.phoneGapError,  {maximumAge: maximumAge, timeout:timeout, enableHighAccuracy:true});
		}else{
			navigator.geolocation.getCurrentPosition(this.phoneGapSuccess, this.phoneGapError,  {maximumAge: maximumAge, timeout:timeout, enableHighAccuracy:true});
		}
	},
	
	/*
	 * Fetch data with a input location
	 * Get lat and lng using google api first 
	 */
	fetchDataWithInput123:function (q) {
		
		if(q){
			 var geocoder = new google.maps.Geocoder();
			 var self = this;
			 geocoder.geocode( { 'address': q}, function(results, status) {
				    if (status == google.maps.GeocoderStatus.OK) { 
				      var searchLat = results[0].geometry.location.lat();
				      var searchLng = results[0].geometry.location.lng();
				      /* Search this sepecific location */
				      //self.getSearchLocation(searchLat, searchLng);
				      self.fetchDataWithLocation(searchLat, searchLng, 5);
				      
				    } else {
				    	jAlert('Geocode was not successful for the following reason: ' + status,'Please Try Again')
				    }
				  });
		}else{
			jAlert("Please provide valid address.","Something Went Wrong");
			return true;
		}
	},
	
	/*
	 * Fetch data with a input location
	 * Get lat and lng using google api first 
	 * The output data are filtered by "medical clinic" service field
	 */
	fetchClinicDataWithInput:function(q){
		if(q){
			 var geocoder = new google.maps.Geocoder();
			 var self = this;
			 geocoder.geocode( { 'address': q}, function(results, status) {
				    if (status == google.maps.GeocoderStatus.OK) { 
				      var searchLat = results[0].geometry.location.lat();

				      var searchLng = results[0].geometry.location.lng();

				      /* Search this sepecific location */
				      //self.getSearchLocation(searchLat, searchLng);
				      self.fetchClinicDataWithLocation(searchLat, searchLng, 4);
				      /* reset my location */
				      clinicListMapView.myLocation = new google.maps.LatLng(searchLat,searchLng);
				      clinicListMapView.collection.lat=searchLat;
	    			  clinicListMapView.collection.lng=searchLng;
	            	  clinicListMapView.collection.reset();
				      
				    } else {
				    	jAlert("We were not able to find your location. Please try again.", "Something Went Wrong");
				    }
				  });
		}else{
			jAlert("Please provide valid address.","Something Went Wrong");
			return true;
		}
	},
	
	/*
	 * Fetch data with input phone number 
	 * the response of this call should have only one store
	 */
//	fetchDataWithPhone123 : function (phone) {
//
//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: "http://api.rexall.ca/v2/standard/Rexall.svc/StoreGet",
//			"parameter"		: {
//								"APIKey" 	: getWebserviceAPIKey(),
//								"PhoneNumber": phone
//							  },
//			"callBack"		: this.fetchDataCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
//		
//		//this.fetch();
//		
//		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
//	},
	
	
	/* 
	 * Fetch more stores in addition to the previous search 
	 * with the same search location
	 */
//	fetchMore123: function() {
//		
//		/* Construct web service options */
//		var webServiceOption = {
//			"webServiceURL"	: "http://api.rexall.ca/v2/standard/Rexall.svc/StoreList",
//			"parameter"		: {
//								"APIKey" 	: getWebserviceAPIKey(),	
//								"latitude"	: this.lat, 
//								"longitude"	: this.lng,
//								"NumResults"	: this.length + 4
//								//"NumStores"	: this.length + 4
//							  },
//			"callBack"		: this.fetchMoreCallBack,		/* Call back function when webservice respond */
//			"caller"		: this							/* refer back to the collection itself */
//		};
//		
//		/* Create new WebService instance */
//		var webService = new WebService(webServiceOption);
//		webService.callWebService();
//	},
	
	
	fetchMoreClinic: function() {
		 var self = this;
        var data = {
			
            APIKey 	: getWebserviceAPIKey(),	
            latitude	: this.lat, 
            longitude	: this.lng,
            NumResults	: (storeCnt==-1)?(this.length + 40):(storeCnt + 10),
            //"NumStores"	: num ? num : 4,
            ReturnRadius : 100,
							 
        };

          /* Show spinner */
		$("#global-spinner").css("visibility", "visible");
		$("#clinic-search-input").attr("readOnly",true);

        $.ajax({
            url: getRexallWebserviceRoot() + "v3/standard/Rexall.svc/ClinicList",
            type: 'GET',
            data: data,
            crossDomain: true,
            dataType: 'json',
            success: function(res) {	
                console.log("fetchMoreClinic ");
                 /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                self.fetchMoreClinicCallBack(res, self);
            },
            error: function(XHR, textStatus, error) {
                //alert(JSON.stringify(XHR) + "\n" +textStatus +"\n" + error + "\n");
                 /* Hide spinner */
		            $("#global-spinner").css("visibility", "hidden");
		            $("#clinic-search-input").attr("readOnly",false);
                jAlert("An error occurs when trying to get the data, please try again.", "Rexall");
            },
            complete:function(XHR, textStatus) {
                // self.afterFetch();
            }
        }); 
	},

    /* Check wether the input store is open or not */
	storeIsOpen:function(store){
		
		/* Get today */
		var today = new Date();
		var day = today.getDay();
		
		var storeHours = store.ClinicHours;
		
		/* Start and End time of the day */
		var start, end;
		
		switch(day)
			{
			case 1:
				if(storeHours.MondayOpen){
					start = storeHours.MondayOpen;
					end = storeHours.MondayClose;
				}else{
					return false;
				}
				break;
			case 2:
				if(storeHours.TuesdayOpen){
					start = storeHours.TuesdayOpen;
					end = storeHours.TuesdayClose;
				}else{
					return false;
				}
				break;
			case 3:
				if(storeHours.WednesdayOpen){
					start = storeHours.WednesdayOpen;
					end = storeHours.WednesdayClose;
				}else{
					return false;
				}
				break;
			case 4:
				if(storeHours.ThursdayOpen){
					start = storeHours.ThursdayOpen;
					end = storeHours.ThursdayClose;
				}else{
					return false;
				}
				break;
			case 5:
				if(storeHours.FridayOpen){
					start = storeHours.FridayOpen;
					end = storeHours.FridayClose;
				}else{
					return false;
				}
				break;
			case 6:
				if(storeHours.SaturdayOpen){
					start = storeHours.SaturdayOpen;
					end = storeHours.SaturdayClose;
				}else{
					return false;
				}
				break;
			case 0:
				if(storeHours.SundayOpen){
					start = storeHours.SundayOpen;
					end = storeHours.SundayClose;
				}else{
					return false;
				}
				break;
			default:
				return false;
			}
		
		/* Determine wether it's open now */
		return this.getOpen(start, end);
	},
	
    /*
	 * Determine while this store is currently open or not
	 */
	getOpen: function(start, end){
		if(start < 0){
			/* if not open at all */
			return;
		}
		
		start = start.substr(0, start.length-2);
		end = end.substr(0, end.length-2);
		
		var s = start.split(":");
		var e = end.split(":");
	
		/* Create date with arbitrary year and month to compare time */
		var ss=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(s[0]),parseInt(s[1]),parseInt("0"));
		/* Afternoon time, need to revise parse ! */
		var ee=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(e[0]) + 12,parseInt(e[1]),parseInt("0"));
		var current = new Date();
		var cc = new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),current.getHours(), current.getMinutes(),parseInt("0"));
		
		/* Output result */
		if(ss.valueOf() < cc.valueOf() && cc.valueOf() < ee.valueOf()){
			return true;
		}else{
			return false;
		}
	},
});