/*
 * Enrolment Process
 */
var Enrolment = Backbone.Model.extend({
	initialize: function() {
	
		this.PhoneNumCheckState=false;
	    this.PostalCodeCheckState = false;
	    this.LoadPhoneNumComplete = false;
	    this.LoadPostalCodeComplete = false;
	    this.FromEnrolmentTermPage = false;
	},
	// Step 1 - register for MyRexall  
	requestMyRexall: function() {

        // self reference
        var self = this;

        // prepare data
		var data = {
				"APIKey"       : getProxyAPIKey(),
				"attributes"   :{
			                     "displayName"  : $("#enrolment-name").val(),
			                     "email"        : $("#enrolment-email").val(),
			                     "HomeProvince" : $("#enrolment-province").val(),
			                     "password"     : $("#enrolment-password").val(),
			                     "security_question" : $("#enrolment-security-question").val(),
			                     "security_answer"   : $("#enrolment-security-answer").val(),
			                     "PromotionConsent"  : $("input[id='agree-promt']").prop("checked"),
			                     "healthinformation" : $("input[id='agree-health']").prop("checked"),
			                     "PVRegistration"    : false,
			                     "pvRegistrationIncomplete" : true,
			                     "PVRegistrationValidated"  : false,
			                     "RegisterAccountType"		: "basic"
								}
				
		           };
		data = this.getDataString(data);

        // Show spinner
		$("#global-spinner").css("visibility", "visible");
		$.ajax({
            url:  getRexallWebserviceRoot() + "v1/AccountManagement/Entity.svc/Create/",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if (data.Success == 1) {
            	    self.sendWelcomeEmail($("#enrolment-name").val(),$("#enrolment-email").val());
            	    //alert(JSON.stringify(data));
            	    localStorage.setItem("EnrolmentRequestMyRexallID", data.id);
            	    localStorage.setItem("EnrolmentRequestMyRexallUUID", data.uuid);
            	    localStorage.setItem("EnrolmentRequestMyRexallEMAIL", $("#enrolment-email").val());
                    // Login to get access token without retrieving profile
                    janrainLogin.login(
                        {"email":$("#enrolment-email").val(), "password":$("#enrolment-password").val()},
                        function(){
                            // go to complete page
                            var id = "#enrolment-complete-page";
                            $.mobile.changePage(id, {transition: 'slide'});
                        }
                    );

                }else{
                    if(data.Success == 2){
            		    jAlert("This email is already registerd with MyRexall. Please sign in to access your MyRexall account.", "Something Went Wrong",function(r){
	          				if(r){
	          					self.FromEnrolmentTermPage = true;
	          					var id = "#login-page";
	    		       		    $.mobile.changePage(id, {transition: 'slide'});
	          				}
	          			});	
	          	    }else{
	          			var info = data.Message + ".";
	            		if(info.indexOf("..")!=-1){
	            			info = "Error requesting a MyRexall Account:" + data.Message;
	            		}else{
	            			info = "Error requesting a MyRexall Account:" + data.Message + ".";
	            		}
	            		jAlert(info, "Something Went Wrong",function(r){
	            			if(r){
	            				enrolmentFormView.backFromRejectTermandCondition = true;
	    		            	appView.goBack();
	            			}
	            		}); 
	          			//jAlert("Error requesting a MyRexall Account: " + data.error_description + ".", "Something Went Wrong");	
	          	    }
                }
            },
            error: function() {
             	this.requestMyRexallStatus=false;
            	jAlert("Cannot process your MyRexall request, please try again later. If you continue to experience issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong",function(r){
            		if(r){
            			enrolmentFormView.backFromRejectTermandCondition = true;
    	            	appView.goBack();
            		}
            	});  
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		$("#global-spinner").css("visibility", "hidden");
            }
        });

	},
	sendWelcomeEmail: function(DisplayName,Email) {

 		var data = { 
				"DisplayName" : DisplayName,
				"Email"		  : Email,
				"APIKey"	  : getSecureWebserviceAPIKey()
				};

         var current = this;
 		 data = this.getDataString(data);
 		 
		$.ajax({
            url:  getMyRexallWebserviceRoot()+'v3/secure/SecureRexall.svc/MyRexallEnrollRequest',
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if (data.Status == 0) {
                    //jAlert("We have sent an e-mail to your mailbox, please check","Welcome to MyRexall");
                }else{
            	    jAlert("Cannot send Welcome email.","Something Went Wrong");
                }
            },
            error: function() {
            	 jAlert("Cannot send Welcome email.","Something Went Wrong");
            }
        });

	},
	// Step 2 - request Medication Record 
	requestActivationCode: function() {
        var self = this;
		var birthDate = $("#enrolment-request-birthdate").val();
        localStorage.setItem("EnrolmentRequestMyRexallSTORE", $("#enrolment-request-location-result").val());
 		var data = { 
				"APIKey" 	    : getSecureWebserviceAPIKey(),	
				"StoreNumber"	: $("#enrolment-request-location-result").val(),
				"Email"	        : localStorage.getItem("EnrolmentRequestMyRexallEMAIL"),
				"DOBYear"	    : birthDate.substring(6,10),
				"DOBMonth"	    : birthDate.substring(3,5),
				"DOBDay"	    : birthDate.substring(0,2),
				"RxNumber"	    : $("#enrolment-request-rx").val()
				};
 		data = self.getDataString(data);

 		/* Show spinner */
		$("#global-spinner").css("visibility", "visible");
		$.ajax({
            url:  getMyRexallWebserviceRoot()+"v3/secure/SecureRexall.svc/ProfileCreateRequest",
            type: 'GET',
            data: data,
            dataType: 'jsonp',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                //alert(JSON.stringify(data));
                if (data.results.status.code == 0) {
                    self.updateJainrain(); // Tell Jainrain that this patient has requested Activation Code
                    /* go to wait page*/
                    var id = "#enrolment-wait-page";
                    $.mobile.changePage(id, {transition: 'slide'});
                }else{
            		var info = data.results.status.message + ".";
            		if(info.indexOf("..")!=-1){
            			info = "Error requesting Activation Code: " + data.results.status.message;
            		}else{
            			info = "Error requesting Activation Code: " + data.results.status.message + ".";
            		}
            		jAlert(info, "Something Went Wrong"); 
            		
            		//alert("Error requesting Activation Code: " + JSON.stringify(data));
            		//jAlert("Error requesting Activation Code: " + data.results.status.message,"Something Went Wrong"); 
            	}
            },
            error: function() {
            	jAlert("Cannot process your request for an Activation Code, please try again later. If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		$("#global-spinner").css("visibility", "hidden");
            }
        });

	},

    /*
        Input:
        opt_data: (optional) if provide, use as ajax data
     */
	updateJainrain: function(opt_data) {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function() {
            self.updateJainrain(); // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;    // return if token is refreshed and callback with this function
        }

        // prepare data
        var data;
        if(opt_data){
            data = opt_data;
        }else{
            data = {
                "APIKey" 	    : getProxyAPIKey(),
                "AccessToken"   : localStorage.getItem("JanRainAccessToken"),
                "attributes"	: {
                    "homestorenumber"		    : $("#enrolment-request-location-result").val(),
                    "PVRegistration"		    : true,
                    "pvRegistrationIncomplete"  : false,
                    "PVRegistrationValidated"   : false,
                    "RegisterAccountType"	    : "pharmacy"
                }

            };
        }
 		data = this.getDataString(data);

          /* Show spinner */
  		$("#global-spinner").css("visibility", "visible");		
		$.ajax({
            url:  getRexallWebserviceRoot() + "v1/AccountManagement/Entity.svc/Update/",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if (data.Success === 1) {
            	    //alert("Updated Jainrain successfully: " + JSON.stringify(data));
                    self.updateLocalJanrain();
            	}else{
            		var info = data.Message + ".";
            		if(info.indexOf("..")!=-1){
            			info = "Error updating Jainrain:" + data.Message;
            		}else{
            			info = "Error updating Jainrain:" + data.Message + ".";
            		}
            		jAlert(info, "Something Went Wrong"); 
            	}
             },
            error: function() {
                jAlert("Cannot update your MyRexall Profile, please try again later. If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong");
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		$("#global-spinner").css("visibility", "hidden");
            }
        });

	},

    updateLocalJanrain: function()
    {
        var SignIndata = localStorage.getItem("JanRainLogin");
        if (SignIndata)
        {
            SignIndata = JSON.parse(SignIndata);
            SignIndata.homestorenumber = $("#enrolment-request-location-result").val();
            SignIndata.PVRegistration = true;
            SignIndata.pvRegistrationIncomplete = false;
            SignIndata.PVRegistrationValidated = false;
            localStorage.setItem("JanRainLogin", JSON.stringify(SignIndata ));
            janrainLogin.setHomeStoreAddress();
        }
    },

    /*
        Step 3 - Confirm activation code

        Input:
        opt_data: (optional) if provide, use as ajax data
     */
	confirmActivationCode: function(opt_data) {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.confirmActivationCode();   // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;        // return if token is refreshed and callback with this function
        }

        // prepare data
        var data;
        if(opt_data){
            data = opt_data;
        }else{
            var birthDate = $("#enrolment-confirm-birthdate").val();
            var pin = $("#enrolment-confirm-code").val();
            if(pin.length>4){
                pin = pin.substring(pin.length-4,pin.length);
            }

            var data = {
                "APIKey" 	: 	getSecureWebserviceAPIKey(),
                "AccessToken"   :   localStorage.getItem("JanRainAccessToken"),
                "StoreNumber"	:	localStorage.getItem("EnrolmentRequestMyRexallSTORE"),
                //"ProfileID" :       localStorage.getItem("EnrolmentRequestMyRexallUUID"),
                "PIN"		:		pin,
                "DOBYear"	:		birthDate.substring(6,10),
                "DOBMonth"	:		birthDate.substring(3,5),
                "DOBDay"	:		birthDate.substring(0,2),
                "RxNumber"	:		$("#enrolment-confirm-rx").val()
            };
        }

        data = this.getDataString(data);

 	     /* Show spinner */
		$("#global-spinner").css("visibility", "visible");		
		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/ProfileConfirmationCheck",
            type: 'GET',
            data: data,
            dataType: 'jsonp',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if(data.results.status.code == 0) {
                    self.setPVProfileID(data.results.result.profile.patientId);
	          		var id = "#enrolment-verify-page";
	          		$.mobile.changePage(id, {transition: 'slide'});	
                }else{
                    jAlert("Error confirming Activation Code: " + data.results.status.message + ".", "Something Went Wrong");
            	}
            },
            error: function() {
            	jAlert("Cannot confirm your Activation Code, please try again later. If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		$("#global-spinner").css("visibility", "hidden");
            }
        });
	},
                                      
    setPVProfileID: function(pvProfileID)
    {
        var SignIndata = localStorage.getItem("JanRainLogin");
        if (SignIndata)
        {
            SignIndata = JSON.parse(SignIndata);
            SignIndata.PVprofileID = pvProfileID;
            localStorage.setItem("JanRainLogin", JSON.stringify(SignIndata ));
        }
    },
                                      
	before : function(){
		$("#enrolment-verify-page").find(".rexall-page-header").html(
				"<span style='font-size:0.8em'>Loading Phone Number and Postal Code </span> " +
		   		"<div id='circleG'>" +
		   		"<div id='circleG_1' class='circleG'></div>" +
		   		"<div id='circleG_2' class='circleG'></div>" +
		   		"<div id='circleG_3' class='circleG'></div>" +
		   		"</div>"
			);
	},
	after : function(){
		$("#enrolment-verify-page").find(".rexall-page-header").html(
    			"<p>CONFIRM YOUR MEDICATION RECORD</p>" +
    			"<div class='rexall-page-header-info'></div>");
	},
    /* popule phone number ----begin----*/
	getPhoneDropdown: function() {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.getPhoneDropdown();   // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;        // return if token is refreshed and callback with this function
        }

        // prepare data
        var data = {
		    "APIKey" 	: 	getSecureWebserviceAPIKey(),
            "AccessToken"   : localStorage.getItem("JanRainAccessToken")
        };
 		data = self.getDataString(data);

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/PhoneValidationDisplay",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            //async: false,
            crossDomain: true,
            beforeSend: function(XMLHttpRequest){
				self.before();
				var result = "<option id='wait-phone-num' value='' selected>Loading phone number, wait...</option>";
		    	$("#enrolment-verify-question1").prepend(result);
			},
            success: function(data) {
              if (data.results.status.code == 0) {
            	  $.each(data.results.result, function(index, value) {
            		 var result = null;
            		 if(value){
            				 result = "<option class='phone-num' value='" + value + "' >"+value+"</option>";	
            			}
      				if(result){
      					$("#enrolment-verify-question1").append(result);
      				}
      			});
              }else{
            	  jAlert("Error obtaining the Phone Dropdown: " + data.results.status.message + ".", "Something Went Wrong");  
              }  
            },
            error: function() {
            	jAlert("Cannot obtain the Phone Dropdown, please try again later. If you are still experiencing issues, Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		//$("#global-spinner").css("visibility", "hidden");
            	$("#enrolment-verify-question1 option[id='wait-phone-num']").remove();
            	
            	self.LoadPhoneNumComplete = true;
            	if(self.LoadPostalCodeComplete){
            		self.after();
            		self.LoadPhoneNumComplete = false;
            		self.LoadPostalCodeComplete = false;
            	}
            }
        });
	},

	validatePhone: function() {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.validatePhone();   // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;        // return if token is refreshed and callback with this function
        }

        // prepare data
 		var data = {
		    "APIKey" 	: 	getSecureWebserviceAPIKey(),
            "AccessToken"   : localStorage.getItem("JanRainAccessToken"),
		    "PhoneNumber"	:	$("#enrolment-verify-question1").val()
		};
 		data = self.getDataString(data);

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/PhoneValidationCheck",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if (data.results.status.code == 0) {
            	   self.setPhoneNumCheckState(true);
                }else{
            	    self.setPhoneNumCheckState(false);
            	    jAlert("Error validating the Phone Number: " + data.results.status.message + ".", "Something Went Wrong");
                }
            },
            error: function() {
            	 self.setPhoneNumCheckState(false);
                	jAlert("Cannot validate the Phone Number, please try again later. If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            	
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
//          		$("#global-spinner").css("visibility", "hidden");
            }
        });
	},

	/* popule postal code ----begin----*/
	getPostalCodeDropdown: function() {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.getPostalCodeDropdown();   // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;        // return if token is refreshed and callback with this function
        }

        // prepare data
 		var data = { 
		    "APIKey" 	    : 	getSecureWebserviceAPIKey(),
            "AccessToken"   :   localStorage.getItem("JanRainAccessToken")
		};
	    data = self.getDataString(data);

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/PostalCodeValidationDisplay",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
          //  async: false,
            crossDomain: true,
            beforeSend: function(XMLHttpRequest){
				self.before();
				var result = "<option id='wait-postal-code' value='' selected>Loading postal code, wait...</option>";
		    	$("#enrolment-verify-question2").prepend(result);
			},
            success: function(data) {
              if (data.results.status.code == 0) {
            	  $.each(data.results.result, function(index, value) {
             		 var result = null;
             		 if(value){
             			  result = "<option class='postal-code' value='" + value + "' >"+value+"</option>";	
             			}
       				if(result){
       					$("#enrolment-verify-question2").append(result);
       				}
       			 });
               }else{
            	   jAlert("Error obtaining the Postal Code: " + data.results.status.message + ".", "Something Went Wrong");  
            	}
            },
            error: function() {
            	jAlert("Cannot obtain Postal Code, please try again later.  If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
//            	/* Hide spinner */
          	//	$("#global-spinner").css("visibility", "hidden");
            	$("#enrolment-verify-question2 option[id='wait-postal-code']").remove();
            	
            	self.LoadPostalCodeComplete= true;
            	if(self.LoadPhoneNumComplete){
            		self.after();
            		self.LoadPhoneNumComplete = false;
            		self.LoadPostalCodeComplete = false;
            	}
            }
        });
	},

	validatePostalCode: function() {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.validatePostalCode();   // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;        // return if token is refreshed and callback with this function
        }

        // prepare data
 		var data = {
		    "APIKey" 	: 	getSecureWebserviceAPIKey(),
            "AccessToken"   : localStorage.getItem("JanRainAccessToken"),
		    "PostalCode"	:	$("#enrolment-verify-question2").val()
		};
 		data = self.getDataString(data);     

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/PostalCodeValidationCheck",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
              if (data.results.status.code == 0) {
            	   self.setPostalCodeCheckState(true);
            	 }
            	else
            	  {
            		self.setPostalCodeCheckState(false);
            		 jAlert("Error validating the Postal Code: " + data.results.status.message + ".", "Something Went Wrong");  
            	 }  
            },
            error: function() {
            	self.setPostalCodeCheckState(false);
            	jAlert("Cannot validate Postal Code, please try again later.  If you are still experiencing issues, contact our Customer Service at 1-877-378-4100.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
//          		$("#global-spinner").css("visibility", "hidden");
            }
        });
	},
	// Step 4 - post verification 
	postVerification: function() {

        // self reference
        var self = this;

        // Check if refresh token is required
        if(janrainLogin.refreshToken(function(){
            self.postVerification(); // Must wrap this recursive call in a function, otherwise the value of self will change
        })){
            return true;    // return if token is refreshed and callback with this function
        }

        // prepare data
        var data = {
            "APIKey" 	    : getProxyAPIKey(),
            "AccessToken"   : localStorage.getItem("JanRainAccessToken"),
            "attributes"    : {
                                "PVRegistration"  : true,
                                "pvRegistrationIncomplete"  : false,
                                "PVRegistrationValidated"   : true
                                }
        };
        data = self.getDataString(data);

		 /* Show spinner */
		$("#global-spinner").css("visibility", "visible");		
		$.ajax({
            url: getRexallWebserviceRoot() + "v1/AccountManagement/Entity.svc/Update/",
            type: 'GET',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            crossDomain: true,
            success: function(data) {
                if (data.Success === 1) {
                    self.setPVRegistrationValidated(true);
               
				    var info = "<p>You have successfully completed all the steps to confirm your Medication Record.</p>";
				    jAlert(info,"Congratulations",function(r){
					    if(r){
						    self.enrolmentAlltoPage();
					    }
				    });
				    $("#popup_ok").css('width','72%');
				    $("#popup_title").addClass("orange-color-title");
				    $("#popup_ok").html("View Medication Record");
                }else{
                    var info = data.Message + ".";
                    if (info.indexOf("..") != -1) {
                        info = "Error updating Jainrain:" + data.Message;
                    } else {
                        info = "Error updating Jainrain:" + data.Message + ".";
                    }
                    jAlert(info, "Enrolment Verification");

                }
            },
            error: function() {
            	jAlert("Cannot update your MyRexall Profile, please try again later.", "Enrolment Verification"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	/* Hide spinner */
          		$("#global-spinner").css("visibility", "hidden");
            }
        });

	},
                                      
    setPVRegistrationValidated: function(state) {
        var SignIndata = localStorage.getItem("JanRainLogin");
        if (SignIndata) {
            SignIndata = JSON.parse(SignIndata);
            SignIndata.PVRegistrationValidated = state;
            localStorage.setItem("JanRainLogin", JSON.stringify(SignIndata ));
        }
    },
                                      
	getDataString:function(parameter){
		var result="";
		$.each(parameter, function (key, value) {
			if(key=="attributes")
			{
				result += (key + "=" + JSON.stringify(value) + "&");
			}else{
				result += (key + "=" + value + "&");
			}
		});
		return result.substring(0, result.length-1);
	},
	
	setPhoneNumCheckState: function(state){
		
		this.PhoneNumCheckState = state;
	},
	setPostalCodeCheckState: function(state){
		
		this.PostalCodeCheckState = state;
	},
	getTodayString: function(){
		var today = new Date();
		var vYear = today.getFullYear();
        var vMon = today.getMonth() + 1;
        var vDay = today.getDate();
        var h = today.getHours(); 
        var m = today.getMinutes(); 
        var se = today.getSeconds(); 
		return  vYear+'-'+vMon+'-'+vDay+' '+h+':'+m+':'+se;
	},
	enrolmentAlltoPage : function(){
		if(window.localStorage.getItem("JanRainLogin")) {
            if (!profile.hasRecord()) {
                // force to populate profile
                profile.fetchData();
            }
                                      
			$("#header-slider-back").removeClass("header-hide");
			this.fromEnrolment = true;
			var id = "#record-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#record-page-header").html("<p>REFILL USING MyRexall ACCOUNT</p><div class='rexall-page-header-info'></div>");
			$("#MedicalRecord-page-info span").html("About Refill Using MyRexall Account");
			/* Change appView currentPage */
			appView.currentPage = id;
		}else{
			this.fromEnrolment = true;
			var id = "#login-page";
			$.mobile.changePage(id, {transition: 'slide'});
			/* Insert selected store to refill view */
			appView.currentPage = id;
		}
	},
});