var Refiller = Backbone.Model.extend({
	
	initialize: function (options) {
	    this.storeNum = options.storeNum;
	    this.prescriptionNum = options.prescriptionNum;
	    this.year = options.year;
	    this.month = options.month;
	    this.day = options.day;
	    this.drugName = options.drugName;
        this.method = options.method;
	},
	
	refill : function () {

		/* Construct web service options */
		var webServiceOption = {
				"webServiceURL"	: getRexallWebserviceRoot() + "/v3/standard/Rexall.svc/Refill",
				"parameter"		: {
									"APIKey" 		: getWebserviceAPIKey(),	
									"Storenumber"	: this.storeNum,// 9981, //this.storeNum,
									"Rxnumber"		: this.prescriptionNum,  //9736220, //this.prescriptionNum,
									"Year"			: this.year,//1971, // this.year,
									"Month"			: this.month,//11, //this.month,
									"Day"			: this.day,//1, //this.day,
                                    "Method"        : this.method,
                                    "Channel"		: 'MOB',
									"Language"		: 'ENG'
								  },
				"callBack"		: this.refillCallBack,		/* Call back function when webservice respond */
				"caller"		: this							/* refer back to the collection itself */
			};

		/* Create new WebService instance */
		var webService = new WebService(webServiceOption);
		webService.callWebService();
	},
	
	refillCallBack: function (data, self) {
		var rxNum = self.prescriptionNum;
		var drugName = self.drugName;
		var info = "";
		if(drugName){
			info = "<span class='refill-callBack-info-left'>RX Number: <span>&#9;"+rxNum+"</span></span>" + 
					"<span class ='refill-callBack-info-left'>Drug Name: <span>&#9;"+drugName+"</span></span><BR/>";
		}else{
			//info = "<BR/><span class ='refill-callBack-info-left' >Drug Name: <span class='refill-callBack-info-right' >"+''+"</span></span><BR/><BR/> <span style='float:left;color:#00b0a9;font-weight:bold;'>RX Number:&nbsp;&nbsp;<span style='color:#0F0F0F;font-weight:bold;'>"+rxNum+"</span></span><BR/><BR/>";
			info = "<span class='refill-callBack-info-left'>RX Number: <span>&#9;"+rxNum+"</span></span><BR/>";
		}
			
		
		/* Show response message */
		if(data.statusNumber==0 || data.statusNumber==12){
			//jAlert(info,"<center>Refill Successfully Completed</center>");
			jAlert(info,"Refill Successfully Completed");
		}else{
			info = "<span class ='refill-callBack-info-regular'>" + data.userDescription + "</span><BR/><BR/><BR/>"+info;
			jAlert(info,"Prescription Refill");
		    if (data.statusNumber==1) // Prescription # cannot be found
				{$("label[for='refill-prescription-number']").addClass("rexall-warning-label");}
	   }
	},
	
});
