﻿var ResetPassword = Backbone.Model.extend({
    initialize : function () {
    },

    /* Validate user's input for login */
    validateInput : function (loginInput) {
        /* validate email and password */
        var email = loginInput.email;
        if (!email) {
        	$("label[for='reset-pass-label']").addClass("rexall-warning-label");
            jAlert("Correct the information highlighted in red.", "Please Try Again");
            return false;
        }else{
        	$("label[for='reset-pass-label']").removeClass("rexall-warning-label");
        }
        /* Set valid check for login function */
        return true;
    },

    /* Login the user */

    getQuestionbyEmail: function (loginInput) {

        // Validate the login input
        if (!this.validateInput(loginInput)) {
            return false;
        }

        // Show spinner
        $("#resetpass-page-spinner").css("visibility", "visible");

        // Self reference
        var self = this;

        // Login parameters
        var data = {
            "APIKey"    : getProxyAPIKey(),
            "AccessToken"  : loginInput.email
        };

        // get Authorization code from JanRain
        $.ajax({
            url: getRexallWebserviceRoot() + "v1/AccountManagement/Entity.svc/Find/",
            type: 'GET',
            data: data,
            crossDomain: true,
            dataType: 'json',
            success: function(res) {
                if(res.Success === 1) {
                    // save response to LS
                    var result = JSON.parse(res.JainRainRecord).result;
                    localStorage.setItem("JanRainLoginEmailOnly", JSON.stringify(result));
                    // show question
                    resetPasswordView.ShowQuestion(result.security_question);
                }else {     // record not found
                    $("label[for='reset-pass-label']").addClass("rexall-warning-label");
                    jAlert("This email is not registered with MyRexall.", "Please Try Again");
                }
            },
            error: function(XHR, textStatus, error) {
                // show error message
                jAlert("Unable to reset password, please check your network connection and try again.", "Something Went Wrong");
                return false;
            },
            complete: function(){
                // hide spinner
                $("#resetpass-page-spinner").css("visibility", "hidden");
            }
        });
    },



    validateAnswer: function (answerText) {
        // security answer is not logger returned by API, alway return true to proceed the reset
        return true;

//        var LoginEmailOnly = localStorage.getItem("JanRainLoginEmailOnly");
//        if (LoginEmailOnly){
//            var security_answer = JSON.parse(LoginEmailOnly).security_answer;
//            if (answerText == security_answer)
//                return true;
//        }
//        return false;
    },

    /*
        Send reset password request

        Input:
        answerText - the answer provided by user
     */
    sendPasswordEmail: function (answerText) {

        // prepare data
        var data = {
            "APIKey"        : getSecureWebserviceAPIKey(),
            "Email"         : JSON.parse(localStorage.getItem("JanRainLoginEmailOnly")).email,
            "SecurityQuestion": JSON.parse(localStorage.getItem("JanRainLoginEmailOnly")).security_question,
            "SecurityAnswer": answerText
        };

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/MyRexallPasswordReset/",
            type: 'get',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            success: function(data) {
                if (data.Status == 0){
                    jAlert("We have emailed you your new password. You may change your password in the profile section after logging in. <br><br>" +
                    "If you are experiencing any issues, please contact " +
                    "Rexall Customer Service at 1-877-378-4100 or " +
                    "click here to <span class='dark-teal' id='resetpass-page-email-us'>email</span> us now.  ", "Password successfully changed");

                    if(appView)
            		appView.goBack();
                }else{
                    $("#resetpass-question-prompt").addClass("rexall-warning-label");
                    $.alerts.alert("The answer does not match with our record.", "Please Try Again");
                }
            },
            error: function() {
                jAlert("Cannot process your request, please try again later.", "Password Reset");
            }
        });
    }

	



	

});