/*
 * Webservice model 
 * Can be use to make webservice call
 */
var WebService = Backbone.Model.extend({
	
	initialize : function ( ) {
		
	},
	
	/* Construct URL for webservice call */
	webServiceRequestURL : function (parameter) {
		
		/* Construct request url */
		var result = "";
		result = result + this.get("webServiceURL") + "?" ; 
		
		/* Append parameters */
		$.each(parameter, function (key, value) {
			if("StoreServices.ServiceName"===key && (value instanceof Array))
			{
              for(var i=0; i<value.length;i++){
            	  result += key + "=" + value[i] + "&";
                 }
			}else{
				result += key + "=" + value + "&";
			}
		});

		return result;
	},
	
	/* This function send web service request */
	callWebService : function (before, after) { 
		
		/* Check internet connection */
	    if(navigator.connection.type == Connection.NONE){
	    	 jAlert("You have no connection to the internet. Check your network settings and try again.", "Network Connection Error");
	    	return false;
	    }
		
		/* run Before function */
		if(before){
			before();
		}
		
		var webServiceURL = this.get("webServiceURL");
		
		/* Dynamic script insertion */
		var script = document.createElement('script');
		script.setAttribute('src', webServiceURL);
		document.getElementsByTagName('head')[0].appendChild(script); // Load the script

		/* Retrieve input data */
		var requestURL = this.webServiceRequestURL(this.get("parameter"));
		
		/* Callback function and caller */
		var callBack = this.get("callBack");
		var caller = this.get("caller");
		
		/* Show spinner */
		$("#global-spinner").css("visibility", "visible");
		$("#locator-search-input").attr("readOnly",true);
		/* Send request to web service */
		jQuery.getJSON(requestURL, function(data){
			/* Call functions */
			callBack(data, caller);
		}).fail(function(){
			jAlert("An error occurs when trying to retrieve data. Please try again.", "Something Went Wrong");
		}).always(function() {
			/* Hide spinner */
			$("#global-spinner").css("visibility", "hidden");
			$("#locator-search-input").attr("readOnly",false);
			/* Run after function */
			if(after){
				after();
			}
		});
	}
	
});