/*
 * View class of home page
 * 
 */

var AppView = Backbone.View.extend({
	
	id: "menu-page",

	el: $("body"),
	
	events: {
		"tap .menu-option"				:	"goToPage",
		"tap #login"					: 	"goToPage",
		"tap #see-closest"				: 	"openClosestStore",
		"tap #search-closest"			: 	"searchClosest",
		"tap #clinic-search-closest"	: 	"clinicSearchClosest",
		"tap #map-view"					: 	"showMapView",
		"tap #list-view"				: 	"showListView",
		"tap #hide-locatore-options" 	: 	"closeClosestStore",
		"tap #show-all-stores"			:	"showAllStores",
		"tap #show-direction"			: 	"showDirection",
		"tap .detail-address-info"		:	"showDirection",
		"tap #clinic-show-direction"	: 	"showClinicDirection",
		"tap #set-default-store"		:	"setDefaultStore",
		"tap #detail-address-make-default" :"setDefaultStore",
		"tap #header-address"			:	"showCurrentStore",
		"tap #current-store"			: 	"showCurrentStore",
		"tap #flyer"					: 	"goToPage",
        "tap #flyer-from-store"			: 	"showFlyerFromStore",
        "tap #logo"		                : 	"goHomePage",
		"tap #header-slider-back"		: 	"goBack",
		//"swiperight .rexall-content"  	:	"goBack",
		"tap .menu-label"				:	"goToPage",
		"tap #logout"					:	"logoutJR",
		"tap #search-filter"            :   "searchFilter",
		"tap #refill-by-myRexall"       :   "refillByMAOrSL",
        "tap #record"                   :   "medicationRecord",
		"tap #refill-from-storeLocator" :   "showOnlineRefill",
		"tap #refill-prescription"      :   "refillPrescription",
		"tap #locator-search-hide"      :   "searchHide",
		"tap #clinic-locator-search-hide"      :   "clinicSearchHide",
		"tap .locator-menu ul li"       :   "changeColor",
		"tap #termOfUse"                :   "termOfUse",
		"tap #privacypolicy"            :   "privacypolicy",
	//	"tap #feedback"                 :   "feedback",
		"tap #my-store"            		:   "showCurrentStoreDetail",
		"tap .rexall-page-header-info"	: 	"showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
		"tap #detail-view"              :   "showDetailView",
		"tap #pdf-read-close"           :   "closePdf",
		"tap #login-other"           	:   "showRegister",
		"tap .rexall-check-box"			: 	"rexallCheckBoxPreventDefault",
		"tap #resetpass-page-email-us"	:	"resetPageEmailUs",
        "tap #enrolment-request-cancel"     : "goHomePage",
        "tap #enrolment-complete-notnow"     : "enrolmentCompleteNotnow",
        "tap #enrolment-confirm-cancel"     : "goHomePage",
         "tap #clinic-detail-view"			: 	"showClinicDetailView",
         "tap #flyer-page-info-button"      :   "flyerShowInfo",
         "tap #flyer-page-info-close"        :   "flyercloseInfo",
	},
	
	/* Go to contact us page when click on the link in reset password light box */
	resetPageEmailUs: function() {
		/* Close light box */
		$.alerts._hide();
		/* Go to contact us page */
		var id = "#feedback-page";
		$.mobile.changePage(id, {transition: 'slide'});
	},

    goHomePage: function() {
		/* Close light box */
		$.alerts._hide();
        console.log("gohomepage location.hash=" +location.hash);
        //hide store locator header
      
	    $("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");
        
       
        //go home page
        var id = "#menu-page";
		$.mobile.changePage(id, {transition: 'slide'});


        
        /*reset store locator*/
         console.log("gohomepage location.hash=" +location.hash);
		

	},
	
	termOfUse:function(){
		var id ="#termOfUse-page";
		$.mobile.changePage(id, {transition: 'slide'});
		$("#settings-page [href='#']").removeClass("ui-btn-active");
	},
	privacypolicy:function(){
		var id ="#privacypolicy-page";
		$.mobile.changePage(id, {transition: 'slide'});
		$("#settings-page [href='#']").removeClass("ui-btn-active");
	},

//	feedback:function(){
//       
//        if(!localStorage.getItem("JanRainLogin"))
//        {
//           $("#contact-us-nologin-fields").show();
//        }
//		else
//        {
//            $("#contact-us-nologin-fields").hide();
//        }
//	},
	
	/* A work around to prevent .rexall-check-box class toggle itself when tapping */
	rexallCheckBoxPreventDefault:function(e) {
		//e.preventDefault();		
		if($(e.target).prop("tagName").toUpperCase() == "SPAN"){
			/* Tap on span */
			var checkBox = $(e.target).closest('.rexall-check-box').find("input");
			checkBox.prop("checked", !checkBox.prop("checked"));
		}
	},
	
    showFlyerFromStore:function(){
        $("#E-Flyer-div").removeClass("content-page-flyer").addClass("content-page-flyer-from-store");
        
        setTimeout(function(){
        	$("#lower-header").removeClass("lower-header-close").addClass("lower-header-open");
        },240);

        
         var id = "#flyer-page";
         $.mobile.changePage(id, {transition: 'slide'});	
    },


    showCurrentStoreDetail:function(){

/* hide the filter layer */

        $("#store-service-filter").slideUp("normal");

        if(localStorage.getItem("JanRainLogin")){
         //jAlert("You currently do not have a Preferred Store","My Store");
            var homeStore = localStorage.getItem("RexallProfileHomeStore");
             if(homeStore){
            	 //after the user sign out.. still use the preferred store he set before
            	// localStorage.setItem("CurrentStore",homeStore);
            	 
                /* go to detail page */
                var id = "#detail-page";
                $.mobile.changePage(id, {transition: 'slide'});
                currentStoreView.render();      
                storeDetailPage.setModel(currentStoreView.model);
                //storeDetailPage.setModel(homeStore);
                storeDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */
                               /* Create Detail page */
                $("#locator-menu ul li[class='locator-detail']").css("visibility","visible");

                $("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
                
//    		    $("#detail-address-make-default").css({"background-color": "#ED8C22"});
//    			$("#detail-address-make-default p").css({"color": "white"});

              }else{
            	  currentStoreView.render();	/* Render to get localstorage */
                  if(currentStoreView.model){
                     /* go to detail page */
                     var id = "#detail-page";
                     $.mobile.changePage(id, {transition: 'slide'});
                     storeDetailPage.setModel(currentStoreView.model);
                     storeDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */
                     /* Create Detail page */
                     $("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
                     $("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
                     
//      			    $("#detail-address-make-default").css({"background-color": "#ED8C22"});
//        			$("#detail-address-make-default p").css({"color": "white"});
                  }else{
                       jAlert("You do not have a Preferred Store","My Store");

                  }
              }
        }else{
        		//current = localStorage.getItem("CurrentStore");
        		currentStoreView.render();	/* Render to get localstorage */
                if(currentStoreView.model){
                   /* go to detail page */
                   var id = "#detail-page";
                   $.mobile.changePage(id, {transition: 'slide'});
                   storeDetailPage.setModel(currentStoreView.model);
                   storeDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */
                   /* Create Detail page */
                   $("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
                   $("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
                   }else{
                     jAlert("You do not have a Preferred Store","My Store");

                 }
       }
    },


	
	
	initialize: function () { 

		var self = this;
		self.states = 0;
        this.stepsToGoback = 0;
		/**
		 * Need to be migrate to locator view 
		 * MainRouter will also be affected
		 */
		$(document).on( "pagebeforechange", function( e, data ) {
			//alert("location.hash:"+location.hash + "; data.toPage:"+data.toPage);
			/* Close the store locator menu whenever exit the following pages */
			if(location.hash !== "#locator-page" 
				&& location.hash !== "#locator-map-page" 
				&& location.hash !== "#direction-page"
				&& location.hash !== "#detail-page"
			){
				self.closeClosestStore();
			}
			/* Tell ContactUs that we are coming from Validation */
			if(location.hash == "#enrolment-verify-page"  && data.toPage == "file:///android_asset/www/index.html#feedback-page")
			{
			contactUsView.setFromValidateLogin(true);
			}
			/* Set Up Refill to be by MyRexall if user decides to sign in */
			if(location.hash == "#detail-page"  && data.toPage == "#refill-page")
			{
			loginView.setfromRefillbyNumberFromStoreLocator(true);
			}
			 else{
			if(
			(
			(typeof data.toPage == "string" ? (data.toPage == "#menu-page")  : false) ||  // Home button
			(typeof data.toPage == "string" ? (data.toPage == "file:///android_asset/www/index.html#detail-page")  : false) /*|| // back button
			(location.hash == "#login-page") && (typeof data.toPage == "string" ? (data.toPage == "#record-page")  : false) */)
			 && loginView.fromRefillbyNumberFromStoreLocator)
			{
			loginView.setfromRefillbyNumberFromStoreLocator(false);
			}}
		});
		
		/* Google Analytics */
		if(typeof analyticsAgent != 'undefined'){
			$(document).on( "pageshow", function( e, data ) {	
				analyticsAgent.gaSendPage(location.hash);	// Send active pageview
			});
		}

//		/* Workaround for google map does show correctly if create before page load */
//		$(document).on( "pagechange", function( e, data ) { 
//			
//			if(location.hash === "#locator-page"){
//				alert("page change");
//				/* Show map */
//				storeListMapView.showMap();	
//			}
//		});
	},	
	
	/* Go back */
    goBack: function (steps) {
		if(location.hash=="#login-page"&&enrolment.FromEnrolmentTermPage&&
			               router.previousPage=="#enrolment-term-page"){
			enrolment.FromEnrolmentTermPage = false;
			var id = "";
			$.mobile.changePage(id, {transition: 'slide'});
			return;
		}else{
			enrolment.FromEnrolmentTermPage = false;
		}
        
        //location.hash == "#enrolment-verify-page"||location.hash=="#enrolment-complete-page")
        //Disable back button on All enrolment pages		
		/* if((/enrolment-[A-Za-z0-9._%+-]+page/.test(location.hash)||
				location.hash=="#enrolment-page")&&
				location.hash!="#enrolment-form-page") { */
				
		if(/enrolment-[A-Za-z0-9._%+-]+page/.test(location.hash)&&location.hash!="#enrolment-form-page") {
        	return;
        }else if(location.hash!=""&&location.hash){
        	$("#header-slider-back").removeClass("header-hide");
        }

		 if(location.hash=="#record-page"&&enrolment.fromEnrolment){
	        	enrolment.fromEnrolment = false;
	        	this.goHomePage();
	        	return;
	      } 
		 if(location.hash=="#login-page"&&enrolment.fromEnrolment){
	        	var id = "#record-page";
				$.mobile.changePage(id, {transition: 'slide'});
				$("#record-page-header").html("<p>REFILL USING MyRexall ACCOUNT</p><div class='rexall-page-header-info'></div>");
				$("#MedicalRecord-page-info span").html("About Refill Using MyRexall Account");
	       return;
		 }
        if (location.hash === "" || !location.hash) {
            var self = this;
            /* Sign out check */
		
            //navigator.app.exitApp();
		
            if (!window.localStorage.getItem("JanRainLogin")) {
                jConfirm("Are you sure you want to exit?", "Exit", function(r) {
                    if (r) {				
                        navigator.app.exitApp();
                    }
                });
                $("#popup_ok").html("Yes");
                $("#popup_cancel").html("No");    
            }
		
            else {
                jConfirm("Are you sure you want to sign out and exit?", "Exit", function(r) {
                    if (r) {				
                        // Logout JanrainLogin model 
                        loginView.model.logout();
                        //jAlert("You have signed out.","MyRexall");
                        navigator.app.exitApp();
                    }
                });
                $("#popup_ok").html("Yes");
                $("#popup_cancel").html("No");
            }
            return;
        }
		
        if (location.hash==="#pharmacy-page") {
            this.states = 0;
        }
        /* hide the filter layer */
        //$("#store-service-filter").slideUp("normal");
        clinicFilterView.filterHide();
        storeFilterView.filterHide();
        /* Go back HEADER */
        var headerId = location.hash.split("-")[0];
		
        /* Hide Page header */
        //		if(headerId =="#pharmacy"||headerId =="#refill"
        //		 ||headerId =="#locator"||headerId =="#clinic"){
        //			$("#header-slider-back").removeClass("in").addClass("header-hide");
        //		}else{
        //			$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
        //		}

        console.log("Before Goback:" + location.href + " Location hash:" + location.hash + " stepsToGoback:" + this.stepsToGoback);
        /* check goBack from enrolment*/
        if (this.checkGoBackFromEnrolment()) {
            steps = 2;
        }
        if(loginView.goToSettingsPage&&location.hash=="#settings-page"){
        	loginView.goToSettingsPage = false;
        	var id = "";
			$.mobile.changePage(id, {transition: 'slide'});
			return;
        }
        if(location.hash==="#licensePdf-page"){
        	steps = 2;
        }
        /*go back from detail page*/
        if(location.hash=="#detail-page"&&
        		!storeDetailPage.fromMapPageState&&
        		$("#locator-page").attr("class").indexOf("locator-page-map-view") != -1){
        	
        	$("#locator-page").removeClass("locator-page-map-view").addClass("locator-page-list-view");
        	$("#map-view").removeClass("locator-menu-hide");
        	$("#list-view").addClass("locator-menu-hide");
        }
        if(location.hash=="#clinic-detail-page"&&
        		!clinicStoreDetailPage.fromMapPageState&&
        		$("#clinic-page").attr("class").indexOf("clinic-page-map-view") != -1){
        	
        	$("#clinic-page").removeClass("clinic-page-map-view").addClass("clinic-page-list-view");
        	$("#clinic-map-view").removeClass("locator-menu-hide");
        	$("#clinic-list-view").addClass("locator-menu-hide");
        }       
        /* Go back PAGE */
        if (steps >= 2) {
            var s = parseInt(steps);
            window.history.go(-s);
        }
        else if ((location.hash == "#record-page" || location.hash == "#transfer-page" || location.hash == "#refill-page") && this.stepsToGoback > 0) {
            window.history.go(-this.stepsToGoback);
            this.stepsToGoback = 0;
        }
        else {
            window.history.go(-1);
            console.log("window.history.go(-1);");
        }
	    
        console.log("After Goback:" + location.href + " Location hash:" + location.hash);
        /* Hide Page header */
        //		if(headerId=="#pharmacy"||headerId=="#refill"
        //		   ||headerId==="#locator"||headerId=="#clinic"
        //		   ||headerId=="#flyer"||headerId=="#rewards"
        //		   ||headerId=="#shopping"||headerId=="#settings")
        //		{
        //			$(".header-slider-item").removeClass("slidefade in").addClass("header-hide");
        //			$(".rexall-content").css("top","4em");
        //		}else
        //		 {
        //			headerId += "-header";
        //			$(headerId).removeClass("slidefade in").addClass("header-hide");
        //		 }
    },
	
	goToPage: function (e) {
		e.preventDefault();
		/* HANDLE PAGE CHANGE */
		var menuId = $(e.currentTarget).attr('id');
		console.log("goToPage Location hash:" + location.hash);
		/* Condition handlers */
		if(location.hash=="#login-page"&&menuId=="enrolment"){
			if(!this.checkEnrolment()){
				return;
			}
		}
		if(location.hash==="#pharmacy-page"){
			this.states=2;
		}
		if(menuId==="login"&&location.hash==="#refill-page"){
			/* hide the filter layer */
			$("#store-service-filter").slideUp("normal");
			
//			loginView.setFromRefill(loginView.checkFromRefillValue());
			loginView.setfromRefillbyNumber(true);
		}else{
			this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
			/* hide the filter layer */
			$("#store-service-filter").slideUp("normal");
			
			loginView.setfromRefillbyNumber(false);
		}
		
		/* Check internet connection */
		if(menuId==="login" 
		|| menuId == "flyer" 
		|| menuId == "locator"
		|| menuId == "clinic"){
			if(!this.checkConnection()){
				return;
			}
		}
		
        /* Go to that page */
        if (menuId === "blood-pressure" || menuId === "airmile" || menuId==="rewards") {
            /* Waiting for sign off .... */
            jAlert("COMING SOON!", "Rexall");
            return;
        }
        else if (menuId == "myprofile" 
                 || menuId == "CommunicationPreferences"
                 || menuId == "SecurityPreferences"
                 || menuId == "record"
                 || menuId == "myrexall-account") {
            /* Check login status first */
            if (!localStorage.getItem("JanRainLogin")) {
                /* haven't login, go to login page */
                id = "login";
            }
            else {
                /* have login, go to selected page */
                id = menuId;
                /* Change record page header */
                if (id == "record") {
                	if(!this.checkEnrolment()){
                		return;
                	}
                    $("#record-page-header").html("<p>MEDICATION RECORD</p><div class='rexall-page-header-info'></div>");
                }
            }
            /* Handle settings page */
            if (id == "myrexall-account")
                return;
				
            /* go to page */
            var id = "#" + id + "-page";
            $.mobile.changePage(id, {transition: 'slide'});	
        }
        else {
            if (menuId == "flyer")
                $("#E-Flyer-div").removeClass("content-page-flyer-from-store").addClass("content-page-flyer");
            else
                this.closeClosestStore();
         
            //clear clinic-locator-search
            $("#clinic-locator-search").css("visibility","hidden");
            $("#clinic-search-input").val("");
            clinicFilterView.filterReset();

            //clear store-locator-search
            storeFilterView.filterReset();

             if ((location.hash == "#transfer-page" || location.hash == "#refill-page" )&& menuId == "login"	)
            {
                if(location.hash == "#transfer-page"){
          		  this.setStepsToGobackForRecord(3);
                }else{
          		 this.setStepsToGobackForRecord(2);
                }
             }
            else if (menuId == "transfer")
            { 
                transferView.render();
                this.setStepsToGobackForRecord(0);
            }
            else if (menuId == "refill")
            {
                refillView.render();
				//refillView.refillScroll.scrollTo(0,10,200,true);

            }

             /* General go to page */
            var id = "#" + $(e.currentTarget).attr('id') + "-page";

            if (id !== location.hash)
                $.mobile.changePage(id, {transition: 'slide'});	

           

        }
		
		/* CHANGE HEADER */
//		if(menuId == "pharmacy" || menuId == "refill" || menuId == "locator" || menuId == "clinic"){
//			/* From first level to second */
//			/* show back button  */
//			$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
//		}else{
//			/**
//			 * Do we still need this condition? since from second level to third the back button has already been shown */
//			/* From second level to third */
//			/* Show back button */
			$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
//		}
		
		/* unbind the settings page collapse */
		$(".ui-collapsible[data-allow-collapse=false]").unbind("expand collapse");
		
		/* show the title*/
		//var id="#" + $(e.currentTarget).attr('id') + "-page";
//		$(".rexall-content").css("top","6em");
//		var headerId = "#" + menuId + "-header";
//		$(headerId).removeClass("header-hide").addClass("slidefade in");
		
		
		
		
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	closeClosestStore: function() {
		/* Close locator options */
		$("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");
	},
	
	
	closeClosestClinicStore: function() {
		/* Close locator options */
		$("#clinic-lower-header").removeClass("lower-header-open").addClass("lower-header-close");
	},

	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	toggleClosestStore: function(e) {
		
		if(e){
			e.preventDefault();
		}
		
		/* Toggle options */
		$("#lower-header").toggleClass("lower-header-close lower-header-open");
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	searchClosest: function() {
		/* Check if need go back first */
		if(location.hash === "#direction-page" &&router.pageFromlocator != "#locator-page"){
			this.goBack(2);
		}else if((location.hash === "#detail-page"||router.previousPage == "#locator-page")&&
				  location.hash != "#locator-page"&&location.hash != "#clinic-store-service-filter"){
			this.goBack();
		}
		/* hide the filter layer */
		$("#store-service-filter").slideUp("normal");
		/* Show search box */
		$("#locator-search").css("visibility","visible");
		//$("#locator-list-div").css("top","14em");
		//storeDetailList.fetchDataWithGeo();
	},
	
	clinicSearchClosest: function() {
		/* Check if need go back first */
        console.log("clinicSearchClosest location:" + location.hash);
		if(location.hash === "#direction-page"&&router.pageFromlocator != "#locator-page"){
			this.goBack(2);
		}else if((location.hash == "#clinic-detail-page"||router.pageFromlocator == "#locator-page")&&
				location.hash != "#clinic-page"&&location.hash != "#store-service-filter"){
			this.goBack();
		}
		/* hide the filter layer */
		$("#clinic-store-service-filter").slideUp("normal");
		/* Show search box */
		$("#clinic-locator-search").css("visibility","visible");
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	openClosestStore: function (e)	 {
		
		e.preventDefault();
		
		/* Workflow control */
		if(location.hash === "#locator-page" || location.hash === "#detail-page" || location.hash === "#direction-page")
			return;
		
		/* Change to locator page */
		if(location.hash != "#locator-page")
		{
			var id = "#locator-page";
			$.mobile.changePage(id, {transition: 'slide'});
		}
	
		/* Back button show */
		$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
		/* Show header */
		var headerId = "#locator-header";
		$(headerId).removeClass("header-hide").addClass("slidefade in");		
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showMapView: function(e) {
		
		e.preventDefault();
		/* hide the filter layer */
		$("#store-service-filter").slideUp("normal");

		this.searchHide();
        console.log("showMapView location.hash:" + location.hash);
		/* Check if need go back first */
		if(location.hash === "#direction-page"){
			/* Show list view button */
			$("#list-view").removeClass("locator-menu-hide");
			
			if(this.directionFromListView){
				/* Previous page is list view, go back to map view without worrying about detail page */
				this.goBack();
			}else{
				/* Previous page is detail view, need to bypass detail page */
				this.goBack(2);
			}
			
		}else if(location.hash === "#detail-page" || location.hash === "#flyer-page"){
			var id="#locator-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#list-view").addClass("locator-menu-hide");
			$("#map-view").addClass("locator-menu-hide");
			$("#detail-view").removeClass("locator-menu-hide");
			setTimeout(function(){
				if(storeDetailPage.model){
					storeListMapView.setDetailPageModel(storeDetailPage.model);
				}
				storeListMapView.showMapFromDetailPage();
			},800);
			appView.currentPage = id;
		}else {
			$("#list-view").removeClass("locator-menu-hide");
			/* Show map */
			//storeListMapView.showMap();	
			setTimeout(storeListMapView.showMap(),500); 

		}
		//hide filter layer
		$("#store-service-filter").slideUp("normal");
		$("#locator-page").removeClass("locator-page-list-view").addClass("locator-page-map-view");
		/* Hide button */
		$("#map-view").addClass("locator-menu-hide");	
//		$("#list-view").removeClass("locator-menu-hide");

        // refresh map after 0.2 sec delay
        setTimeout(function(){
            google.maps.event.trigger(storeListMapView.map, 'resize');
            storeListMapView.map.setCenter(storeListMapView.myLocation);
        }, 200);
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showListView: function(e) {
			
		e.preventDefault();
		/* Check if need go back first */
		if(location.hash === "#direction-page"){
			this.goBack(2);
		}else if(location.hash === "#detail-page"){
			this.goBack();
		}
		//hide filter layer
		$("#store-service-filter").slideUp("normal");
		$("#locator-page").removeClass("locator-page-map-view").addClass("locator-page-list-view");
		this.searchHide();

		/* Hide button */
		$("#list-view").addClass("locator-menu-hide");	
		$("#map-view").removeClass("locator-menu-hide");

	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showAllStores: function() {
		var id = "#locator-page";
		$.mobile.changePage(id, {transition: 'slide'});
		
		/* Show all Stores */
		storeListView.showAll();
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showDirection: function(options) {
		this.showClinicDirection = false;
        this.searchHide();
		if(!storeDetailPage.model){
			jAlert("Select a store first.","Please Try Again");
		}else if(location.hash === "#direction-page"){
			return true;
		}else{
			var id = "#direction-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#direction-page-title").html("STORE LOCATOR");

			if(options.isFromListView && options.isFromListView == true){
				/* This call is from list view */
				this.directionFromListView = true;
			}else{
				/* This call is from detail view */
				this.directionFromListView = false;
			}
			
            			/**
			 * Moved this part to router, need more thoughts on this ....
			 */
//			/* creat direction page */
//			var directionPage = new StoreDirectionView({"model" : storeDetailPage.model});
//			directionPage.render();
//			/* Search by default, from search location */
//			var lt = storeDetailList.lat;
//			var lg = storeDetailList.lng;
//			directionPage.displayDirection(lt, lg);
		}
	},
	
	showClinicDirection: function(options) {
		
		this.showClinicDirection = true;
		/* hide the filter layer */
		$("#clinic-store-service-filter").slideUp("normal");
        this.clinicSearchHide();
		if(!clinicStoreDetailPage.model){
			jAlert("Select a clinic first.","Please Try Again");
		}else if(location.hash === "#direction-page"){
			return true;
		}else{
			var id = "#direction-page";
			$.mobile.changePage(id, {transition: 'slide'});
            $("#direction-page-title").html("MEDICAL CLINIC LOCATOR");
		}
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	setDefaultStore : function () {
		/* hide the filter layer */
		$("#store-service-filter").slideUp("normal");
		
		if(location.hash !== "#detail-page"){
			jAlert("Select a store first.","Please Try Again");
		}else if(localStorage.getItem("RexallProfileHomeStore")){
			
			/* Check if the user has already got a Medication record store */
			
			var store = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));
			var address = store.Address + ", " +  store.City + ", " + store.Province;

			var info = "<span class ='refill-callBack-info-regular-teal'>"+address+"</span>";
			info = "<span class ='refill-callBack-info-regular'>Your My Store has been linked to your Medication Record Store</span>"+ info;
			jAlert(info, "My Store");

			
		}else{
			
			/* Store the store in memory, it may be better if move this line to StoreDetail.js */
			localStorage.setItem("CurrentStore", JSON.stringify(storeDetailPage.model.toJSON()));
			
			/* Set this store as preferred store */
			storeDetailPage.model.setPreferred();
			
			/* Set currentStoreView with new preferred store */
			currentStoreView.setModel(storeDetailPage.model);
			currentStoreView.render();
            storeDetailPage.render();
			
			/* Update record view address header */
			var currentStore = localStorage.getItem("CurrentStore");
		    $("#record-manual-refill-header-mystore").html(JSON.parse(currentStore).Address);
			
			jAlert("Your preferred store has been updated","My Store");
		}
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showCurrentStore : function	() {
		/* hide the filter layer */
		$("#store-service-filter").slideUp("normal");
		
		/* Render using profile store or current store */
		currentStoreView.render();
		
		if(currentStoreView.model){
			/* The user has set a preferred store */
			/* Create Detail page */
			storeDetailPage.setModel(currentStoreView.model);
			storeDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */	
			/* go to detail page */
			var id = "#detail-page";
			$.mobile.changePage(id, {transition: 'slide'});
		}else{
			/* go to store locator page */
			var id = "#locator-page";
			$.mobile.changePage(id, {transition: 'slide'});
			/* Back button show */
			$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
			/* Page header show */
			var headerId = "#locator-header";
			$(headerId).removeClass("header-hide").addClass("slidefade in");
		}
		
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	showOnlineRefill: function() {

   		this.closeClosestStore();
	//	if(!this.checkEnrolment()){
	//	return;
	//	}
		var current = localStorage.getItem("CurrentStore");
		if(window.localStorage.getItem("JanRainLogin")&&profile.hasRecord()){
/*			var storeNumber = JSON.parse(current).StoreNumber;
			var thisNumber = storeDetailPage.model.toJSON().StoreNumber;
			if(storeNumber === thisNumber){
				this.states = 3;
				var id = "#record-page";
				$.mobile.changePage(id, {transition: 'slide'});
				$("#record-page-header span").html("REFILL USING MyRexall ACCOUNT");
				$("#MedicalRecord-page-info span").html("About Refill Using MyRexall Account");
//				$("#record-header").removeClass("header-hide").addClass("slidefade in");
				 Change appView currentPage 
				appView.currentPage = id;
				 Medication Records 
//				recordListView.setModel(this.model);
//				recordListView.render();
			}else{
				this.states = 1;
				 Go to refill page 
				var id = "#refill-page";
				$.mobile.changePage(id, {transition: 'slide'});
//				var headerId = "#refill-header";
//				$(headerId).removeClass("header-hide").addClass("slidefade in");
				 Insert selected store to refill view 
				refillView.insertStore(storeDetailPage.model);
			}*/
			this.states = 3;
			var id = "#record-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#record-page-header").html("<p>REFILL USING MyRexall ACCOUNT</p><div class='rexall-page-header-info'></div>");
			$("#MedicalRecord-page-info span").html("About Refill Using MyRexall Account");
//			$("#record-header").removeClass("header-hide").addClass("slidefade in");
			/* Change appView currentPage */
			appView.currentPage = id;
		}else{
			this.states = 1;
			/* Go to refill page */
			var id = "#refill-page";
			$.mobile.changePage(id, {transition: 'slide'});
            //Init refill page
            refillView.render();
	//	    refillView.refillScroll.scrollTo(0,10,200,true);
//			var headerId = "#refill-header";
//			$(headerId).removeClass("header-hide").addClass("slidefade in");
			/* Insert selected store to refill view */
			refillView.insertStore(storeDetailPage.model);
		}
	},

	/* Logout MyRexall */
	logoutJR: function(){
		
		var self = this;
		/* Sign out check */
		
/* -------- Logic for Sign out without a prompt ------------------    */		
				/* Logout JanrainLogin model */
				loginView.model.logout();
				//jAlert("You have signed out.");
				
				if(location.hash === "#profile-page"
					|| location.hash === "#myprofile-page"
					|| location.hash === "#SecurityPreferences-page"
					|| location.hash === "#CommunicationPreferences-page"){
					self.goBack(1);
				}
				
				if(location.hash === "#record-page" ){
					switch(self.states){
						case 1:			/* Refill Page */
							self.goBack(2);
							break;
						default:
							self.goBack(1);
							break;
					}
				}		
				/* sign out from enrolment page*/
		        if(location.hash == "#enrolment-page"||
		        	location.hash == "#enrolment-form-page"||
		        	location.hash == "#enrolment-term-page"||
		        	location.hash == "#enrolment-complete-page"||
		        	location.hash == "#enrolment-request-page"||
		        	location.hash == "#enrolment-wait-page"||
					location.hash == "#enrolment-confirm-page"||
					location.hash == "#enrolment-verify-page"){
					this.goHomePage();
		        }
/* -------- Logic for Sign out with a prompt ------------------   	
		
		
/* -------- Logic for Sign out with a prompt ------------------    */		
		
	/*	jConfirm("Are you sure you want to sign out?","Sign Out",function(r){
			if(r){
				
				// Logout JanrainLogin model
				loginView.model.logout();
				//jAlert("You have signed out.");
				
				if(location.hash === "#profile-page"
					|| location.hash === "#myprofile-page"
					|| location.hash === "#SecurityPreferences-page"
					|| location.hash === "#CommunicationPreferences-page"){
					self.goBack(1);
				}
				
				if(location.hash === "#record-page" ){
					switch(self.states){
						case 1:			// Refill Page 
							self.goBack(2);
							break;
						default:
							self.goBack(1);
							break;
					}
				}
				
			}
		});
		
		// Set comfirm button text 
		$("#popup_ok").html("Yes");
		$("#popup_cancel").html("No");
		
		*/

	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 * ** It would be better if it is done in content level instead of page level
	 */
	searchFilter :function(){
		//$("#store-service-filter").slideToggle("slow");
		$("#store-service-filter").slideDown("slow");
		//$("#store-service-filter").fadeIn("normal");
		this.searchHide();
		if($("#store-service-filter-ul li").length<=0){
			storeFilterView.render();
		}
		storeFilterView.storeFilterScroller.refresh();
		storeFilterView.storeFilterScroller.scrollToElement("#store-service-filter-div .v-scrollable li.scrollToElement",200) ;
	},
	
	/* Show Refill by MyRexall or Refill from Store Locator */
	refillByMAOrSL: function(){
		/* check Enrolment*/
		if(!this.checkEnrolment()){
			return;
		}
		if(!window.localStorage.getItem("JanRainLogin")){
			//this.states = 1;
			loginView.setFromRefill(true);
			// jAlert("Please login first");
			var id ="#login-page";
			$.mobile.changePage(id, {transition: 'slide'});
            this.setStepsToGobackForRecord(1);
            console.log( "refillByMAOrSL : " + this.stepsToGoback);
		}else{
			if(profile.hasRecord()){
			var id = "#record-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#record-page-header").html("<p>REFILL USING MyRexall ACCOUNT</p><div class='rexall-page-header-info'></div>");
			/* Change appView currentPage */
			appView.currentPage = id;
            this.setStepsToGobackForRecord(0);
            console.log( "refillByMAOrSL-profile.hasRecord : " + this.stepsToGoback);
		}else{
				/* Go to refill page */
		      	var id = "#refill-page";
				$.mobile.changePage(id, {transition: 'slide'});
                //init refill page
                refillView.render();
		   //     refillView.refillScroll.scrollTo(0,10,200,true);
				/* Insert selected store to refill view */
				refillView.insertStore();
                this.setStepsToGobackForRecord(0);
                console.log( "refillByMAOrSL refill-page : " + this.stepsToGoback);
			}
		}
		
	},

    /* Show Refill by MyRexall or Refill from Store Locator */
	medicationRecord: function(){
		if(!window.localStorage.getItem("JanRainLogin")){
			this.states = 1;
            loginView.state = true;
			loginView.setFromRecord(true);
			// jAlert("Please login first");
			var id ="#login-page";
			$.mobile.changePage(id, {transition: 'slide'});
            this.setStepsToGobackForRecord(2);
		}else{
			   if(!this.checkEnrolment()){
				   return;
			   }
	    	    var id = "#record-page";
			    $.mobile.changePage(id, {transition: 'slide'});
			    $("#record-page-header").html("<p>MEDICATION RECORD</p><div class='rexall-page-header-info'></div>");
			    /* Change appView currentPage */
			    appView.currentPage = id;
                this.setStepsToGobackForRecord(0);
                console.log( "medicationRecord  #record-page: " + this.stepsToGoback);
		}
		
	},
	
	/* Show Refill Prescriptions */
	refillPrescription: function(e){
		
//		var ls = localStorage.getItem("RexallProfile");
//		if(ls){
//			profile.set(JSON.parse(ls));
//		}
		
		//if(localStorage.getItem("JanRainLogin")&&profile.hasRecord()){
//		if(!this.checkEnrolment()){
//			return;
//		}
		if(localStorage.getItem("JanRainLogin")&&profile.hasRecord()){
			this.states = 0;
			var id = "#record-page";
			$.mobile.changePage(id, {transition: 'slide'});
			$("#record-page-header").html("<p>REFILL USING MyRexall ACCOUNT</p><div class='rexall-page-header-info'></div>");
			/* Change appView currentPage */
			appView.currentPage = id;
            
		}else{
			this.states = 1;
			/* Go to refill page */
			var id = "#refill-page";
			$.mobile.changePage(id, {transition: 'slide'});
             //init refill page
            refillView.render();
		 //   refillView.refillScroll.scrollTo(0,10,200,true);

			/* Insert selected store to refill view */
			refillView.insertStore();
            loginView.setFromRefill(true);
            console.log(" loginView.setFromRefill(true);");
		}
		
	},
	
	/**
	 * Need to be migrate to locator view 
	 * MainRouter will also be affected
	 */
	searchHide : function(e){
		if(e){
			e.preventDefault();
		}
		$("#locator-search").css("visibility","hidden");
		//$("#locator-list-div").css("top","6.8em");
	},
	
	clinicSearchHide: function(e) {
		if(e){
			e.preventDefault();
		}
		$("#clinic-locator-search").css("visibility","hidden");
	},
	
	changeColor : function(e){
		if(e){
			e.preventDefault();
		}
		
		var chageId = $(e.currentTarget).attr('id');
		var lis = $(".locator-menu ul li");
		for(var i=0;i<lis.length;i++){
			var ps = $("#"+lis[i].id+">p");
			if(lis[i].id==chageId&&chageId!="list-view"&&chageId!="map-view"&&chageId!="detail-view"&&
					   chageId!="clinic-list-view"&&chageId!="clinic-map-view"&&chageId!="clinic-detail-view"){
				ps.css("color","rgba(24, 199, 189)");
			}else{
				ps.css("color","#6d6e6e");
			}
		}
	
		if(chageId=="map-view"||chageId=="list-view"||chageId=="detail-view"){
			$("#list-view>p").css("color","#6d6e6e");
			$("#map-view>p").css("color","#6d6e6e");
			
		}
		if(chageId=="clinic-list-view"||chageId=="clinic-map-view"||chageId=="clinic-detail-view"){
//			$("#clinic-list-view>p").css("color","#0FB0A8");
//			$("#clinic-map-view>p").css("color","#0FB0A8");
			$("#clinic-list-view>p").css("color","#6d6e6e");
			$("#clinic-map-view>p").css("color","#6d6e6e");
			
		}
	},
	resetLocatorMenuColor : function(){
		$(".locator-menu ul li>p").css("color","#6d6e6e");
//		$("#clinic-detail-view>p").css("color","#0FB0A8");
//		$("#detail-view>p").css("color","#0FB0A8");
//		$("#list-view>p").css("color","#0FB0A8");
//		$("#clinic-list-view>p").css("color","#0FB0A8");
		
		
	},
	showTransferPage : function(){
	    $("#settings-page [href='#']").removeClass("ui-btn-active");
		$.mobile.changePage("#transfer-page", {transition: 'slide'});
	},
	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#locator-page-info1").popup({ transition: "pop" });
		$("#locator-page-info1").popup("open");
		//this.infoScroll.refresh();
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#locator-page-info1").popup("close");
	},
	/* states=0:home;1:refill-page;2:pharmacy-page;3:storeLocator */
	setBackPageFromRecord:function(states){
		
		this.states = states;
		
	},

    setStepsToGobackForRecord:function(stepsToGoback){
		
		this.stepsToGoback = stepsToGoback;
		
	},
	
	showDetailView :function(){
        console.log("showDetailView location.hash:" + location.hash);

		//this.goBack();
        /* Store detail */
		var id = "#detail-page";
		$.mobile.changePage(id, {transition: 'slide'});
		/* Change appView currentPage */
		appView.currentPage = id;
		/* Create Detail page */
		
		storeDetailPage.render();
		$("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
		$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");

	},

    showClinicDetailView :function(){
        console.log("show Clinic DetailView location.hash:" + location.hash);

		/* Clinic detail */
		var id = "#clinic-detail-page";
		$.mobile.changePage(id, {transition: 'slide'});
		/* Change appView currentPage */
		appView.currentPage = id;
		
		clinicStoreDetailPage.render();

   //     $("#clinic-locator-menu ul li[class='locator-detail']").css("visibility","visible");
		$("#clinic-locator-menu ul li[class='locator-first']").css("visibility","visible");
        //show direction
        $("#clinic-show-direction").removeClass("locator-menu-hide");	
        $("#clinic-map-view").removeClass("locator-menu-hide");
		/* Hide my clinic button */
		$("#my-clinic").addClass("locator-menu-hide");
        $("#clinic-detail-view").addClass("locator-menu-hide");

	},

	closePdf :function(){
		this.goBack();
	},
	
	showRegister :function(){
		var strURL = getMyRexallURL(); 
		var strMsg = "Please register at \n" + strURL + " \n";  
		jAlert(strMsg, "Register to MyRexall"); 
	},
	
	/* Check internet connection */
	checkConnection:function() {
	    var networkState = navigator.connection.type;
	    
	    if(networkState == Connection.NONE){
	    	jAlert("You have no connection to the internet. Check your network settings and try again.", "Network Connection Error");
	    	return false;
	    }
	    
	    return true;
	},
	/* check Enrolment*/
	checkEnrolment : function(){
		if(localStorage.getItem("JanRainLogin")&&loginView.goToEnrolmentPageStatus){
    		loginView.goToEnrolmentPage();
    		return false;
    	}else{
    		return true;
    	}
	},
	/* check go back  from Enrolment*/
	checkGoBackFromEnrolment : function(){
		if(loginView.enrolmentPageId!=null&&loginView.enrolmentPageId==location.hash){
			return true;
		}else{
			return false;
		}
	},
	enrolmentCompleteNotnow : function(){
		var self = this;
		var info = "<p>MyRexall benefits include:</p><li>Your personal Medication Record</li><li>Quick refill of multiple prescriptions</li><li>Easy prescription transfers</li><li>Access to health information</li><li>Exclusive savings and promotions</li>";
		jAlert(info,"Thank you for creating a MyRexall Account",function(r){
			    if(r){
			    	self.goHomePage();
			    }
		});
	},
	
	checkDateOfBirth : function(dateStr){
		var date;
		if(dateStr.indexOf("-")!=-1){
			 date = new Date(dateStr.replace("-", "/").replace("-", "/"));
		}else{
		     date = new Date(dateStr.substring(6,10),parseInt(dateStr.substring(3,5))-1,dateStr.substring(0,2));
		}
		var now = new Date();
	    if(now<date){  
	        return false;  
	    }else{
	    	return true;
	    }  
	}, 
	
	checkDateOfBirthAfter18 : function(dateStr){
		var date='';
		if(dateStr.indexOf("-")!=-1){
			 date = new Date(dateStr.replace("-", "/").replace("-", "/"));
		}else{
			 date = new Date(dateStr.substring(6,10),parseInt(dateStr.substring(3,5))-1,dateStr.substring(0,2));
		}
		var now = new Date();
		var date18 = new Date(date.getFullYear()+18,date.getMonth(),date.getDate()); 
		if(date18<now){  
	        return true;  
	    }else{
	    	return false;
	    }  
	}, 
	
	flyerShowInfo : function(e){
		e.preventDefault();
		/* Open information box */
		$("#flyer-page-info").popup( "option", "history", false );
		$("#flyer-page-info").popup({ transition: "pop" });
		$("#flyer-page-info").popup("open");
	},
	flyercloseInfo : function(e){
		e.preventDefault();
		$("#flyer-page-info").popup("close");
	},



});