//var serviceList=[];
var ClinicFilterView = Backbone.View.extend({
	
	initialize: function () {
	  /* Initialize store service scroller */
//      this.storeFilterScroller = new iScroll("clinic-store-service-filter", {
//    	  	hScroll:false, 
//			vScroll:true, 
//			vScrollbar: true, 
//			hScrollbar: false, 
//			fadeScrollbar: true, 
//			hideScrollbar:true,
//      });
      
      /* remember the filter list */
      this.serviceList = new Array();
      this.filterChanged = false;           
	},
	
	el: $("#clinic-store-service-filter"),
	
	events: {
	    "tap #clinicFilterClear"      : "filterReset",
		"tap #clinicFilterDone" 		: "filterStores",
		"tap #clinicFilterHide"       : "filterHide",
		"tap .store-service-filter-item"	: "toggleFilterItem",
	},
	
	setModel:function(model) {
		this.model = model;
	},
	
	/* Toggle the check box of filter items */
	toggleFilterItem: function(e) {
		if($(e.target).prop("tagName").toUpperCase() == "INPUT"){
			return;	/* Let html tag do the job if tap on input */
		}
		var checkBox = $(e.target).find('input');
		checkBox.prop("checked", !checkBox.prop("checked"));
	},
	
	filterStores : function() {	
		/* Remeber previous list to compare, !! the compare is redundant now since filterReset is called every time the filter is closed */
		var previous = this.serviceList;
		/* new empty array list */
		var list = [];
	    /* get the checked store service */
		$("[name='filterCheckbox']:checked").each(function(index, value){
			list[index] = $(value).val();
    	});

		this.serviceList = list;
		/* Compare to check difference */
		if(this.notSameList(list, previous)){
			if($("#clinic-locator-search-input").val()){
				/* use search input */
				clinicLocatorView.searchStores("clinicFilter");
			}else if(this.model){
				/* use geolocation */
				this.model.fetchClinicDataWithDefaultLocation();
                clinicLocatorView.searchFromPage = "clinicFilter"; 
			}
				
		}
		if (location.hash !== "#clinic-page")
        {
            clinicLocatorView.showListView();
            var id="#clinic-page";
			$.mobile.changePage(id, {transition: 'slide'});
            appView.currentPage = id;
        }
        		
    	$("#clinic-store-service-filter").slideUp('normal');
        this.filterChanged = false;  
	},
	
	filterReset :function(){
	    this.$el.find("[name='filterCheckbox']").attr("checked",false);
	    this.serviceList = []; 
        this.filterChanged = true;
	},
	
	filterHide :function(){
	  //slideToggle("slow"); 
	  $("#clinic-store-service-filter").slideUp('normal');
	  /* new empty array list */
		var list = [];
	    /* get the checked store service */
		$("[name='filterCheckbox']:checked").each(function(index, value){
			list[index] = $(value).val();
    	});

		this.serviceList = list;
	},
	
	/* Compare two filter list, return ture if they are not the same */
	notSameList: function(a, b){
		if(!a || !b)
			return;
		
		/* Compare lenght */
		if(a.length != b.length || this.filterChanged)
			return true;
		/* Compare content */
		var i = 0;
		for(i = 0; i < a.length; i++){
			if(a[i] != b[i])
				return true;
		}
		return false;
	}
	
	
});