var ClinicListMapView = Backbone.View.extend({
	
	tagName: 'div',
	
	//el: $("locator-map-div"),
	el:$("#clinic-map-div"),
	
	events: {
		
	},
	
	initialize: function () {
						
		/* Initialize new map */
		//this.map = 
		
		/* Initialize marker container */
		this.markers = new Array();
		
		/* Add listeners */
		this.listenTo(this.collection, "reset", this.resetMarkers);
		//this.listenTo(this.collection, "add", this.addMarker);

	},
	
	showMap: function() {
		
		/* Default map settings */
		var mapOptions = {
				zoom: 10,	
				mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		
		/* create new map */
		// Mike Map Change: in showMap to create map only if it do not exist.
		//
		if (!this.map)
		{		
			this.map = new google.maps.Map(document.getElementById("clinic-map-div"), mapOptions);
		}
		 else
		 {
			 this.resetMarkers();
		 }
		this.map.setZoom(10);
		// Mike Map Change End	
		
		/* Test position */
		//this.myLocation = new google.maps.LatLng(43.6317, -79.6756);
	    
		/* Add markers */
		this.addMarkers();

		this.map.setCenter(this.myLocation);
		
	},
	
	resetCenter:function () {
		this.map.setCenter(this.myLocation);
	},
	
	resetMarkers: function() { 
		/* remove from map */
		$.each(this.markers, function(index, value) {
			value.setMap(null);
		});
		/* empty array */
		this.markers.length = 0;		
		/* reset the center of the map */
		this.myLocation = new google.maps.LatLng(this.collection.lat, this.collection.lng);
		
	},
	

	
	addMarkers: function(){
		
		
		var markers = this.markers;
		var map = this.map;
		
		/* Add self location to the map */
		var myLocationMarker = new google.maps.Marker({
				position: this.myLocation,
				map: this.map
		});
		this.markers.push(myLocationMarker);
		
		/* Filling marker container */
		$.each(this.collection.models, function (index, value) {
			var long = value.toJSON().Longitude;
			var lat = value.toJSON().Latitude;

			var latitudeAndLongitude = new google.maps.LatLng(lat, long);

		    //console.log("Clinic Map view creat marker, long=" +long + " lat=" +lat);
            var iconimg = {
            	    url: 'image/store-locator-image/clinic-location-pin-teal.png',
            	    size: new google.maps.Size(82, 76),
            	    origin: new google.maps.Point(0,0),
            	    anchor: new google.maps.Point(22.5,40),
            	    scaledSize: new google.maps.Size(45, 40)
            	  };

             if (value.toJSON().isPreferredClinic) {
                iconimg = {
                	    url: 'image/store-locator-image/location-pin-preferred-clinic.png',
                	    size: new google.maps.Size(82, 76),
                	    origin: new google.maps.Point(0,0),
                	    anchor: new google.maps.Point(22.5,40),
                	    scaledSize: new google.maps.Size(45, 40)
                	  };
             }
			/* Create new marker */
			var marker = new google.maps.Marker({
				position: latitudeAndLongitude,
				map: map,
				//icon: 'http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld='+ (index+1) + '|3bb2a0|FFFFFF'
                icon: iconimg
			});
			

			/* Add listener for a click on the marker */
			google.maps.event.addListener(marker, 'click', function () {
				clinicStoreDetailPage.fromMapPage(true);
				var id = "#clinic-detail-page";
				$.mobile.changePage(id, {transition: 'slide'});
				/* Change appView currentPage */
				appView.currentPage = id;
				/* Create Detail page */
				clinicStoreDetailPage.setModel(value);
				clinicStoreDetailPage.render();
			});
		
			/* Insert marker */
			markers.push(marker);
			
		});
	},

    setDetailPageModel: function(detailPageModel){
		this.detailPageModel = detailPageModel;
	},

    showMapFromDetailPage: function(){
//		alert(JSON.stringify(this.detailPageModel.toJSON()));

		// Mike Map Change: in showMapFromDetailPage to use this.detailMap to store map so that it can be reused.
		//  create map only if it do not exist.
		var detailMapMarkers = this.markers;
		// Mike Map Change End
		var long1 = this.detailPageModel.toJSON().Longitude;
		var lat =  this.detailPageModel.toJSON().Latitude;
		/* reset the center of the map */
		var latitudeAndLongitude = new google.maps.LatLng(lat, long1);
		/* Default map settings */
		var mapOptions = {
				zoom: 10,	
				mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		/* create new map */
		//var map  = new google.maps.Map(document.getElementById("clinic-map-div"), mapOptions);
		
		// Mike Map Change: create map only if it do not exist. But clear all pins
				if (!this.map)
				 {		
				this.map  = new google.maps.Map(document.getElementById("clinic-map-div"), mapOptions);
				 }
				 else
				 {
				   $.each(detailMapMarkers, function(index, value) {
					value.setMap(null);
				      });
				  detailMapMarkers.length = 0;
				 }
		// Mike Map Change End		
				
				
		// Mike Map Change, change ref to this.detailMap		 
				this.map.setCenter(latitudeAndLongitude);
		//map.setCenter(latitudeAndLongitude);
		
        var iconimg = {
        	    url: 'image/store-locator-image/clinic-location-pin-teal.png',
        	    size: new google.maps.Size(82, 76),
        	    origin: new google.maps.Point(0,0),
        	    anchor: new google.maps.Point(22.5,40),
        	    scaledSize: new google.maps.Size(45, 40)
        	  };

        if (this.detailPageModel.toJSON().isPreferredClinic) {
            iconimg = {
            	    url: 'image/store-locator-image/location-pin-preferred-clinic.png',
            	    size: new google.maps.Size(82, 76),
            	    origin: new google.maps.Point(0,0),
            	    anchor: new google.maps.Point(22.5,40),
            	    scaledSize: new google.maps.Size(45, 40)
            	  };
        }

        /* Create new marker */
		var markerCenter = new google.maps.Marker({
			position: latitudeAndLongitude,
			// Mike Map Change, change ref to this.detailMap		 
			map: this.map,
			icon:iconimg
		});
		
// Mike Change: Track Marker for later deletion
		 detailMapMarkers.push(markerCenter);
// Mike Map Change End

      	google.maps.event.addListener(markerCenter, 'click', function (self) {
      		appView.goBack();
//			var id = "#clinic-detail-page";
//			$.mobile.changePage(id, {transition: 'slide'});
//			/* Change appView currentPage */
//			appView.currentPage = id;
//			/* Create Detail page */
//            clinicStoreDetailPage.setModel(this.detailPageModel.toJSON());
//			clinicStoreDetailPage.render();
		
		});

         var myLocationMarker = new google.maps.Marker({
			position: this.myLocation,
			// Mike Map Change, change ref to this.detailMap		 
			map: this.map
		});
// Mike Map Change: Track Marker for later deletion
		  detailMapMarkers.push(myLocationMarker);
// Mike Map Change End	
	},
});