var ClinicListView = Backbone.View.extend({
	
	tagName: "ul",
	
	el: $("#clinic-list-ul"),
	
	events:	{
		
	},
	
	initialize: function () {
		/* Array that stores all the item views */
		this.itemViews = new Array();
		
		this.listenTo(this.collection, "add", this.addOne);
		this.listenTo(this.collection, "reset", this.cleanUp);
				
		/* Create iScroller for store list */
		var self = this;
		var pullUpEl = document.getElementById('ClinicPullUp');
        var pullUpOffset = pullUpEl.offsetHeight;
		var scroller = new iScroll('clinic-list-div',
									{snap:'li', 
									hScroll:false, 
									vScroll:true, 
									vScrollbar: true, 
									hScrollbar: false, 
									fadeScrollbar: true, 
									hideScrollbar:true,
									onRefresh: function () {
										if (pullUpEl.className.match('loading')) {
											pullUpEl.className = '';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Pull up to load more...';
										}
									},
									onScrollMove: function () {
										if (this.y < (this.maxScrollY - 40) && !pullUpEl.className.match('flip')) {
											pullUpEl.className = 'flip';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Release to refresh...';
											this.maxScrollY = this.maxScrollY;
										} else if (this.y > (this.maxScrollY + 40) && pullUpEl.className.match('flip')) {
											pullUpEl.className = '';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Pull up to load more...';
											this.maxScrollY = pullUpOffset;
										} 
									},
									onScrollEnd: function () { 
										if(pullUpEl.className.match('flip')){
											pullUpEl.className = 'loading';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Loading...';
											self.addMore();
										}
									},
									});
		this.listScroller = scroller;
        this.listScroller.scrollTo(0,100);
        /* clean up */
		this.cleanUp();
	},
	
	addMore: function()	{
		this.collection.fetchMoreClinic();
	},
	
	addOne: function (item) {
		
		/* Add to list */
		var storeListItemView = new StoreListItemView({model : item});	/* Create item view */
		this.$el.append(storeListItemView.render().el);					/* Insert Item view to list */
		this.listScroller.refresh();
		/* push to container array */
		this.itemViews.push(storeListItemView);							/* Push to storage */
		
		/* Refresh list scroller, should not doing it here!!.. */
		this.listScroller.scrollTo(0, this.listScroller.maxScrollY-40);
		this.listScroller.refresh();
		
		/* Show pullup icon */
		$("#ClinicPullUp").show();
		
		/* Show map - not.. this is the memory leak bug */
		//clinicListMapView.showMap();
	},
	
	cleanUp: function () {
		this.$el.html("");
		/* Empty itemViews */
		this.itemViews.length=0;
        $("#ClinicPullUp").hide();
	},
	
	showRefill: function() {
		var filter = "Online Refill";
		$.each(this.itemViews, function(index, value) {
			//if(value.model.toJSON().StoreServices.indexOf(filter) >= 0){
			if(index > 2){
				// do nothing
			}else{
				/* Hide the stores that don't have online refill service */
				value.$el.removeClass("list-item-show").addClass("list-item-hide");
			}
		});
		this.listScroller.refresh();
	},
	
	showAll: function() {
		$.each(this.itemViews, function(index, value) {
				/* Make All Stores Visible */
				value.$el.removeClass("list-item-hide").addClass("list-item-show");
		});
		this.listScroller.refresh();
	},
	
    refreshScroller: function () {
        this.listScroller.refresh();
        this.listScroller.scrollTo(0,100);
    }

});