var ClinicLocatorView = Backbone.View.extend({
	
	initialize: function () {
        this.directionFromListView = false;
        this.searchFromPage = "";
	},

	
	el: $("body"),
	
	events: {
		"tap #clinic-locator-search-submit-wrapper" 	: 	"searchStoresSubmit",
		"keypress #clinic-search-input"					: 	"keySearchStores",
		"tap #clinic-map-view"				: 	"showMapView",
		"tap #clinic-list-view"				:	"showListView",
		"tap #clinic-search-filter"			:   "clinicSearchFilter",
		"tap #clinic-detail-address-make-default"		: "setDefaultClinic",
		"tap #my-clinic"					: 	"showCurrentClinic",
       
        "tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
		//"tap #clinic-show-direction"	: 	"showDirection",
	},

   
//	showClinicDetail:function() {
//        console.log("showClinicDetail location.hash:" + location.hash);

//		//this.goBack();
//        storeListItemView.showClinicDetail();
//       
//    },

	showCurrentClinic:function(){
		/* hide the filter layer */
		$("#clinic-store-service-filter").slideUp("normal");
		
		//var current = localStorage.getItem("CurrentStore");
		currentClinicView.render();	/* Render to get localstorage */
		
		if(currentClinicView.model){
			/* go to detail page */
			var id = "#clinic-detail-page";
			$.mobile.changePage(id, {transition: 'slide'});
			
			clinicStoreDetailPage.setModel(currentClinicView.model);
			clinicStoreDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */				
			//console.log("currentClinicView.model true" + JSON.stringify(currentClinicView.model));
		}else{
			//		jAlert("You currently do not have a Preferred Store","My Store");
			jAlert("You do not have a Preferred Clinic","My Clinic");
//			var homeStore = localStorage.getItem("RexallProfileHomeStore");
//			if(homeStore){
//				localStorage.setItem("CurrentClinic",homeStore);
//				/* go to detail page */
//				var id = "#clinic-detail-page";
//				$.mobile.changePage(id, {transition: 'slide'});
//				
//				clinicStoreDetailPage.setModel(currentStoreView.model);
//				//storeDetailPage.setModel(JSON.parse(homeStore));
//				clinicStoreDetailPage.render();	/* !!!! This render function here should be handle by view listener after the app is able to store customer setting of stores */				
//		        console.log("currentClinicView.model false, show homeStore");
//			}else{
//				jAlert("You do not have a Preferred Clinic","My Clinic");
//			}
		}
	},
	
	
	setDefaultClinic: function() {
		
		if(location.hash !== "#clinic-detail-page"){
			jAlert("Select a store first ","My Clinic");
		}
//        else if(localStorage.getItem("RexallProfileHomeStore")){
//			
//			/* Check if the user has already got a Medication record store */
//			
//			var store = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));
//			var address = store.Address + ", " +  store.City + ", " + store.Province;

//			var info = "<BR/> <span style='float:left;color:#00b0a9;font-weight:bold;'>Medication Record Store:&nbsp;&nbsp;<span style='color:#0F0F0F;font-weight:bold;'>"+address+"</span></span><BR/><BR/>";
//			info = "<span class ='refill-callBack-error-info-top'>Your My Store has been linked to your Medication Record Store</span><BR/><BR/><BR/>"+ info;
//			
//			jAlert(info, "Rexall");
			
//		}
        else{
			/* Store the store in memory, it may be better if move this line to StoreDetail.js */
			localStorage.setItem("CurrentClinic", JSON.stringify(clinicStoreDetailPage.model.toJSON()));
			
            jAlert("Your preferred clinic has been updated","My Clinic");

			/* Set this store as preferred store */
			clinicStoreDetailPage.model.setPreferredClinic();
			
			/* Set currentStoreView with new preferred store */
			currentStoreView.setModel(storeDetailPage.model);
            currentStoreView.render();
			clinicStoreDetailPage.render();
		
			
			
		}
	},
	
	clinicSearchFilter :function(){
		/* Open filter layer */
		$("#clinic-store-service-filter").slideDown("slow");
		
		/* Hide search field */
		if(appView)
			appView.clinicSearchHide();
	},
	
	keySearchStores : function (e) {
		if(e.keyCode === 13) {
			this.searchStores("clinicSearch");
		}
	},

    searchStoresSubmit : function () {
		this.searchStores("clinicSearch");
	
	},
	
	searchStores : function(fromPage) {
		var q = $("#clinic-search-input").val();
		
		if(q){
            this.searchFromPage= fromPage;
			this.collection.fetchClinicDataWithInput(q);
			/* Empty search box */ //Fix J-137, move to clinicPreload()
			//$("#clinic-search-input").val("");
			/* Hide clinic search box */
			if(appView)
				appView.clinicSearchHide();
		}else{
			jAlert("Enter a valid address","Please Try Again");
		}
	},
	
	showMapView: function(e) {

		e.preventDefault();
		/* hide the filter layer */
		$("#clinic-store-service-filter").slideUp("normal");
        /* hide the search layer */
		appView.clinicSearchHide();
        /* Hide button */
		$("#clinic-map-view").addClass("locator-menu-hide");	

		/* Show map */
		$("#clinic-page").removeClass("clinic-page-list-view").addClass("clinic-page-map-view");
		
		/* Check if need go back first */
		if(location.hash === "#direction-page"){
			/* Show list view button */
			$("#clinic-list-view").removeClass("locator-menu-hide");
			
			if(this.directionFromListView){
				/* Previous page is list view, go back to map view without worrying about detail page */
                this.directionFromListView = false;
				appView.goBack();
			}else{
				/* Previous page is detail view, need to bypass detail page */
				appView.goBack(2);
			}
			
		}else if(location.hash === "#clinic-detail-page"){
            // buttons' show and hide are handled in Fake_Router.js clinicPreload()

            var id="#clinic-page";
            $.mobile.changePage(id, {transition: 'slide'});

            setTimeout(function(){
                if(clinicStoreDetailPage.model){
                    clinicListMapView.setDetailPageModel(clinicStoreDetailPage.model);
                }
                clinicListMapView.showMapFromDetailPage();
            },200);
            appView.currentPage = id;
          
		}else {
			$("#clinic-list-view").removeClass("locator-menu-hide");
			
			$("#clinic-detail-view").addClass("locator-menu-hide");
//			$("#my-clinic").show();
			$("#clinic-locator-menu ul li[class='locator-first']").css("visibility","visible");
			$("#clinic-show-direction").addClass("locator-menu-hide");

			
			/* Show map */
		    clinicListMapView.showMap();
		}
        		
		/* Show map */
//		$("#clinic-page").removeClass("clinic-page-list-view").addClass("clinic-page-map-view");
		
		
	},
	
	showListView: function(e) {
		
        if ((e)) {
            e.preventDefault();
        }

        /* hide the filter layer */
		$("#clinic-store-service-filter").slideUp("normal");
        /* hide the search layer */
		appView.clinicSearchHide();
		

		$("#clinic-page").removeClass("clinic-page-map-view").addClass("clinic-page-list-view");
		
		$("#clinic-map-view").removeClass("locator-menu-hide");
		$("#clinic-list-view").addClass("locator-menu-hide");	
	},

	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#clinic-page-info").popup( "option", "history", false );
		$("#clinic-page-info").popup({ transition: "pop" });
		$("#clinic-page-info").popup("open");
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#clinic-page-info").popup("close");
	},

    /* Set appView object */
	setApp: function(app){
		this.appView = app;
	}
});