var ClinicStoreDetailView = Backbone.View.extend({
	
	el: $("#clinic-detail-page"),
	
	template: Handlebars.compile($("#clinic-locator-detail-template").html()),
	
	events: {
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
    },
    
    initialize: function () {
    	this.fromMapPageState = false;
    },
    fromMapPage : function(state){
    	
    	this.fromMapPageState = state;
    },
	render: function () {
		this.$el.find("ul").html(this.template(this.model.toJSON()));
		this.getToday("#clinic_open_close",this.model.toJSON().ClinicHours);
		
        this.showStoreHours("#detail-clinic-hours",this.model.toJSON().ConsolidatedClinicHours);
        this.showFax("#detail-clinic-hours",this.model.toJSON().FaxNumber);
		//this.formatDistance();
		if(!this.detailScroller){
			this.detailScroller = new iScroll("clinic-locator-detail-div", {hScroll:false, vScroll:true, vScrollbar: true, hScrollbar: false, fadeScrollbar: true, hideScrollbar:true });
		}else{
			this.detailScroller.refresh();
		}

		 console.log(JSON.stringify(this.model));

		this.checkCurrentStore();
		
		return this;
	},
	
	setModel: function(model) {
		this.model = model;
	},

    /* set .preferred class to current view */
    setPreferred: function(){
        this.$el.find(".detail-address-section").addClass("preferred");
    },

    /* remove .preferred class from current view */
    removePreferred: function(){
        this.$el.find(".detail-address-section").removeClass("preferred");
    },

	/* Check whether the store is current store and change the set as My Store button to orange */
	checkCurrentStore: function() {
		if(this.model && this.model.get("isPreferredClinic") == true ){
            this.setPreferred();
//			this.$el.find("#clinic-detail-address-make-default").css({"background-color": "#C72238"});
//			this.$el.find("#clinic-detail-address-make-default").find("p").css({"color": "white"});
//			this.$el.find("#detail-address-phone-p").find("img").attr("src", "image/store-locator-image/clinic-location-details-phone.png");
		}else{
            this.removePreferred();
        }

       
		
	},
	
//	formatDistance: function() {
//		var long = this.$el.find("#detail-address-distance").html();
//		this.$el.find("#detail-address-distance").html(parseFloat(long).toFixed(2) + " KM");
//	},
	
	getToday: function (id,storeHours) {
		var today = new Date();
		
		var day = today.getDay();
		
		if (!(storeHours.MondayOpen || storeHours.TuesdayOpen || storeHours.WednesdayOpen || storeHours.ThursdayOpen 
		   || storeHours.FridayOpen || storeHours.SaturdayOpen || storeHours.SundayOpen)){

            // hide store open/close indicator if the clinic hours is not provided
            this.$el.find('.detail-hours-section-open-close').css('opacity', '0');

			this.$el.find(id).html("&nbsp;");
			return;
		}
		var start, end;
		switch(day)
			{
			case 1:
				if(storeHours.MondayOpen){
					start = storeHours.MondayOpen;
					end = storeHours.MondayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 2:
				if(storeHours.TuesdayOpen){
					start = storeHours.TuesdayOpen;
					end = storeHours.TuesdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 3:
				if(storeHours.WednesdayOpen){
					start = storeHours.WednesdayOpen;
					end = storeHours.WednesdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 4:
				if(storeHours.ThursdayOpen){
					start = storeHours.ThursdayOpen;
					end = storeHours.ThursdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 5:
				if(storeHours.FridayOpen){
					start = storeHours.FridayOpen;
					end = storeHours.FridayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 6:
				if(storeHours.SaturdayOpen){
					start = storeHours.SaturdayOpen;
					end = storeHours.SaturdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 0:
				if(storeHours.SundayOpen){
					start = storeHours.SundayOpen;
					end = storeHours.SundayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			default:
				start = -1;
				return "&nbsp;" + "&nbsp;-&nbsp;";
			}
		this.getOpen(start, end,id);
		
	},
	
	/*
	 * Determine while this store is currently open or not
	 */
	getOpen: function(start, end,id){
		if(start < 0){
			/* if not open at all */
			return;
		}
		
		/* Store end time */
		var finalEnd = end;
		/*check 12:00 AM*/
		var checkStore12AMStatus = checkStore12AM(start);
		if(checkStore12AMStatus){
			start = "00:00AM";
		}
		start = start.substr(0, start.length-2);
		end = end.substr(0, end.length-2);
		
		var s = start.split(":");
		var e = end.split(":");
	
		/* Create date with arbitrary year and month to compare time */
		var ss=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(s[0]),parseInt(s[1]),parseInt("0"));
		/* Afternoon time, need to revise parse ! */
		var ee=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(e[0]) + 12,parseInt(e[1]),parseInt("0"));
		var current = new Date();
		var cc = new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),current.getHours(), current.getMinutes(),parseInt("0"));
		
		/* Output result */
		if(ss.valueOf() < cc.valueOf() && cc.valueOf() < ee.valueOf()){
			this.$el.find(id).html("OPEN");
		}else{
			this.$el.find(id).html("CLOSED");
		}
	},
	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#clinic-detail-page-info").popup( "option", "history", false );
		$("#clinic-detail-page-info").popup({ transition: "pop" });
		$("#clinic-detail-page-info").popup("open");
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#clinic-detail-page-info").popup("close");
	},
	
	containsStr : function(str,substr,isIgnoreCase){
		if(isIgnoreCase)
		{
		 str=str.toLowerCase();
		 substr=substr.toLowerCase();
		}
		var startChar=substr.substring(0,1);
		var strLen=substr.length;
		for(var j=0;j<str.length-strLen+1;j++)
		{
			if(str.charAt(j)==startChar)
			{
				if(str.substring(j,j+strLen)==substr)
				{
					return true;
				}  
			}
		}
		return false;
	},
	
	showStoreHours : function(id,consolidatedHours){
		if(!consolidatedHours){
			return;
		}
		var hours = consolidatedHours.split("|");
		var result = "";
		for(var i=0;i<hours.length;i++){
			//result = "<tr><td class='consolidated-hours'>"+this.splitHoursStr(hours[i])+"</td></tr>";
			if(this.containsStr(hours[i],"12:00 AM - 11:59 PM",true)){
				result = "<li>"+this.splitHoursStr(hours[i].replace("12:00 AM - 11:59 PM","24 Hours"))+"</li>";
			}else{
				result = "<li>"+this.splitHoursStr(hours[i])+"</li>";
			}
			$(id).append(result);
		}
	},
	 splitHoursStr : function(str){
		   var newStr = '';
		   if(str&&str.indexOf(":")!=-1){
			   var index = str.indexOf(":");
			   newStr = str.substring(0,index)+' :'+str.substring(index+1,str.length);
			}
		   if(newStr!=''){
			   return newStr;
		   }else{
			   return str;
		   }
		},

    showFax : function(id,fax){
		if(!fax){
			return;
		}

		result = "<li>&nbsp;</li><li>Fax #: "+fax+"</li>";
		$(id).append(result);
		
	}
});