var CommunicationView = Backbone.View.extend({
	
	el: $("#CommunicationPreferences-page"),
	
	events: {
		"tap #update-communication-preference"	: "update",
		"tap .rexall-page-header-info"			: "showInfo",
		"tap .rexall-page-info-popup-close"		: "closeInfo",
	},
	
    initialize: function() {
        /* Set up the scroller */
        this.scroll = new iScroll("communication-scroll", {
            hScroll:false, 
            vScroll:true, 
            vScrollbar: true, 
            hScrollbar: false, 
            fadeScrollbar: true, 
            hideScrollbar:true,
            onBeforeScrollStart: function (e) { 
                var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
                if (nodeType != 'select' && nodeType != 'option' && nodeType != 'input' && nodeType != 'textarea') {
                    e.preventDefault(); 
                }
                else {	/* Auto scroll up for the input field */
                    var selfScroll = this;
							
                    /* Set a 1 sec time out to allow the soft keyboard show up first */
                    setTimeout(function() { 
                        var top = 170;		/* maximium ceiling of pageY */
                        var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
															
                        /* Determine whether auto scroll is required in this event */
                        if (y > top) {
                            /* Calculation moving distance */
                            var moveD = top - y;
                            /* Actual moving position */
                            var actualMove = selfScroll.y + moveD;
                            /* Remeber the position before auto scroll */
                            selfScroll.autoScrollLastPos = selfScroll.y;
                            /* Auto scroll up */
                            selfScroll.scrollTo(0, actualMove);
                        }	
                    }, 800);
                }
            }
        });
		
        /* Set up popup information scroller */
        this.infoScroll = new iScroll("communication-info-scroll", {
            hScroll:false, 
            vScroll:true, 
            vScrollbar: true, 
            hScrollbar: false, 
            fadeScrollbar: true, 
            hideScrollbar:true,
        });
			
        this.render();
    },
	
	/* Render communication preferences page */
	render: function() {
		var profile = JSON.parse(localStorage.getItem("JanRainLogin"));
		/* Double existence of Janrain profile */
        //console.log(JSON.stringify(profile));
		if(!profile) return;
		/* Airmiles number */
		$("#airmiles_number").val(profile.LoyaltyNumber ? profile.LoyaltyNumber : " ");
		/* Home province */
		$("#home_province").val(profile.HomeProvince ? profile.HomeProvince : 'ChooseFromList');
		/* Health information */
		$('#healthinformation').prop('checked', profile.healthinformation);
		/* Promotion consent */
		$('#opt_in_for_promotions').prop('checked', profile.PromotionConsent);
		
		/* Clean up warning */
		$(".rexall-warning-label").removeClass("rexall-warning-label");
	},
	
	/* Validate update input */
	validate: function() {
		var result = true;
		
		if(!$("#home_province").val() || $("#home_province").val() == "ChooseFromList"){
			$("label[for='home_province']").addClass("rexall-warning-label");
			result &= false;
		}else{
			$("label[for='home_province']").removeClass("rexall-warning-label");
		}
		
		return result;
	},
	
	/* Update communication preferences */
	update: function() {
		/* Validate input */
		if(!this.validate())
			return;
		/* use janrain login to update */
		this.model.update({'LoyaltyNumber'		: $("#airmiles_number").val(),
							'HomeProvince'      : $("#home_province").val(),
							'PromotionConsent'  : $('#opt_in_for_promotions').prop('checked'),
							'healthinformation' : $('#healthinformation').prop('checked'),
							});
	},
		
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
        if(cordova.plugins.Keyboard.isVisible){
            $('input').blur();  // unfocus input
            cordova.plugins.Keyboard.close();   // close keyboard

            var self = this;
            setTimeout(function(){  // set a 0.5 sec delay to allow keyboard close first
                $("#CommunicationPreferences-page-info").popup("option", "history", false);
                $("#CommunicationPreferences-page-info").popup({ transition: "pop" });
                $("#CommunicationPreferences-page-info").popup("open");
                self.infoScroll.refresh();
            }, 500);
        }else {
            $("#CommunicationPreferences-page-info").popup("option", "history", false);
            $("#CommunicationPreferences-page-info").popup({ transition: "pop" });
            $("#CommunicationPreferences-page-info").popup("open");
            this.infoScroll.refresh();
        }
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#CommunicationPreferences-page-info").popup("close");
	}
});