var ContactUsView = Backbone.View.extend({
	
	el: "#feedback-page",
	
	events: {
		"tap #contact-us-submit"	: "submitFeedback",
		"tap #contact-us-continue"	: "submitFeedbackContinue",
	},
	
    initialize: function () {
        /* Listen to login model */
        this.listenTo(janrainLogin, "change:hasLogin", this.render);
		this.fromValidateLogin = false;
		
        /* Set up the scroller */
        this.scroll = new iScroll("contact-us-scroll", {
            hScroll:false, 
            vScroll:true, 
            vScrollbar: true, 
            hScrollbar: false, 
            fadeScrollbar: true, 
            hideScrollbar:true,
            onBeforeScrollStart: function (e) { 
        	 	setInputmaskPostalCode("contact-us-zip");
//        		$("#contact-us-number").inputmask("mask", {"mask": "(999) 999-9999"});
//        		$("#contact-us-zip").inputmask( {"mask": "a9a 9a9"}); 
        		//$("#contact-us-email").inputmask("mask",  {"mask": "{1,30}@{1,30}.{3}[.{2}]"}); 
        		var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
                if (nodeType != 'select' && nodeType != 'option' && nodeType != 'input' && nodeType != 'textarea') {
                    //e.preventDefault();
                }
                else {	/* Auto scroll up for the input field */
                    var selfScroll = this;
					var currentY = 	selfScroll.y;	
                    /* Set a 1 sec time out to allow the soft keyboard show up first */
                    setTimeout(function() { 
                        var top = 170;		/* maximium ceiling of pageY */
                        var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
															
                        /* Determine whether auto scroll is required in this event */
                        if (y > top) {
                            /* Calculation moving distance */
                            var moveD = top - y;
                            /* Actual moving position */
                            var actualMove = selfScroll.y + moveD;
                            /* Remeber the position before auto scroll */
                            selfScroll.autoScrollLastPos = selfScroll.y;
                            //auto scroll only when user is NOT intent on scrolling
                            if (Math.abs(currentY - selfScroll.y) < 10) 
                            {
                                /* Auto scroll up */
                                selfScroll.scrollTo(0, actualMove);
                            }
                        }	
                    }, 800);
                }
            },
            scrollStart: function (e)
            {

            }

        });
		
        /* Prerender */
        this.render();
    },
	
	render: function () {
        $("#contact-us-spinner").css("visibility", "hidden");

        if(localStorage.getItem("JanRainLogin")&&profile.hasProfile&&profile.hasRecord())
        {
            $("#contact-us-nologin-fields").hide();
        }
        else
         {
            $("#contact-us-nologin-fields").show();
        }
		if(this.fromValidateLogin)
		  {
		  this.fromValidateLogin = false;
          this.scroll.refresh();
		  $("#contact-us-submit").hide();
  	      $("#contact-us-continue").show();       
		  $.alerts._hide();
		  }
        else
        {
        this.scroll.refresh();
		$("#contact-us-submit").show();
  	    $("#contact-us-continue").hide();       
         }
	},

    /* Validate update input */
	validate: function() {
		var result = true;
		if(!localStorage.getItem("JanRainLogin")||!profile.hasProfile||!profile.hasRecord())
        {
            if(!$("#contact-us-fname").val().length > 0)
            {
                $("label[for='contact-us-fname']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-fname']").removeClass("rexall-warning-label");}

           if(!$("#contact-us-lname").val().length > 0)
            {
                $("label[for='contact-us-lname']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-lname']").removeClass("rexall-warning-label");}

            if(!$("#contact-us-address").val().length > 0)
            {
                $("label[for='contact-us-address']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-address']").removeClass("rexall-warning-label");}

            if(!$("#contact-us-city").val().length > 0)
            {
                $("label[for='contact-us-city']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-city']").removeClass("rexall-warning-label");}

			var contactPhoneLength = $("#contact-us-number").val().length;
            if(!(contactPhoneLength == 0 || contactPhoneLength == 14))
            {
                $("label[for='contact-us-phone']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-phone']").removeClass("rexall-warning-label");}

            if($("#contact-us-province").val() == "ChooseFromList")
            {
                $("label[for='contact-us-province']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-province']").removeClass("rexall-warning-label");}

            //if($("#contact-us-zip").inputmask('unmaskedvalue').length != 6)
            if($("#contact-us-zip").val().length != 7)
            {
                $("label[for='contact-us-zip']").addClass("rexall-warning-label");
                result &= false;
            }
            else{$("label[for='contact-us-zip']").removeClass("rexall-warning-label");}

            
            if($("#contact-us-email").val().length < 0)
            {
                $("label[for='contact-us-email']").addClass("rexall-warning-label");
                result &= false;
			}else{
		 		if (!this.validateEmail($("#contact-us-email").val()))
					{$("label[for='contact-us-email']").addClass("rexall-warning-label");
						result &= false;
		      }else{			
		     $("label[for='contact-us-email']").removeClass("rexall-warning-label");
   		     }
          }
		}

        if($("#feedback-topic-selection").val() == "ChooseFromList")
        {
            $("label[for='feedback-form-existing-topic']").addClass("rexall-warning-label");
            result &= false;
        }
        else{$("label[for='feedback-form-existing-topic']").removeClass("rexall-warning-label");}

        if($("#feedback-patient-Message").val().length < 1)
        {
            $("label[for='feedback-patient-Message']").addClass("rexall-warning-label");
            result &= false;
        }
        else{$("label[for='feedback-patient-Message']").removeClass("rexall-warning-label");}

        

		return result;
	},

    /* Submit  request */
	submitFeedback: function(e) {
	    if (this.validate())
        {
            //alert("validaded");
		    var contactUs = new ContactUs();
		    contactUs.requestContactUs(true);
        }else{
        	jAlert("Correct the information highlighted in red.","Please Try Again");
        }
	},
    /* Submit  request */
	submitFeedbackContinue: function(e) {
	    if (this.validate())
        {
            //alert("validaded");
		    var contactUs = new ContactUs();
		    contactUs.requestContactUs(false);
            var id = "#menu-page";
            $.mobile.changePage(id, {transition: 'slide'});	
        }else{
        	jAlert("Correct the information highlighted in red.","Please Try Again");
        }
	},
	
	/* Cleanup input fields */
	cleanUp: function() {
		this.$el.find("input").val("");
		this.$el.find("textarea").val("");
		this.$el.find("select").val("ChooseFromList");
        $("label[for='contact-us-fname']").removeClass("rexall-warning-label");
        $("label[for='feedback-patient-Message']").removeClass("rexall-warning-label");
        $("label[for='feedback-form-existing-topic']").removeClass("rexall-warning-label");
        $("label[for='contact-us-email']").removeClass("rexall-warning-label");
        $("label[for='contact-us-province']").removeClass("rexall-warning-label");
        $("label[for='contact-us-city']").removeClass("rexall-warning-label");
        $("label[for='contact-us-address']").removeClass("rexall-warning-label");
        $("label[for='contact-us-lname']").removeClass("rexall-warning-label");
        $("label[for='contact-us-zip']").removeClass("rexall-warning-label");
//        $("#contact-us-number").inputmask("mask", {"mask": "(999) 999-9999"});
	},
	
	validateEmail: function(email) { 
  // http://stackoverflow.com/a/46181/11236
  
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
	},
	
	setFromValidateLogin: function(state) { 
	this.fromValidateLogin = state;
	},
});