var EnrolmentConfirmView = Backbone.View.extend({
	
	el: $("#enrolment-confirm-page"),
	
	events: {
		"tap #enrolment-confirm-continue"	: "go",
		"tap #enrolment-confirm-cancel"		: "cancel",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		/* Setup page scroller */
		this.scroll = new iScroll("enrolment-confirm-scroll",{

			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			onBeforeScrollStart: function (e) { 
				setHTML5DateFormat("enrolment-confirm-birthdate");
				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */				
					var selfScroll = this;					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 220;//170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}						
					}, 800);					
				} 
				},
			});
	},
	
	/* Go to verify page */
	go: function(e) {
		
		e.preventDefault();
		
		/* Validate input */
		if(!this.validate())
			return;

		/**
		 * CREATE WEB SERVICE MODEL INSTANCE HERE
		 */
		enrolment.confirmActivationCode();
	},
	
	cancel: function() {
		
	},
	
	/* Validate input */
	validate: function() {

		valid = true;	

		/* Check Activation code */
		if($("#enrolment-confirm-code").val().length != 4 && $("#enrolment-confirm-code").val().length != 8){
			$("label[for='enrolment-confirm-code']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-confirm-code']").removeClass("rexall-warning-label");
		}
		
		/* Check rx */
		if($("#enrolment-confirm-rx").val().length <= 0 ){
			$("label[for='enrolment-confirm-rx']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-confirm-rx']").removeClass("rexall-warning-label");
		}
		
		/* Check birthdate */
		var birthDate = getHTML5Date("enrolment-confirm-birthdate");
		if(getHTML5DateLength("enrolment-confirm-birthdate")!= 8||!appView.checkDateOfBirth(birthDate)){
			$("label[for='enrolment-confirm-birthdate']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-confirm-birthdate']").removeClass("rexall-warning-label");
		}
		
		/* Error */
		if(!valid){
			jAlert("Correct the information highlighted in red.","Please Try Again");
		}
		
		return valid;
		
	},
	
	/* reset input fields */
	resetRender: function() {
		/* remove warning */
		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
		/* clean input fields */
		this.$el.find("input").val("");
		setHTML5DateFormat("enrolment-confirm-birthdate");
		
	},
	
	/* Show refill page information pop up */
	showInfo: function(e) {

		e.preventDefault();

		/* Open information box */
		$("#enrolment-confirm-page-info").popup( "option", "history", false );
		$("#enrolment-confirm-page-info").popup({ transition: "pop" });
		$("#enrolment-confirm-page-info").popup("open");

	},

	/* Close information */
	closeInfo: function(e) {

		e.preventDefault();

		$("#enrolment-confirm-page-info").popup("close");

	},
});