var EnrolmentRequestView = Backbone.View.extend({
	
	el: $("#enrolment-request-page"),
	
	events: {
		"tap #enrolment-request-continue"	: "request",
		"tap #enrolment-request-search-phone"	: "searchByPhone",
		"tap #enrolment-request-search-location": "searchByLocation",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		/* Setup page scroller */
		this.scroll = new iScroll("enrolment-request-scroll",{

			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			onBeforeScrollStart: function (e) { 
			setHTML5DateFormat("enrolment-request-birthdate");
//			$("#enrolment-request-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
				
				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */				
					var selfScroll = this;					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 220;//170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}						
					}, 800);					
				} 
				}
			});

        /* Set up popup information scroller */
		this.infoScroll = new iScroll("enrolment-request-page-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
	},
	
	/* Show refill page information pop up */
	showInfo: function(e) {

		e.preventDefault();

		/* Open information box */
        if(cordova.plugins.Keyboard.isVisible){
            $('input').blur();  // unfocus input
            cordova.plugins.Keyboard.close();   // close keyboard

            var self = this;
            setTimeout(function(){  // set a 0.5 sec delay to allow keyboard close first
                $("#enrolment-request-page-info").popup("option", "history", false);
                $("#enrolment-request-page-info").popup({ transition: "pop" });
                $("#enrolment-request-page-info").popup("open");
            }, 500);
        }else {
            $("#enrolment-request-page-info").popup("option", "history", false);
            $("#enrolment-request-page-info").popup({ transition: "pop" });
            $("#enrolment-request-page-info").popup("open");
        }

	},

	/* Close information */
	closeInfo: function(e) {

		e.preventDefault();

		$("#enrolment-request-page-info").popup("close");

	},
	
	/* Send request */
	request: function(e) {
		
		e.preventDefault();
		
		/* Validate input */
		if(!this.validate())
		return;
		
		/**
		 * CREATE WEB SERVICE MODEL INSTANCE HERE
		 */
		enrolment.requestActivationCode();
		
	},
	
	/* Validate input */
	validate: function() {
		
		var valid = true;
		var flag = 0;
		
		/* Check rx */
		if($("#enrolment-request-rx").val().length <= 0 ){
			$("label[for='enrolment-request-rx']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-request-rx']").removeClass("rexall-warning-label");
		}
		/* Check birthdate */
		var birthDate = getHTML5Date("enrolment-request-birthdate");
		if(getHTML5DateLength("enrolment-request-birthdate") != 8||!appView.checkDateOfBirth(birthDate)){
			$("label[for='enrolment-request-birthdate']").addClass("rexall-warning-label");
			valid &= false;
		}else{
		    var dateInput = getHTML5Date("enrolment-request-birthdate");
		    var d = new Date();
			var yr18=new Date();
			var n = yr18.getFullYear()-18;
			yr18.setFullYear(n,yr18.getMonth(),yr18.getDate());
			var d1 = dateInput.substring(0,2);
			var d2 = dateInput.substring(3,5);
			var d3 = dateInput.substring(6,10);
			d.setFullYear(d3,d2-1,d1);
			if (d>yr18)
 			{  
				$("label[for='enrolment-request-birthdate']").addClass("rexall-warning-label");
				valid &= false;
				flag = 1;
 			}else{
			$("label[for='enrolment-request-birthdate']").removeClass("rexall-warning-label");
			}
		}
		
		/* Check address */ 
		if($("#enrolment-request-location-result").val() == null
			|| $("#enrolment-request-location-result").val().length <= 0 
			|| $("#enrolment-request-location-result").val() == "ChooseFromList"){
			$("label[for='enrolment-request-location-result']").addClass("rexall-warning-label");
			$("label[for='enrolment-request-location']").addClass("rexall-warning-label");			
			valid &= false;
		}else{
			$("label[for='enrolment-request-location-result']").removeClass("rexall-warning-label");
			$("label[for='enrolment-request-location']").removeClass("rexall-warning-label");
		}
		
		
		/* Error */
		if(!valid&&flag==1){
			jAlert("You must be at least 18 years of age to request to view your Medication Record online.","Please Try Again");
		}else if(!valid&&flag==0){
			jAlert("Correct the information highlighted in red.","Please Try Again");
		}
		
		return valid;
	},
	
	/* Search pharmacy location by phone */
	searchByPhone: function() {
		
	
		/* Clean up the history list first */
		$("#enrolment-request-location-result").html('<option value="ChooseFromList">Choose from the list below</option>');

		/* Read in phone number */
		var contactPhoneLength = $("#enrolment-request-phone").val().length;
        if(!(contactPhoneLength == 14))
        	{
            	$("label[for='enrolment-request-phone']").addClass("rexall-warning-label");
                $.alerts.alert("The phone number is invalid.", "Please Try Again");
            }
            else{$("label[for='enrolment-request-phone']").removeClass("rexall-warning-label");
			var phoneInput = $("#enrolment-request-phone").val();		
			var p1 = phoneInput.substring(1,4);
			var p2 = phoneInput.substring(6,9);
			var p3 = phoneInput.substring(10,14);
		
			/* Construct phone number query string */
			var phoneNumber = p1 + "-" + p2 + "-" + p3;
			/* Create a new store collection */
			var searchResult = new StoreDetailList();
			/* Create view */
			this.enrolmentStoreList = new RefillStoreListView({"collection" : searchResult});
			this.enrolmentStoreList.setEl("#enrolment-request-location-result");

			/* Fetch data */
			searchResult.fetchDataWithPhone(phoneNumber);
			$("#enrolment-request-location-input").val("");
			//$("#enrollment-form-to-select").show();
			this.scroll.refresh();
		}
	},
	
	/* Search pharmacy location by location */
	searchByLocation: function() {

		/* Get search query */
		var q = $("#enrolment-request-location-input").val();

	    if (!q){
	    	jAlert("Enter a valid address.","Please Try Again");
	    	return;
	    }
        //Take out the phone number warning lable.
        $("label[for='enrolment-request-phone']").removeClass("rexall-warning-label")

		/* Clean up the history list first */
		$("#enrolment-request-location-result").html("");

		/* Create a new store collection */
		var searchResult = new StoreDetailList();

		/* Create view */
		this.enrolmentStoreList = new RefillStoreListView({"collection" : searchResult});
		this.enrolmentStoreList.setEl("#enrolment-request-location-result");
		
		/* Fetch data */
		searchResult.fetchDataWithInput(q);

		/* Show the selections */
		var result = "";
		result = "<option value='ChooseFromList' >Choose from the list below</option>";

		$("#enrolment-request-location-result").prepend(result);
        $("#enrolment-request-phone").val("");
    	//$("#enrollment-form-to-select").show();
        this.scroll.refresh();
	},
	
	/* reset input fields */
	resetRender: function() {
		if(janrainLogin.get("hasLogin") && localStorage.getItem("JanRainLogin")){
			/* Logged in */
			$("#enrolment-request-popup-users-signed-in").show();
			$("#enrolment-request-popup-users-not-signed-in").hide();

		}else{
			/* not Logged in */
			$("#enrolment-request-popup-users-signed-in").hide();
			$("#enrolment-request-popup-users-not-signed-in").show();
		}
		/* remove warning */
		$("#enrollment-form-to-select").hide();
		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
		/* clean input fields */
		this.$el.find("input").val("");
		getHTML5DateLength("enrolment-request-birthdate");
//		$("#enrolment-request-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
		/* Clean up the history list */
		$("#enrolment-request-location-result").html('<option value="ChooseFromList">Choose from the list below</option>');
		this.$el.find("select").val("ChooseFromList");
	},
});