var EnrolmentVerifyView = Backbone.View.extend({
	
	el: $("#enrolment-verify-page"),
	
	events: {
		"tap #enrolment-verify-complete"	: "complete",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		
		/* Setup page scroll */
		/* Setup page scroller */
		this.scroll = new iScroll("enrolment-verify-scroll",{

			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			onBeforeScrollStart: function (e) { 
				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */				
					var selfScroll = this;					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 220;//170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}						
					}, 800);					
				} 
				},
			});
		
	},
	
	/* Complete the whole enrolment process */
	complete: function() {
		
		/* Validate input */
		if(!this.validate())
			return;

		/**
		 * CREATE WEB SERVICE MODEL INSTANCE HERE
		 */
//		enrolment.validatePhone(
//			enrolment.validatePostalCode(
//			   enrolment.postVerification()
//			)
//		);
		enrolment.postVerification();
		/* Reset form */
//		if(enrolmentVerifyView){
//			enrolmentVerifyView.resetRender();
//		}
		
	},
	
	/* Validate input */
	validate: function() {
		
		valid = true;	
        var serverValid = true;
		/* Check question1 */
		if($("#enrolment-verify-question1").val() == null
				|| $("#enrolment-verify-question1").val().length <= 0 
				|| $("#enrolment-verify-question1").val() == "ChooseFromList"){
				$("label[for='enrolment-verify-question1']").addClass("rexall-warning-label");
				valid &= false;
			}else{
				$("label[for='enrolment-verify-question1']").removeClass("rexall-warning-label");
			}
		/* Check question1 */
		if($("#enrolment-verify-question2").val() == null
				|| $("#enrolment-verify-question2").val().length <= 0 
				|| $("#enrolment-verify-question2").val() == "ChooseFromList"){
				$("label[for='enrolment-verify-question2']").addClass("rexall-warning-label");
				valid &= false;
			}else{
				$("label[for='enrolment-verify-question2']").removeClass("rexall-warning-label");
			}
		
		/* Check phone number */
		enrolment.validatePhone();
		/* Check postal code */
		enrolment.validatePostalCode();
		
		if(!enrolment.PhoneNumCheckState){
			//phone number fail
			$("label[for='enrolment-verify-question1']").addClass("rexall-warning-label");
			jAlert("Check phone number.","Please Try Again");
			valid &= false;
            serverValid = false;
		}else{
			$("label[for='enrolment-verify-question1']").removeClass("rexall-warning-label");
		}
		if(!enrolment.PostalCodeCheckState){
			//Postal Code fail
			$("label[for='enrolment-verify-question2']").addClass("rexall-warning-label");
			jAlert("Check postal code.","Please Try Again");
			valid &= false;
            serverValid = false;
		}else{
			$("label[for='enrolment-verify-question2']").removeClass("rexall-warning-label");
		}
		/* Error */
		if(!valid){
          
            jAlert("The phone number and postal code combination that you submitted was not valid. " + 
			"Please contact Rexall Customer Service at 1-877-378-4100 or " +
			 "<a class=\"light-teal\" href=\"#\" onclick='gotoFeedbackPage()' data-transition=\"slide\">click here</a>.","Something Went Wrong", function()
             {
                if (!serverValid)
                {
                  appView.goHomePage();
                }
             });
		}
		
		return valid;
		
	},
	
	/* reset input fields */
	resetRender: function() {
		/* remove warning */
		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
		$("#enrolment-verify-question1").html('<option value="ChooseFromList">Choose from the list below</option>');
		$("#enrolment-verify-question2").html('<option value="ChooseFromList">Choose from the list below</option>');
		this.$el.find("select").val("ChooseFromList");
	},
	
	/* Show verify page information pop up */
	showInfo: function(e) {

		e.preventDefault();

		/* Open information box */
		$("#enrolment-verify-page-info").popup( "option", "history", false );
		$("#enrolment-verify-page-info").popup({ transition: "pop" });
		$("#enrolment-verify-page-info").popup("open");

	},

	/* Close information */
	closeInfo: function(e) {

		e.preventDefault();

		$("#enrolment-verify-page-info").popup("close");

	},
	render:function(){
		enrolment.getPhoneDropdown();
		enrolment.getPostalCodeDropdown();
	},
});

/* go to feedback-page */
function gotoFeedbackPage(){
	$.alerts._hide();
	var id = "#feedback-page";
	$.mobile.changePage(id, {transition: 'slide'});	
	appView.currentPage = id;
}