var LoginView = Backbone.View.extend({
	
	el : $("#login-page"),
	
	events: {
		"tap #login-submit" 	: "loginToJanRain",
		"tap #logout-submit"	: "logoutJanRain",
	},
	
	initialize: function() {
		/* Set from refill page */
		this.state = false;
		this.fromRefill = false;
		this.fromTransfer = false;
        this.fromRecord = false;
        this.fromRefillbyNumber = false;
        this.fromRefillbyNumberFromStoreLocator = false;
        this.goToEnrolmentPageStatus = true;
        this.enrolmentPageId = null;
		/* Listen to login event */
		this.listenTo(this.model, 'change:hasLogin', this.render);
		
		/* Predefine remember password or not */
		if(!localStorage.getItem("Rexall-remember-user"))
			localStorage.setItem("Rexall-remember-user", 0);	/* Default not remember */
		
		/* Setup page */
		this.render();

	
		/**
		 * Debug mode */
//		$("#onoff").val("1");
//		$("#login-email").val("maguiar@propharm.com");
//		$("#login-password").val("vgemsvgems9$");
//		$("#old_password").val("vgemsvgems9$"),
//		$("#new_password").val("vgemsvgems9$"),
//		$("#confirm_password").val("vgemsvgems9$");
		/* *********** */
	},
	
	setApp: function(app) {
		this.appView = app;
	},

    /* Validate login input */
	validateLoginInput: function() {
		var result = true;
		
		/* Validate email */
		if($("#login-email").val().length <= 0){
			$("label[for=login-email]").addClass("rexall-warning-label");
			result &= false;
		}else{
			$("label[for=login-email]").removeClass("rexall-warning-label");
		}
		
		/* Validate password */
		if($("#login-password").val().length <= 0){
			$("label[for=login-password]").addClass("rexall-warning-label");
			result &= false;
		}else{
			$("label[for=login-password]").removeClass("rexall-warning-label");
		}
		return result;
	},
	
	/* Login to JanRain */
	loginToJanRain: function (e) {
		e.preventDefault();

//	$("#login-master-form").validationEngine('attach',{
//             promptPosition : "topLeft"
//             ,scroll: true
//             ,autoPositionUpdate : true
//             ,focusFirstField : true
//       		});
//	if ($("#login-master-form").validationEngine('validate'))
		if(this.validateLoginInput() == true){
			var email = $("#login-email").val();
			var password = $("#login-password").val();
			
			/* Check if need to remeber password */
			if($("#onoff").val() == 1){
				localStorage.setItem("Rexall-user-login", email);
				localStorage.setItem("Rexall-user-credential", password);
				localStorage.setItem("Rexall-remember-user", 1);
				}

            /* Pass input to model to handle the login */
            this.model.login(
                {"email":email, "password":password},
                function(){     // call back function
                    janrainLogin.getLoginProfile(function(){    // retrieve login profile right after login
                    loginView.goToEnrolmentPage();          // goToEnrollment Page if applicable after retieving login profile
                    });
                }
            );
			//this.isLogin();
        }
	},
	
	/* Logout JanRain */
	logoutJanRain: function (e) {
		e.preventDefault();
//		/* Remove janrain respose */
//		localStorage.removeItem("JanRainLogin");
//		/* change model */
//		this.model.set({hasLogin: false});
//		this.isLogin();
		
		/* Ask model to handle the logout */
		this.model.logout();
	},
	
	render: function () {
		this.goToTransferPage = false;
		this.goToSettingsPage = false;
		if(this.model.get("hasLogin")){
           
			/* Show logout page */
//			this.$el.removeClass("not-logged").addClass("logged");
			
			console.log("ligin view render: fromTransfer=" + this.fromTransfer.toString() + " this.fromRecord =" + this.fromRecord.toString() + " this.fromRefill=" + this.fromRefill.toString() + " this.fromRefillbyNumber=" + this.fromRefillbyNumber.toString());
           // console.log(JSON.stringify(localStorage.getItem("JanRainLogin")));
			/* goBack to previous page*/
			if((location.hash == "#login-page"&&!this.state)||
				location.hash == "#enrolment-request-page"||location.hash == "#enrollment-medication-record-info-page"||
				location.hash == "#enrolment-confirm-page"||
				location.hash == "#enrolment-verify-page"){
				if(!this.goToEnrolmentPageStatus){
				//appView.goBack();
		
					if(router.previousPage=="#transfer-page"&&location.hash == "#login-page"){
//						 var id = "#transfer-page";
//		                 $.mobile.changePage(id, {transition: 'slide'});
		                 this.goToTransferPage = true;
			        }else if(router.previousPage=="#settings-page"&&location.hash == "#login-page"){
			        	 this.goToSettingsPage = true;
						 var id = "#settings-page";
		                 $.mobile.changePage(id, {transition: 'slide'});
			        }else{
			        	appView.goBack();
			        }
			}
			}
            else if (this.fromTransfer) {
                     var id = "#transfer-page";
                    $.mobile.changePage(id, {transition: 'slide'});
                    $("#transfer-page").find(".rexall-page-header").html("Loading your profile &nbsp;&nbsp  <div id='circleG'><div id='circleG_1' class='circleG'></div><div id='circleG_2' class='circleG'></div><div id='circleG_3' class='circleG'></div></div>");
		
                }
            else if (this.fromRecord || this.fromRefill || this.fromRefillbyNumberFromStoreLocator ){
                    var id = "#record-page";
                    $.mobile.changePage(id, {transition: 'slide'});
                    /* Change record page header */
		            $("#record-page").find(".rexall-page-header").html("Loading your profile &nbsp;&nbsp  <div id='circleG'><div id='circleG_1' class='circleG'></div><div id='circleG_2' class='circleG'></div><div id='circleG_3' class='circleG'></div></div>");
                    $("#record-manual-refill-header-mystore").html("");
                    console.log(" Login view header-mystore:" + $("#record-manual-refill-header-mystore").html());
              }
            else if (this.fromRefillbyNumber) {
// alert("goto Refill");
                var id = "#refill-page";
                $.mobile.changePage(id, {transition: 'slide'});
                //Init refill page
                refillView.render();
		      //  refillView.refillScroll.scrollTo(0,10,200,true);
            }
           

            
		}else{
			/* Show login page */
			this.$el.removeClass("logged").addClass("not-logged");
			/* Pre-enter information if rememebered */
			if(localStorage.getItem("Rexall-user-login"))
				$("#login-email").val(localStorage.getItem("Rexall-user-login"));
			if(localStorage.getItem("Rexall-user-credential"))
				$("#login-password").val(localStorage.getItem("Rexall-user-credential"));
			/* Remeber or not */
			$("#onoff").val(localStorage.getItem("Rexall-remember-user"));
			
		}
		
		/* Render top-right header part */
		this.isLogin();
	},
	
	isLogin: function(){
	
	    if(window.localStorage.getItem("JanRainLogin")){
		     $("#login").css("visibility", "hidden");
			 $("#logout").css("visibility", "visible");
			 $("#welcome").html("Hi, " + JSON.parse(localStorage.getItem("JanRainLogin")).displayName);
	    }else{
	         $("#logout").css("visibility", "hidden");
	 	     $("#login").css("visibility", "visible");
	 	     $("#welcome").html("");
	    }
	   
	},
	setFromRefill : function(state){
		/* Set flag so that the login page does a back" when done. */		
		this.state = state;
		this.fromRefill = true;
		
	},
    setFromRecord : function(state){
		/* Set flag so that the login page does a back" when done. */		
		this.state = state;
		this.fromRecord = true;
	},
	setFromTransfer : function(state){
		/* Set flag so that the login page does a back" when done. */
		this.state = state;
		this.fromTransfer = true;
		
	},	
    setfromRefillbyNumber : function(state){
		/* Set flag so that the login page does a back" when done. */
		this.state = state;
		this.fromRefillbyNumber = true;
	},	
     setfromRefillbyNumberFromStoreLocator : function(value){
		/* Set flag so that the login page does a back" when done. */
		this.state = true;
		this.fromRefillbyNumberFromStoreLocator = value;
// alert("Set Flag:" + value );
	},	
        
	checkFromRefillValue: function(){
		
		var homeStore = localStorage.getItem("RexallProfileHomeStore") ;
		var currentStore = localStorage.getItem("CurrentStore");
		var store1 = "";
		var store2 = "";
		var storeValue1= "";
		var storeValue2 = "";
		if(homeStore){	
		   store1 = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));
		   storeValue1 =store1.Address + ", " + store1.City+", " +store1.Province;
		}
		if(currentStore){											
		   store2 = JSON.parse(localStorage.getItem("CurrentStore"));
		   storeValue2 =store2.Address + ", " + store2.City+", " +store2.Province;
		}
		var addressDefault = $("#refill-to-pharmacy-address-default").val();
		if(addressDefault&& $.trim(addressDefault)!=$.trim(storeValue1)&& $.trim(addressDefault)!=$.trim(storeValue2)){
			return false;
		}else{
			return true;
		}
		
	},
	
	setGoToEnrolmentPageStatus : function(state){
		this.goToEnrolmentPageStatus=state;
	},
	setGoToEnrolmentPageId : function(id){
		this.enrolmentPageId = id;
	},
	goToEnrolmentPage : function(){
		this.setGoToEnrolmentPageStatus(true);
		this.setGoToEnrolmentPageId(null);
		var SignIndata = localStorage.getItem("JanRainLogin"); 
		if(SignIndata){
			SignIndata = JSON.parse(SignIndata);
		    if(!SignIndata.PVRegistration||
		    	SignIndata.pvRegistrationIncomplete||
		    	!SignIndata.PVRegistrationValidated){
		    	localStorage.setItem("EnrolmentRequestMyRexallID", SignIndata.id);
	           	localStorage.setItem("EnrolmentRequestMyRexallUUID", SignIndata.uuid);
	           	localStorage.setItem("EnrolmentRequestMyRexallEMAIL", SignIndata.email);
	           	if(SignIndata.homestorenumber)
	           	localStorage.setItem("EnrolmentRequestMyRexallSTORE", SignIndata.homestorenumber);
	           	if(SignIndata.PVprofileID)
	           	localStorage.setItem("EnrolmentRequestMyRexallPatientId", SignIndata.PVprofileID);
		    }else{
		    	localStorage.removeItem("EnrolmentRequestMyRexallID");
	           	localStorage.removeItem("EnrolmentRequestMyRexallUUID");
	           	localStorage.removeItem("EnrolmentRequestMyRexallEMAIL");
	           	localStorage.removeItem("EnrolmentRequestMyRexallSTORE");
	           	localStorage.removeItem("EnrolmentRequestMyRexallPatientId");
		    }
			if(!SignIndata.PVRegistration){
				//go to request page
				var id = "#enrollment-medication-record-info-page";
				this.setGoToEnrolmentPageId(id);
             	$.mobile.changePage(id, {transition: 'slide'});	
			}else if((!SignIndata.pvRegistrationIncomplete) && (!SignIndata.PVRegistrationValidated)) { 
				if (SignIndata.PVprofileID == null) { 
					// go to confirm page
					var id = "#enrolment-confirm-page";
				}else{ 
					// go to verify page
					var id = "#enrolment-verify-page";
				}
				this.setGoToEnrolmentPageId(id);
             	$.mobile.changePage(id, {transition: 'slide'});	
			}else if(!SignIndata.PVRegistrationValidated){
				// go to verify page
				var id = "#enrolment-verify-page";
				this.setGoToEnrolmentPageId(id);
             	$.mobile.changePage(id, {transition: 'slide'});	
			}else{
				this.setGoToEnrolmentPageStatus(false);
			}
		}
	},
});


function changeOnOff(value){
	if("0"==value){
		
		$("#login-email").val("");
		$("#login-password").val("");
		$("#old_password").val(""),
		$("#new_password").val(""),
		$("#confirm_password").val("");
		/* Clean local storage */
		if(localStorage.getItem("Rexall-user-login"))
			localStorage.removeItem("Rexall-user-login");
		if(localStorage.getItem("Rexall-user-credential"))
			localStorage.removeItem("Rexall-user-credential");
		localStorage.setItem("Rexall-remember-user", 0);
//	}else{
//		$("#login-email").val("maguiar@propharm.com");
//		$("#login-password").val("vgemsvgems9$");
//		$("#old_password").val("vgemsvgems9$"),
//		$("#new_password").val("vgemsvgems9$"),
//		$("#confirm_password").val("vgemsvgems9$");
	}
	
}

function goResetPass()
{
    localStorage.removeItem("JanRainLoginEmailOnly");
    resetPasswordView.hideQuestions();
    resetPasswordView.clearQuestions();
    resetPasswordView.scroll.refresh();

	var id ="#resetPass-page";
   
	$.mobile.changePage(id, {transition: 'slide'});
	$("#settings-page [href='#']").removeClass("ui-btn-active");
    $("#resetpass-page-spinner").css("visibility", "hidden");
    
}

