var ProfileView = Backbone.View.extend({
	
	el: "#myprofile-page",
	
//	template: Handlebars.compile($("#personal-info-template").html()),
	
	events: {
		//"tap .profile-section-header" 		: "openOrClose",
		//"tap .profile-section-close-button"	: "close"
		"tap #profile-update-displayName"		: "updateDisplayName",
	},

	
	initialize: function () {
		/* Listen to profile.profile change */
		this.listenTo(this.model, "change:profile", this.render);
		
		/* Prerender */
		this.render();
		
		/* Set up the scroller */
		this.scroll = new iScroll("profile-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			onBeforeScrollStart: function (e) { 
//				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
//				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea')
//					e.preventDefault();
            // commented the above lines out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
            // from hidding after user unfocus an input field
			}
			});
	},
	
	render: function () {
		if(this.model.hasProfile()){	/* if has Profile */
			var profile = this.model.get("profile");
			/* Display name */
			var displayName = JSON.parse(localStorage.getItem("JanRainLogin")).displayName;
			$("#profile-displayName").val(displayName ? displayName : "Not Specified");
			/* First name */
			$("#profile-firstName").html(profile.firstName ? profile.firstName : "Not Specified");	
			/* Last name */
			$("#profile-lastName").html(profile.lastName ? profile.lastName : "Not Specified");
			/* Gender */
			$("#profile-gender").html(profile.gender ? this.readGender(profile.gender) : "Not Specified");
			/* Birthdate */
			$("#profile-birthDate").html(profile.birthDate ? this.readBirth(profile.birthDate) : "Not Specified");
			/* Phn */
			$("#profile-phn").html(profile.phn ? profile.phn : "Not Specified");
			/* Address */
			$("#profile-address").html(this.readAddress(profile));
			/* City */
			$("#profile-city").html(profile.city ? profile.city : "Not Specified");
			/* Province */
			$("#profile-province").html(profile.province ? profile.province : "Not Specified");
			/* Postal Code */
			$("#profile-postalCode").html(profile.postalCode ? profile.postalCode : "Not Specified");
			/* Home Phone */
			$("#profile-homePhone").html(profile.homePhone ? profile.homePhone : "Not Specified");
			/* Email Address */
			$("#profile-emaliAddress").html(profile.emailAddress ? profile.emailAddress : "Not Specified");
		}else{						/* Does not have Profiled */
			$("#profile-displayName").val("");
			/* First name */
			$("#profile-firstName").html("");	
			/* Last name */
			$("#profile-lastName").html("");
			/* Gender */
			$("#profile-gender").html("");
			/* Birthdate */
			$("#profile-birthDate").html("");
			/* Phn */
			$("#profile-phn").html("");
			/* Address */
			$("#profile-address").html("");
			/* City */
			$("#profile-city").html("");
			/* Province */
			$("#profile-province").html("");
			/* Postal Code */
			$("#profile-postalCode").html("");
			/* Home Phone */
			$("#profile-homePhone").html("");
			/* Email Address */
			$("#profile-emaliAddress").html("");
		}
	},
	
	readAddress: function(profile){
		if(!profile.addressLine1 && !profile.addressLine2){
			return "Not Specified";
		}else{
			return (profile.addressLine1 ? profile.addressLine1 : "") + (profile.addressLine2 ? profile.addressLine2 : "");
		}
	},
	
	readGender: function(gender){
		if(gender === "F"){
			return "Female";
		}else{
			return "Male";
		}
	},
	
	readBirth: function(birth) {
		/* parse date */
		var y = parseInt(birth.substr(0, 4), 10),
			m = parseInt(birth.substr(4, 2), 10),
	      	d = parseInt(birth.substr(6, 2), 10); 
		return d + "/" + m + "/" + y;
	},
	
	updateDisplayName: function() {
		/* Propare update data */
		var regexp = /^[a-zA-Z0-9- ]+$/;
		var newName = $("#profile-displayName").val();
		if(newName.length <= 0 || newName.search(regexp) == -1) {/* Invalid display name */
			jAlert("Display name can only contain letters, numbers, and dashes.","Please Try Again");
			return;
		}
		if(newName == JSON.parse(localStorage.getItem("JanRainLogin")).displayName)
			return;				/* Same as original display name, didn't handle space suffix */
		// length check, fix for Android keyboard
        if(newName.length > 20){
            newName = newName.substring(0,20);
        }
		/* use janrain login to update display name */
		this.loginModel.update({"displayName": newName});
	},
	
	/* Deprecated method, remove later */
	openOrClose: function(e) {
		var t = $(e.currentTarget).parent();
		if(t.attr("class") == "profile-section-close"){
			t.removeClass("profile-section-close").addClass("profile-section-open");
		}else{
			t.removeClass("profile-section-open").addClass("profile-section-close");
		}
	},
	
	/* Deprecated method, remove later */
	close: function(e) {
		var t = $(e.currentTarget).parent();
		t.removeClass("profile-section-open").addClass("profile-section-close");
	},
});