var RecordView = Backbone.View.extend({
	
	tagName: 'li',
	
	template: Handlebars.compile($("#record-view-template").html()),
	
	initialize: function (options) {
		this.listView = options.listView;
	},
	
	events: {
		//"tap .record-header"		: "openOrClose",
		"tap .record-close-button"	: "close",
		"tap .record-open-button"	: "open",
		"tap .record-refill"		: "refill",
	},
	
	render: function () {
		var result = this.template(this.model);
		this.$el.html(result);
		/* Add default class */
		this.$el.addClass("record-close");
	},
	
	/* Open or Close a prescription tab depends on its current status */
	openOrClose: function (e) {
		
		var t = $(e.currentTarget).parent();
		if(t.attr("class") == "record-close"){
			t.removeClass("record-close").addClass("record-open");
		}else{
			t.removeClass("record-open").addClass("record-close");
		}
		
		this.listView.scroller.refresh();
	},
	
	/* Close a prescription tab */
	close: function(e) {
		e.preventDefault();
		
		var t = $(e.currentTarget).parent();
		t.removeClass("record-open").addClass("record-close");
	},
	
	/* Open a prescription tab */
	open: function(e) {
		
		e.preventDefault();
		
		var t = $(e.currentTarget).parent();
		t.removeClass("record-close").addClass("record-open");
		/* refresh scroller */
		this.listView.scroller.refresh();
	},
	
	/* Refill a prescription */
	refill: function(e) {
		e.preventDefault();
		var drugName = this.model.tradeName;
		var prescriptionNum = this.model.rxNumber;
		
		var jConfirmInfos = "<span class='refill-callBack-info-left'>RX Number: <span>&#9;"
			+prescriptionNum
			+"</span></span><BR/><span class='refill-callBack-info-left'>Drug Name: <span>&#9;"
			+drugName
			+"</span></span><BR/><BR/><span class='refill-callBack-info-regular'>Confirm this refill?</span>";
			
//		if(jConfirm(jConfirmInfos,"Are you sure you want to refill this prescription?")){
//			jAlert(0);
//			e.preventDefault();
////			$("li[class='record-open'").removeClass("record-open").addClass("record-close");
//			/* Collect prescription information */
////			var prescriptionNum = this.model.rxNumber;
//			var storeNum = JSON.parse(window.localStorage.getItem("JanRainLogin")).id;
//			var birth = this.listView.model.get("profile").birthDate; 
//			/* Parse date */
//			var y = parseInt(birth.substr(0, 4), 10),
//				m = parseInt(birth.substr(4, 2), 10),
//		      	d = parseInt(birth.substr(6, 2), 10);
//			/* Create new refill */
//			var refiller = new Refiller({
//										"storeNum"		: storeNum,
//										"prescriptionNum": prescriptionNum,
//										"year"			: y,
//										"month"			: m,
//										"day"			: d,
//										"drugName"      :drugName,});
//			jAlert(10);
//			refiller.refill();
//		}else{
//			jAlert("return");
////			return;
//		}
		//if(!confirm("Confirm this refill?Drug Name: "+drugName+" and RX Number: "+prescriptionNum)){
	//		return;
		//}
		var prescriptionNum = this.model.rxNumber;
		var storeNum = JSON.parse(window.localStorage.getItem("JanRainLogin")).homestorenumber;
        //alert(JSON.stringify(window.localStorage.getItem("JanRainLogin")));

		var birth = this.listView.model.get("profile").birthDate; 
		/* Parse date */
		var y = parseInt(birth.substr(0, 4), 10),
			m = parseInt(birth.substr(4, 2), 10),
	      	d = parseInt(birth.substr(6, 2), 10);

        jConfirm(jConfirmInfos,"Are you sure you want to refill this prescription?",function(r){
			if(r){
				/* Create new refill */
				var refiller = new Refiller({
											"storeNum"		: storeNum,
											"prescriptionNum": prescriptionNum,
											"year"			: y,
											"month"			: m,
											"day"			: d,
											"drugName"      : drugName,
                                            "method"        : "MyRexall"
                                            });
				refiller.refill();
			}
		})
		
		
		
	},
	
});