var RecordsListView = Backbone.View.extend({
	
	el: $("#record-page"),
	
	initialize: function () {
		
		/* Listen to profile.prescriptions change */
		this.listenTo(this.model, "change:prescriptions", this.render);
		
		/* Set up scroller */
		this.scroller = new iScroll('record-list-wrapper',{
			//snap:'li', 
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true });
		
		/* Set up popup information scroller */
		this.infoScroll = new iScroll("record-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		this.refillUsingMyRexallScroll = new iScroll("refillUsingMyRexall-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
			
		/* Prerender */
		this.render();
	},
	
	events:{
		"tap #record-prescription-manually"	:	"optPrescriptionManual",
		"tap .rexall-page-header-info"			: "showInfo",
		"tap .rexall-page-info-popup-close"		: "closeInfo",
	},
	/* Render according to Profile model */
	render: function () {
		
		/* Show record */
		if(this.model.hasRecord()){	/* if has record */
			var self = this;
			var storeNum = JSON.parse(window.localStorage.getItem("JanRainLogin")).id;
			var birth = this.model.get("profile").birthDate; 
			//$.each(this.model.get("results").result.prescriptions, function (index, value) {
			$.each(this.model.get("prescriptions"), function (index, value) {
				value.birth=birth;
				value.storeNum=storeNum;
				var fillDate = value.fillDate;
				value.fillDate = self.changeFormatStr(fillDate);
				var din = value.din;
				var rxNum = value.rxNumber;
				var recordView = new RecordView({"listView" : self, "model": value});
				
				/* Display rxNumber as 'Not Specified' and hide the Refill button if rxNumber = 0 */
				if (value.rxNumber == "0") {
					value.rxNumber = "Not Specified";
				}
				recordView.render();
				$("#record-list").append(recordView.el);
				var status = value.status;
				var warningId = "#record-warning-"+rxNum+"-"+birth+"-"+storeNum;
				if($.trim(status).toLowerCase()==$.trim("Hold").toLowerCase()){
					$(warningId).find("span").html("Hold");
					$(warningId).css("background-color","#F0B228");
				}else{
					$(warningId).css("background-color","#006560");
				}
				if (rxNum == "0") {
 				   var refillButtonId = "#record-refill-button-"+fillDate+"-"+din+"-"+birth+"-"+storeNum;
				   $(refillButtonId).hide();
                }
			});
		}else{						/* Does not have record */
			$("#record-list").html("");
		}
		this.scroller.refresh();
	},
	
	setModel: function(model) {
		this.model = model;
	},
	
	fetchRecord: function() {
		jAlert("fetch record","Retrieving Your Profile");
	},
	optPrescriptionManual: function(){
		var id = "#refill-page";
		$.mobile.changePage(id, {transition: 'slide'});	
        //Init refill page
        refillView.render();
		//refillView.refillScroll.scrollTo(0,10,200,true);
	},
	
	showInfo: function(e) {
		e.preventDefault();
		var recordHeader = $("#record-page-header p").text();
		//jAlert("record page header is :" +recordHeader );
		if("MEDICATION RECORD"===recordHeader)
		{	
			/* Open information box */
			$("#MedicalRecord-page-info").popup({ transition: "pop" });
			$("#MedicalRecord-page-info").popup("open");
			this.infoScroll.refresh();
		}else{
			$("#refillUsingMyRexall-page-info").popup({ transition: "pop" });
			$("#refillUsingMyRexall-page-info").popup("open");
			this.refillUsingMyRexallScroll.refresh();
		}
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#MedicalRecord-page-info").popup("close");
		$("#refillUsingMyRexall-page-info").popup("close");
	},
	
	changeFormatStr: function(str){
		if(str.length==8&&str.match(/\D/)==null){
			return str.substring(6,8)+'/'+str.substring(4,6)+'/'+str.substring(0,4)
		}else{
			return str;
		}
	},
	
});