
var RefillView = Backbone.View.extend({
	
	el: $("#refill-page"),
	
	initialize: function () {
		
		
		/* hide the last to steps */
//		$("#refill-form-step2").hide();
//		$("#refill-form-step3").hide();
		
		/* Listen to login model */
		this.listenTo(janrainLogin, "change:hasLogin", this.render);
		
		/* Scroller */
		this.refillScroll = new iScroll('refill-form-scroll',
					{ 
					hScroll:false, 
					vScroll:true, 
					vScrollbar: true, 
					hScrollbar: false, 
					fadeScrollbar: true, 
					hideScrollbar:true,
					onBeforeScrollStart: function (e) { 
//						$("#refill-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
						var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
						if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                            // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                            // from hidding after user unfocus an input field
                            //e.preventDefault();
						}else{	/* Auto scroll up for the input field */
							
							var selfScroll = this;
							
							/* Set a 1 sec time out to allow the soft keyboard show up first */
							setTimeout(function(){ 
								
								var top = 170;		/* maximium ceiling of pageY */
								var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
															
								/* Determine whether auto scroll is required in this event */
								if(y > top){
									/* Calculation moving distance */
									var moveD = top - y;
									/* Actual moving position */
									var actualMove = selfScroll.y + moveD;
									/* Remeber the position before auto scroll */
									selfScroll.autoScrollLastPos = selfScroll.y;
									/* Auto scroll up */
									selfScroll.scrollTo(0, actualMove);
								}	
							
							}, 800);
							
						}
						},
					});
		/* Set up popup information scroller */
		this.infoScroll = new iScroll("refill-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		this.pharcyPolicyScroll = new iScroll("rexall-privacy-policy-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		
		this.pharcyPolicyScrollPrescription = new iScroll("rexall-privacy-policy-scroll-prescription",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
			
		this.render();
	},
	events: {
		"tap #view-medication-record" 		: "showRecord",
		"tap #refill-search-location" 		: "searchLocation",
		"tap #refill-search-phone"	  		: "searchPhone",
		//"tap #refill-now"					: "refill",
		"tap #refill-cancel"				: "cancel",
		"keypress #refill-location-input"	: "keySearchLocation",
		"tap .refill-input-container1"		: "openStoreList",
//		"tap #refill-confirm-store"			: "confirmStore",
		"tap #refill-input-find-another"	: "findAnother",
		"tap #view-login"                   : "loginfromRefill",
		"tap #refill-read-rexall-page"      : "readRexallPage",
		"tap #refill-read-rexall-page-prescription"      : "readRexallPagePrescription",
		"tap #refill-submit"                : "refillSubmit",
		"tap .rexall-page-header-info"			: "showInfo",
		"tap .rexall-page-info-popup-close"		: "closeInfo",
		
	},
	
	/* What does this function do ?? */
	openStoreList: function () {
		$('select').selectmenu('open');	
	},
	
	/* Show refill page information pop up */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
        if(cordova.plugins.Keyboard.isVisible){
            $('input').blur();  // unfocus input
            cordova.plugins.Keyboard.close();   // close keyboard

            var self = this;
            setTimeout(function(){  // set a 0.5 sec delay to allow keyboard close first
                $("#RefillPrescription-page-info").popup("option", "history", false);
                $("#RefillPrescription-page-info").popup({ transition: "pop" });
                $("#RefillPrescription-page-info").popup("open");
                self.infoScroll.refresh();
            }, 500);
        }else {
            $("#RefillPrescription-page-info").popup("option", "history", false);
            $("#RefillPrescription-page-info").popup({ transition: "pop" });
            $("#RefillPrescription-page-info").popup("open");
            this.infoScroll.refresh();
        }
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#RefillPrescription-page-info").popup("close");
		$("#rexall-privacy-policy").popup("close");
		$("#privacypolicy-page-prescription").popup("close");
	},
	
	/* Show medication Record */
	showRecord: function () {
		if(this.appView){
			if(!window.localStorage.getItem("JanRainLogin")){
				/* Haven't login yet, go to login page */
				// jAlert("Login to your MyRexall account first.","Please Try Again");
				var id = "#login-page";
				$.mobile.changePage(id, {transition: 'slide'});
			}else{
				var id = "#record-page";
				$.mobile.changePage(id, {transition: 'slide'});	
			}
		}else{
			//jAlert("Error on refill view: appView is not set in the view class","Rexall");
		}
	},
	
	/* */
	confirmStore: function() {
		/* Show step 3 */
//		$("#refill-form-step3").show(200);
	},
	
	/* insertStore to result field */
	insertStore: function(model) {
		/* Clean up the history list first */
		$("#refill-location-result").html("");
		var currentq = localStorage.getItem("currentq");
		/* Create a new store collection */
		var searchResult = new StoreDetailList();
		var result = "";
		/* Create view */
		this.refillStoreList = new RefillStoreListView({"collection" : searchResult});
//		localStorage.setItem("ThisStore",JSON.stringify(model.toJSON()));
		this.refillStoreList.setModel(model);
		var current = localStorage.getItem("CurrentStore");
		if(currentq){
			/* Fetch data */
			searchResult.fetchDataWithInput(currentq);
//			/* Show the selections */
		}else{
			if(model){
//				  searchResult.create(model);
//				  if(current){
//						var currentItem = JSON.parse(current);
//						var thisStore = model.toJSON().StoreNumber;
//						if(thisStore === currentItem.StoreNumber){
//							result = "<option class='refill-location-selection' value='" + currentItem.StoreNumber + "' selected>"
//									+ currentItem.Address + ", " + currentItem.City + ", " + currentItem.Province+"</option>";
//					     	$("#refill-location-result").prepend(result);	
//						}
//					  
//					}
				  $("#refill-page-seperator1").hide();
				  $("#refill-form-change-location").hide();				
				  $("#refill-form-to-default").show();
				  $("#refill-to-pharmacy-address-default").val(storeSubstring(model.toJSON().StoreName + ", "+model.toJSON().Address + ", " +model.toJSON().City+", " +model.toJSON().Province),35);
			  }else{
				  $("#prescription-number-title div[class='red-warning']").hide();
					$("#date-of-birth-title div[class='red-warning']").hide();
					$("#select-stores-title div[class='red-warning']").hide();
					/* Fill Home store */
					if(localStorage.getItem("CurrentStore")){			/* Has home store from file or preferred store */
						$("#refill-page-seperator1").hide();				/* Hide the search form */
						$("#refill-form-change-location").hide();				/* Hide the search result form */
						$("#refill-form-to-default").show();				/* Show default address */
						/* Prefill pharmacy address */
						var store = JSON.parse(localStorage.getItem("CurrentStore"));
						//$("#refill-to-pharmacy-address-default").val(store.StoreName + ", " +store.Address + ", " + store.City+", " +store.Province);
						$("#refill-to-pharmacy-address-default").val(storeSubstring(store.StoreName + ", " +store.Address + ", " + store.City+", " +store.Province,35));
					}else{				
						$("#refill-form-to-default").hide();				
						$("#refill-page-seperator1").hide();	
						$("#refill-form-change-location").show();				
					}
			  }
			
		}
		result = "<option class='refill-location-selection' id='refill-chooseastore' value='ChooseFromList'>Choose from the list below</option>";
		$("#refill-location-result").prepend(result);
		/* insert store */
//		searchResult.create(model);
		
		/* Show seconde steps */
//		$("#refill-form-step2").show(200);
		
		/* Refresh scroll */
		this.refillScroll.refresh(); 
		/* move up the scroller */
		this.refillScroll.scrollTo(0, -340, 200);
	},
	
	/* Auto search after enter key has pressed */
	keySearchLocation: function(e) {
		/* Check which key was pressed */
		if (e.keyCode != 13) return;
		
		this.searchLocation();
	},
	
	/* Search store by input location */
	searchLocation: function() {
		
		/* Get search query */
		var q = $("#refill-location-input").val();
	    if (!q){
	    	jAlert("Enter a valid address.","Please Try Again");
	    	return;
	    }
		/* Clean up the history list first */
		$("#refill-location-result").html("");
		/* Create a new store collection */
		var searchResult = new StoreDetailList();
		/* Create view */
		this.refillStoreList = new RefillStoreListView({"collection" : searchResult});
		/* Fetch data */
		searchResult.fetchDataWithInput(q);
		/* Show the selections */
		var result = "";
		result = "<option class='refill-location-selection' id='refill-chooseastore' value='ChooseFromList' >Choose from the list below</option>";
		$("#refill-location-result").prepend(result);
				
		/* Show search result 
		$("#refill-page-seperator2").show();
		$("#refill-form-location-result").show();*/
		$("#refill-phone").val("");
       
		/* Refresh scroll */
		this.refillScroll.refresh(); 
	},
	
	/* Validate to inputed phone number for search */
	validateSearchPhone: function(refillPhone1) {
		
		/* Check phone number. Not required. But need to conform if exist */
		var phoneStatus = 0;
		if (refillPhone1.length != 14)
		{
			/* Phone number for search in empty */
			$("label[for='refill-phone-number']").addClass("rexall-warning-label");
			jAlert("Enter a valid phone number.","Please Try Again");
		}	
		else{
			$("label[for='refill-phone-number']").removeClass("rexall-warning-label");
		    phoneStatus=1;
		}
		
		return phoneStatus;
	},
	
	/* Search store by phone number */
    searchPhone: function () {
        /* Clean up the history list first */
        $("#refill-location-result").html("");
        /* Read in phone number */
			var contactPhoneLength = $("#refill-phone").val().length;
            if(!(contactPhoneLength == 14))
            {
                $("label[for='refill-phone-number']").addClass("rexall-warning-label");
                jAlert("The phone number is invalid.", "Please Try Again");
            }
            else{$("label[for='refill-phone-number']").removeClass("rexall-warning-label"); d = new Date();		
        		var phoneInput = $("#refill-phone").val();
        		var p1 = phoneInput.substring(1, 4);
        		var p2 = phoneInput.substring(6, 9);
        		var p3 = phoneInput.substring(10, 14);
        		/* Validate the phone number */
        		var phoneStatus = this.validateSearchPhone($("#refill-phone").val());
        		if (phoneStatus != 1)
            		return;
        		var phoneNumber = p1 + "-" + p2 + "-" + p3;
        		/* Create a new store collection */
        		var searchResult = new StoreDetailList();
        		/* Create view */
        		this.refillStoreList = new RefillStoreListView({"collection" : searchResult});
        		/* Fetch data */
        		searchResult.fetchDataWithPhone(phoneNumber);
        		/* Show the selections */
        		var result = "";
        		result = "<option class='refill-location-selection' id='refill-chooseastore' value=''>Choose a store</option>";
        		$("#refill-location-result").prepend(result);
        		$("#refill-chooseastore").prop('selected', true);
        		/* Show search result 
        		$("#refill-page-seperator2").show();
        		$("#refill-form-location-result").show();	*/
        
        		$("#refill-location-input").val("");
        		/* Refresh scroll */
        		this.refillScroll.refresh(); 
        	}
    },
	
	/* Setter for parent App View */
	setApp: function(app) {
		this.appView = app;
	},
	
	/* Make a refill service call */
//	refill: function() {
//		/* Get input data */
//		var storeNum = $("#refill-location-result").val();
//		var prescriptionNum = $("#refill-prescription-number").val();
//		var birthDate = getHTML5Date("refill-birth-date");
//
//		var refiller = new Refiller({
//									"storeNum"		: storeNum,
//									"prescriptionNum": prescriptionNum,
//									"year"			: birthDate.substring(6,10),
//									"month"			: birthDate.substring(3,5),
//									"day"			: birthDate.substring(0,2),
//                                    "method"        : "Manual"
//                                    });
//		refiller.refill();
//	},
	
	/* Clean up */
	cancel: function() {
		/* Remove warning class */
		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
		
		/* Uncheck check box */
		$("#agree-refill").prop("checked", false);
		/* Remove input field */
		$("#refill-prescription-number").val("");
//		$("#refill-birth-date").val("");
		//alert($("#refill-birth-date").inputmask('unmaskedvalue'));
//		$("#refill-birth-date").inputmask("dd/mm/yyyy");	
		$("#refill-phone").val("");
		$("#refill-location-input").val("");
		$("#refill-location-result").val("");
	},
	
	/* Set up page components */
	render: function() {
		
		/* Clean up previous input */
		this.cancel();
		
		/* Show signin or record button */
		if(janrainLogin.get("hasLogin") && localStorage.getItem("JanRainLogin")){
			/* Logged in, show record button */
			$("#view-medication-record").hide();
			$("#view-steps-below").show();
			$("#view-login").hide();
			$("#refill-complete-steps-below").hide();
		}else{
			/* not Logged in, show record button */
			$("#view-medication-record").hide();
			$("#view-steps-below").hide();
			$("#view-login").show();
			$("#refill-complete-steps-below").show();
		}
		
		/* Reset search form */
		this.cancelAnother();
		
		/* Fill Home store */
       
        var store;
		if(localStorage.getItem("RexallProfileHomeStore") 
		|| localStorage.getItem("CurrentStore")
		|| (storeDetailPage && storeDetailPage.model)){	/* Has home store from file or preferred store or selected store */
			$("#refill-page-seperator1").hide();				/* Hide the search form */
			$("#refill-form-change-location").hide();			/* Hide the search result form */
			$("#refill-form-to-default").show();				/* Show default address */
			/* Prefill pharmacy address */
			if(localStorage.getItem("RexallProfileHomeStore")){	/* Use profile store (must have login) */
				store = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));
               
            }
            else if(localStorage.getItem("CurrentStore")){		/* Use preferred store */

				 store = JSON.parse(localStorage.getItem("CurrentStore"));
			}else if(storeDetailPage && storeDetailPage.model){	/* Use selected store */

				 store = storeDetailPage.model.toJSON();
			}else{
				$("#refill-form-to-default").hide();				
			    $("#refill-page-seperator1").hide();	
			
//			    $("#refill-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
			
			    $("#refill-form-change-location").show();	
			}

            console.log("janrainLogin.getLogin: "  + janrainLogin.get("hasLogin"));
		 
            
            if (janrainLogin.get("hasLogin") && !localStorage.getItem("RexallProfile"))
            {
                $("#refill-form-to-default").show();
                $("#refill-to-pharmacy-address-default").val("Loading your home store, wait...");
            }
            else{
               // $("#refill-to-pharmacy-address-default").val(store.StoreName + ", " +store.Address + ", " + store.City+", " +store.Province);
                $("#refill-to-pharmacy-address-default").val(storeSubstring(store.StoreName + ", " +store.Address + ", " + store.City+", " +store.Province,35));
            }
           
			/* Set default store number for this view */
			this.defaultStoreNumber = store.StoreNumber;
		}
//		else if (janrainLogin.get("hasLogin"))
//            {
//                 if (!localStorage.getItem("RexallProfile"))
//                {
//                    $("#refill-form-to-default").show();
//                    $("#refill-to-pharmacy-address-default").val("Loading your home store, wait...");
//                }
//            }
         else
            {		
        	 	$("#refill-to-pharmacy-address-default").val("");	// Clean up the field in the case that the user login and logout and do the refile
			    $("#refill-form-to-default").hide();				
			    $("#refill-page-seperator1").hide();	
			
//			    $("#refill-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
			
			    $("#refill-form-change-location").show();				
		    }

		this.preFillBirthday();		
			
		/* Hide search result form */
		$("#refill-page-seperator2").hide();
		$("#refill-form-location-result").hide();	
		/* refresh the form scroller */
//		this.refillScroll.refresh();	/* Refresh() here will causing issue 1047?? weird .... */
	},
	
    preFillBirthday:function() {
        /* Prefill birthday */
		if(localStorage.getItem("RexallProfile")&&window.localStorage.getItem("JanRainLogin")&&
				JSON.parse(localStorage.getItem("RexallProfile")).profile&&
				JSON.parse(localStorage.getItem("RexallProfile")).profile.birthDate){
			var birth = JSON.parse(localStorage.getItem("RexallProfile")).profile.birthDate;
			//if(birth){
				$("#refill-birth-date").val(birth.substr(6, 2) +"/"+birth.substr(4, 2)+"/"+ birth.substr(0, 4));
				//$("#refill-birth-date").inputmask(birth.substr(6, 2)+"/"+birth.substr(4, 2)+"/"+birth.substr(0, 4));
				$("#refill-birth-date").attr("readOnly",true);
			//}
		}else{
			$("#refill-birth-date").val("");				// Clean up in the case the user sign in first(has prefill) and sign out (the prefill the value should be clean now)
			setHTML5DateFormat("refill-birth-date");
			$("#refill-birth-date").attr("readOnly",false);
			
		}
    },


	/* Show search store form */
	findAnother: function() {
		var anotherClass = $("#refill-input-find-another").attr("class");
		if(anotherClass=="transfer-input-button1"){
			/* Rotate button arrow */
			$("#refill-input-find-another").removeClass("transfer-input-button1").addClass("refill-input-button1");
			/* Disable editable input */
			$("#refill-to-pharmacy-address-default").prop('disabled', true);	
			//$("#search-by-phone-area").show();
           // $("#search-by-location-area").show();
           //$("#search-by-location-area-or").show();
			$("#refill-page-seperator1").show(200);
			$("#refill-form-change-location").show(200);		/* and seperators */
		}else{
//			/* Rotate button arrow */
//			$("#refill-input-find-another").removeClass("refill-input-button1").addClass("transfer-input-button1");
//			/* Enable editable input */
//			$("#refill-to-pharmacy-address-default").prop('disabled', false);
//			
//			$("#refill-page-seperator1").hide(200);
//			$("#refill-form-change-location").hide(200);		/* and seperators */
//			/* Hide search result form */
//			$("#refill-page-seperator2").hide();
//			$("#refill-form-location-result").hide();
			this.cancelAnother();
		}
		/* refresh the form scroller */
		//this.refillScroll.refresh();
		setTimeout(function() {
			refillView.refillScroll.refresh();
		}, 240);
	},
	
	/* Cancel search store form */
	cancelAnother:function() {
		/* Rotate button arrow */
		$("#refill-input-find-another").removeClass("refill-input-button1").addClass("transfer-input-button1");
		/* Enable editable input */
		$("#refill-to-pharmacy-address-default").prop('disabled', false);
		
		$("#refill-page-seperator1").hide();
		$("#refill-form-change-location").hide();		/* and seperators */
		/* Hide search result form */
		$("#refill-page-seperator2").hide();
		$("#refill-form-location-result").hide();
		/* Empty search result */
		$("#refill-location-result").html("");
	},
	
	loginfromRefill: function(){
		
		if(!localStorage.getItem("JanRainLogin")){
//			loginView.setFromRefill(loginView.checkFromRefillValue());
            loginView.setfromRefillbyNumber(true);
			var id ="#login-page";
			$.mobile.changePage(id, {transition: 'slide'});
            appView.setStepsToGobackForRecord(2);
		}else{
			jAlert("You have already logged on!","Something Went Wrong");
		}
		
	},
	
	refillSubmit: function(e){
		
		e.preventDefault();
		
		var prescriptionNumber = $("#refill-prescription-number").val();
		var birthDate = getHTML5Date("refill-birth-date");
		var pharmacyAddressDefault = $("#refill-to-pharmacy-address-default").val();
		var refillLocationResult = $("#refill-location-result").val();
		
		var prescriptionNumberStatus = 0;
		var dateOfBirthStatus = 0;
		var refillLocationResultStatus = 0;
		
		/* Check prescription number */
		if(prescriptionNumber.length <= 0 ){
			$("label[for='refill-prescription-number']").addClass("rexall-warning-label");
			
		}else{
			$("label[for='refill-prescription-number']").removeClass("rexall-warning-label");
			prescriptionNumberStatus=1;
		}
		/* Check birth date */
		if(birthDate.length != 10||!appView.checkDateOfBirth(birthDate)){
			$("label[for='refill-birth-date']").addClass("rexall-warning-label");
		
		}else{
			$("label[for='refill-birth-date']").removeClass("rexall-warning-label");
            dateOfBirthStatus=1;
		}
				
		/* Check address */
		if($("#refill-form-change-location").is(":visible")
			&& (refillLocationResult == null || refillLocationResult == "ChooseFromList")){	
			/* Need to finish search */
			$("#determine-location").addClass("rexall-warning-label");
		}else if( $("#refill-form-change-location").is(":visible")
					&& $("#refill-form-location-result").is(":visible") 
					&& (refillLocationResult == "ChooseFromList" || refillLocationResult.length <= 0)){
			/* Need to select from search result */
			$("#determine-location").removeClass("rexall-warning-label");
			$("label[for='refill-location-result']").addClass("rexall-warning-label");
		}else if(!$("#refill-form-change-location").is(":visible") && pharmacyAddressDefault.length <= 0 ){
			/* Default field is enabled and is empty */
			$("#determine-location").addClass("rexall-warning-label");
		}else{
			$("label[for='refill-location-result']").removeClass("rexall-warning-label");
			$("#determine-location").removeClass("rexall-warning-label");
			refillLocationResultStatus=1;
		}
		
		/* Valids DOB */
		if(dateOfBirthStatus==2){
			jAlert("Provide a valid birthdate.","Please Try Again");
			return;
		}

		/* Check status */
		if(prescriptionNumberStatus!=1||dateOfBirthStatus!=1||refillLocationResultStatus!=1){
			jAlert("Correct the information highlighted in red.","Please Try Again");
			return;
		}
/*
		var prescriptionNumberStatus = 0;
		var dateOfBirthStatus = 0;
		var refillLocationResultStatus = 0;
		if(prescriptionNumber&&prescriptionNumber>0){
			$("#prescription-number-title span").css("color","#005450");
			$("#prescription-number-title div[class='red-warning']").hide();
			prescriptionNumberStatus=1;
		}else{
			$("#prescription-number-title span").css("color","red");
			$("#prescription-number-title div[class='red-warning']").show(200);
		}
		if(refillDate&&refillDate>0&&refillMonth&&refillMonth>0&&refillYear&&refillYear>0){
			$("#date-of-birth-title span").css("color","#005450");
			$("#date-of-birth-title div[class='red-warning']").hide();
			dateOfBirthStatus=1;
		}else{
			$("#date-of-birth-title span").css("color","red");
			$("#date-of-birth-title div[class='red-warning']").show(200);
		}
		if(refillLocationResult||pharmacyAddressDefault){
			$("#select-stores-title span").css("color","#005450");
			$("#select-stores-title div[class='red-warning']").hide();
			refillLocationResultStatus=1;
		}else{
			$("#select-stores-title span").css("color","red");
			$("#select-stores-title div[class='red-warning']").show(200);
		}
		if(prescriptionNumberStatus!=1||dateOfBirthStatus!=1||refillLocationResultStatus!=1){
			return;
		}
*/
		//if($("input[name='agree-refill']:checked").length==0){
		if(!$("input[name='agree-refill']").prop("checked")){
			jAlert("You must agree to the Prescription Refill Terms and Conditions to continue.","Please Try Again");
			return;
		}

        // determine store number
		var storeNum = "";
		if(refillLocationResult && refillLocationResult.indexOf("s") <0) {
			/* Use search result */
			storeNum = refillLocationResult;
		}else{
			storeNum = this.defaultStoreNumber;
		}

        // determine submit type
        var method = "Manual";  // default submit type on Prescription refill page
        var janRainLogin = localStorage.getItem("JanRainLogin");
        if(janRainLogin){
            if(profile && profile.hasRecord()){    // has login AND has medi record
                method = "MyRexallManual";
            }else{                      // has login but don't have medi record
                method = "MyRexallBasicManual";
            }
        }

        var refiller = new Refiller({
			"storeNum"		: storeNum,
			"prescriptionNum": prescriptionNumber,
			"year"			: birthDate.substring(6,10),
			"month"			: birthDate.substring(3,5),
			"day"			: birthDate.substring(0,2),
            "method"        : method
            });

		refiller.refill();
//		var agreeRefill = $("#agree-refill").val();
	},
	
	readRexallPage: function(e){
		
		e.preventDefault();
		/* Open privacy policy box */
		$("#rexall-privacy-policy").popup( "option", "history", false );
		$("#rexall-privacy-policy").popup({ transition: "pop" });
		$("#rexall-privacy-policy").popup("open");
		this.pharcyPolicyScroll.refresh();

		
	},
	readRexallPagePrescription: function(e){
		e.preventDefault();	
		$("#privacypolicy-page-prescription").popup( "option", "history", false );
		$("#privacypolicy-page-prescription").popup({ transition: "pop" });
		$("#privacypolicy-page-prescription").popup("open");
		this.pharcyPolicyScrollPrescription.refresh();
		
	},
	
});

var select_store_onchange_selectedText = new Array();
function select_store_onchange(list, i) {
    select_store_onchange_selectedText[i] = list.options[list.selectedIndex].text;
    if (list.options[list.selectedIndex].text.length >= 35)
    list.options[list.selectedIndex].text = list.options[list.selectedIndex].text.substring(0, 32) + "...";
}

function select_store_onclick(list, i){
    if (select_store_onchange_selectedText[i]==undefined||select_store_onchange_selectedText[i] == "" || list.selectedIndex <1)
        return;
    list.options[list.selectedIndex].text = select_store_onchange_selectedText[i];
}