﻿var ResetPasswordView = Backbone.View.extend({
	
	el : $("#resetPass-page"),
	
	events: {
		"tap #ResetPass-submit-button" 	: "ResetPassSubmit",
	},
	

    initialize: function() {
        this.hideQuestions();
        this.clearQuestions();
        /* Set up the scroller */
        this.scroll = new iScroll("resetPass-page-scroller", {
            hScroll:false, 
            vScroll:true, 
            vScrollbar: true, 
            hScrollbar: false, 
            fadeScrollbar: true, 
            hideScrollbar:true,
            onBeforeScrollStart: function (e) { 
                var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
                if (nodeType != 'select' && nodeType != 'option' && nodeType != 'input' && nodeType != 'textarea') {
                    e.preventDefault();
                }
                else {	/* Auto scroll up for the input field */
                    var selfScroll = this;
							
                    /* Set a 1 sec time out to allow the soft keyboard show up first */
                    setTimeout(function() { 
                        var top = 170;		/* maximium ceiling of pageY */
                        var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
															
                        /* Determine whether auto scroll is required in this event */
                        if (y > top) {
                            /* Calculation moving distance */
                            var moveD = top - y;
                            /* Actual moving position */
                            var actualMove = selfScroll.y + moveD;
                            /* Remeber the position before auto scroll */
                            selfScroll.autoScrollLastPos = selfScroll.y;
                            /* Auto scroll up */
                            selfScroll.scrollTo(0, actualMove);
                        }	
                    }, 800);
                }
            },
        });
    },
	
    hideQuestions: function(){
        $("#resetpass-page-question").hide();
        $("#reset-pass-question_1").hide();
        $("#reset-pass-question_2").hide();
        $("#reset-pass-question_3").hide();
        $("#reset-pass-question_4").hide();
        $("#reset-pass-question_5").hide();
    },

     clearQuestions: function(){
        $("#resetpass-page-email").val("");
        $("#resetpass-page-answer").val("");
        $("#resetpass-question-prompt").removeClass("rexall-warning-label");
        $("label[for='reset-pass-label']").removeClass("rexall-warning-label");
    },
	
	render: function () {
		
	},
	
	ResetPassSubmit : function(e){
		
		e.preventDefault();
		
		/* Validate email */
		if (!$("#resetpass-page-question").is(":visible") &&this.ResetPassSubmitValidate())
        {
            this.GetPassQuestion();
            return;
        }
		
		/* Validate security answer */
        if ($("#resetpass-page-question").is(":visible") )
        {  
           	if($("#resetpass-page-answer").val().length <= 0){
				  $("#resetpass-question-prompt").addClass("rexall-warning-label");

				  $.alerts.alert("An answer is required for the security question.","Please Try Again");

				}else {
                $("#resetpass-question-prompt").removeClass("rexall-warning-label");

                // send request
                this.model.sendPasswordEmail($("#resetpass-page-answer").val());

//        	var validated = this.model.validateAnswer($("#resetpass-page-answer").val());
//            if (validated) {
//            this.model.sendPasswordEmail();
//                this.hideQuestions();
//                this.clearQuestions();
//                localStorage.removeItem("JanRainLoginEmailOnly");
//
//                /* Go back to previous page */
//                if (this.appView)
//                    this.appView.goBack();
//            }
//            else {
//				$("#resetpass-question-prompt").addClass("rexall-warning-label");
//                $.alerts.alert("The answer does not match with our record.", "Please Try Again");
//            }
                }
        }
	},

    ShowQuestion: function(questionNumber)
    {
             $("#resetpass-page-question").show();
             $("#reset-pass-" + questionNumber).show();
             this.scroll.refresh();
    },

    GetPassQuestion : function()
    {
    
        var result = true;
        var email =  $("#resetpass-page-email").val();
        result = this.model.getQuestionbyEmail({"email":email});
        return result;
    }, 

    
    ResetPassSubmitValidate: function()
    {
        var result = true;
        console.log("ResetPassSubmitValidate");
        if($("#resetpass-page-email").val().length < 4)
        {
            $("label[for='reset-pass-label']").addClass("rexall-warning-label");
            result &= false;
            if($("#resetpass-page-email").val().length==0)
            	jAlert("Correct the information highlighted in red.","Please Try Again");
            else
            	 jAlert("Enter a valid email address.","Please Try Again");
		}else{
		 if (!this.validateEmail($("#resetpass-page-email").val()))
			{$("label[for='reset-pass-label']").addClass("rexall-warning-label");
			result &= false;
			 jAlert("Enter a valid email address.","Please Try Again");
		      }else{			
		     $("label[for='reset-pass-label']").removeClass("rexall-warning-label");
   		     }
		}
        return result;
    },
    
    /* Validate security answer */
    ResetPassSecurityValidate: function() {
    	
    	var result = true;
    	
    	if($("#resetpass-page-question").is(":visible") && $("#resetpass-page-answer").val().length <= 0){
    		$("label[for='reset-pass-question']").addClass("rexall-warning-label");
    		result &= false;
    	}else{
    		$("label[for='reset-pass-question']").removeClass("rexall-warning-label");
    	}
    	
    	return result;
    },
    
 	validateEmail: function(email) { 
  // http://stackoverflow.com/a/46181/11236
  
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
	},
	   
    /* Set app view */
    setApp:function(app) {
    	this.appView = app;
    }

});





