var SecurityView = Backbone.View.extend({
	
	el: $("#SecurityPreferences-page"),
	
	events: {
		"tap #update-security-preference"	: "update",
	},
	
    initialize: function() {
        this.render();
		
        /* Set up the scroller */
        this.scroll = new iScroll("security-scroll", {
            hScroll:false, 
            vScroll:true, 
            vScrollbar: true, 
            hScrollbar: false, 
            fadeScrollbar: true, 
            hideScrollbar:true,
            onBeforeScrollStart: function (e) { 
                var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
                if (nodeType != 'select' && nodeType != 'option' && nodeType != 'input' && nodeType != 'textarea') {
                    e.preventDefault();
                }
                else {	/* Auto scroll up for the input field */
                    var selfScroll = this;
							
                    /* Set a 1 sec time out to allow the soft keyboard show up first */
                    setTimeout(function() { 
                        var top = 170;		/* maximium ceiling of pageY */
                        var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
															
                        /* Determine whether auto scroll is required in this event */
                        if (y > top) {
                            /* Calculation moving distance */
                            var moveD = top - y;
                            /* Actual moving position */
                            var actualMove = selfScroll.y + moveD;
                            /* Remeber the position before auto scroll */
                            selfScroll.autoScrollLastPos = selfScroll.y;
                            /* Auto scroll up */
                            selfScroll.scrollTo(0, actualMove);
                        }	
                    }, 800);
                }
            },
        });
        this.clearPassword();
    },
	
	/* Render security preference page */
	render: function() {
		var profile = JSON.parse(localStorage.getItem("JanRainLogin"));
		/* Double existence of Janrain profile */
		if(!profile) return;
      
	    /* clear password */
		$("#SecurityPreferences-page input[type='password']").val("");
		
        /* current password */
		//$("#old_password_security").val(profile.password.value);
		/* Security Question */
		$("#security_question").val(profile.security_question);
		/* Security answer */
		$('#security_answer').val(profile.security_answer);
	},
	
	/* Update Janrain security preference */
	update: function() {
		
		/* Update password */
//		if($("#old_password_security").val() || $("#new_password_security").val() || $("#confirm_password_security").val())
//		if(!this.validatePassword())	/* Update password */
//			return;
		
		var flag= this.validatePassword()
		if(flag!='blankAll'&&flag){
			var old_password = $("#old_password_security").val();
			var	new_password = $("#new_password_security").val();
			/* Update password */
			 this.model.updatePassword(old_password, new_password);
		}else if(flag!='blankAll'&&!flag){
			return;
		}
		
		/* Get profile */
		var profile = JSON.parse(localStorage.getItem("JanRainLogin"));
		/* Check if need to update security question */
		if($("#security_question").val() == profile.security_question 
		&& $('#security_answer').val() == profile.security_answer)
			return;

        if (!this.validateSecurityAnswer())
            return;
            
		/* Update security question */
		this.model.update({'security_question'	: $("#security_question").val(),
						   'security_answer'    : $('#security_answer').val(),
							});
	},
	
	/* Validate password update */
//	validatePassword: function() {
//		
//		/* Retrieve input data */
//		var old_password = $("#old_password_security").val(),
//			new_password = $("#new_password_security").val(),
//			confirm_password = $("#confirm_password_security").val();
//
//		
//		/* No password update require */
//        if(old_password.length==0 && new_password.length == 0 && confirm_password.length == 0){
//        	return true;
//        }
//		
//		/* Validate new password */
//		if(!old_password.length > 0 || !new_password.length > 0 || !confirm_password.length > 0){
//			jAlert('Please type the old password, and the new password twice to change the password', 'Please Try Again');
//			return false;
//		} 
//        if(new_password !== confirm_password){
//        	jAlert('The password fields do not match', 'Please Try Again');
//        	return false;
//		} 
//        if(!new_password.match(/[1-9]/i) || !new_password.match(/[1-9]/i).length > 0){
//        	jAlert('The password must contain at least 1 number', 'Please Try Again');
//        	return false;
//		} 
//        if(!new_password.match(/[a-zA-Z]/g) || !new_password.match(/[a-zA-Z]/g).length > 0){
//        	jAlert('The password must contain at least 1 letter', 'Please Try Again');
//        	return false;
//		} 
//        if(new_password.length < 7){
//        	jAlert('The password must contain at least 7 characters', 'Please Try Again');
//        	return false;
//		} 
//                	
//        /* update password */
//        this.model.updatePassword(old_password, new_password);
//        	return true;
//	},

	validatePassword: function() {
		var passwordFlag = true;
		/* Retrieve input data */
		var old_password = $("#old_password_security").val(),
			new_password = $("#new_password_security").val(),
			confirm_password = $("#confirm_password_security").val();

		
//		/* No password update require */
        if(old_password.length==0 && new_password.length == 0 && confirm_password.length == 0){
        	return 'blankAll';
        }

		if(old_password.length<=0){
			$("label[for='current-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
		}else{
			$("label[for='current-password']").removeClass("rexall-warning-label");
		}
		if(new_password.length<=0){
			$("label[for='update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
		}else{
			$("label[for='update-password']").removeClass("rexall-warning-label");
		}
		if(confirm_password.length<=0){
			$("label[for='re-update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
		}else{
			$("label[for='re-update-password']").removeClass("rexall-warning-label");
		}
		if(new_password==confirm_password&&new_password.length>0){
			$("label[for='re-update-password']").removeClass("rexall-warning-label");
		}else{
			$("label[for='re-update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
			return passwordFlag;
		}
		if(!new_password.match(/[1-9]/i) || !new_password.match(/[1-9]/i).length > 0){
			jAlert('The password must contain at least 1 number', 'Please Try Again');
			$("label[for='update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
			return passwordFlag;
		}else{
			$("label[for='update-password']").removeClass("rexall-warning-label");
		}
		if(!new_password.match(/[a-zA-Z]/g) || !new_password.match(/[a-zA-Z]/g).length > 0){
			jAlert('The password must contain at least 1 letter', 'Please Try Again');
			$("label[for='update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
			return passwordFlag;
		}else{
			$("label[for='update-password']").removeClass("rexall-warning-label");
		}
		if(new_password.length < 7){
			jAlert('The password must contain at least 7 characters', 'Please Try Again');
			$("label[for='update-password']").addClass("rexall-warning-label");
			passwordFlag&=false;
		}else{
			$("label[for='update-password']").removeClass("rexall-warning-label");
		}

        return passwordFlag;

	},


    validateSecurityAnswer:function() {
        if ($('#security_answer').val().length < 5) {
            jAlert('The answer to the security question must be at least 5 characters.', 'Please Try Again');
            return false;
        }
        return true;
    },

	clearPassword: function(){
		 $("#old_password_security").val("");
		 $("#new_password_security").val("");
		 $("#confirm_password_security").val("");
	},
});