﻿var StoreDetailView = Backbone.View.extend({
	
	el: $("#detail-page"),
	
	template: Handlebars.compile($("#locator-detail-template").html()),
	
	events: {
		"tap #detail-patient-note-patient"				:	"showPDF",
		"tap #detail-patient-note-proprietor"			: 	"showContact",
        "tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
    },
    initialize: function () {
    	this.fromMapPageState = false;
    },
    fromMapPage : function(state){
    	
    	this.fromMapPageState = state;
    },

	render: function () {
        if (!this.model)
            return;

		this.$el.find("ul").html(this.template(this.model.toJSON()));
		this.getToday("#store_open_close",this.model.toJSON().StoreHours);
		this.getToday("#pharmacy_open_close",this.model.toJSON().RxHours);
		this.showStoreHours("#detail-store-hours",this.model.toJSON().ConsolidatedStoreHours);
		this.showStoreHours("#detail-pharmacy-hours",this.model.toJSON().ConsolidatedRxHours);
		//this.formatDistance();
		if(!this.detailScroller){
			this.detailScroller = new iScroll("locator-detail-div", {hScroll:false, vScroll:true, vScrollbar: true, hScrollbar: false, fadeScrollbar: true, hideScrollbar:true });
		}else{
			this.detailScroller.refresh();
		}

        // Check if the store is set as current store
        this.checkCurrentStore();

        // Show patient section
        this.showPatientConcern();

        // show exception message
        this.showExceptionMsg();

        // show holiday hours
        this.showHolidayHours();

        console.log(JSON.stringify(this.model));
        
        /* Rx24 = rexall-open24-fs-rx.png
        REX = REXALL-old.png
        PPD = PharmaPlus.png
        REXALL = REXALL.png	 */

        			var banner = this.model.toJSON().Banner;
        			if (banner == "RX24")
        				{this.$el.find(".detail-address-logo").find("img").attr("src", "image/store-locator-image/logos/rexall-open24-fs-rx.png");
        			    console.log("RX24");}
        			if (banner == "REX")
        				{this.$el.find(".detail-address-logo").find("img").attr("src", "image/store-locator-image/logos/REXALL-old.png");
        			    console.log("REX");}
        			if (banner == "PPD")
        				{this.$el.find(".detail-address-logo").find("img").attr("src", "image/store-locator-image/logos/PharmaPlus.png");
        			    console.log("PPD");}
        			if (banner == "REXALL")
        				{this.$el.find(".detail-address-logo").find("img").attr("src", "image/store-locator-image/logos/REXALL.png");
        			    console.log("REXALL");}

        		return this;
        		

		return this;
	},
	
	setModel: function(model) {
		this.model = model;
	},


    // Show store exception message if it's provided
    showExceptionMsg: function(){
        // Show exception message
        var exceptionMsg = this.model.toJSON().ExceptionMessage;
        var exceptionPrior = this.model.toJSON().ExceptionMessagePriority;
        if(exceptionMsg.length > 0) { // show message
            this.$el.find(".detail-msg-section").show();
            this.$el.find(".detail-msg-section p").html(exceptionMsg);
        }else{      // now message, hide the section
            this.$el.find(".detail-msg-section").hide();
        }
        if(exceptionPrior == 3) // critical message
            this.$el.find(".detail-msg-section").addClass("critical");
        if(exceptionPrior == 2) // critical message
            this.$el.find(".detail-msg-section").addClass("med");
    },

    // Show holiday hours if it's provided in the model
    showHolidayHours: function(){
        var holidays = this.model.toJSON().Exceptions;
        if(holidays.length > 0){
            // show holiday hours section
            this.$el.find(".detail-holiday-hours-section").show();
            this.$el.find(".detail-holiday-hours-section").next(".detail-divider").show();
            // retrieve holiday hours
            var h = 0;
            var h_json = {};    // holiday exceptions in JSON
            for(h; h<holidays.length; h++){

                var h_item = holidays[h];   // retrieve the holiday exception
                var h_date = h_item.Date;   // retrieve the date of the exception
                if(!(h_date in h_json)){    // found new holiday exception
                    h_json[h_item['Date']] = {};
                }

                // add holiday exception to JSON object grouped with date
                h_json[h_item['Date']][h_item['Activity']] = h_item;
            }

            // render holiday hours
            for(var day in h_json){
                var html = '<div class="holiday-hours-content">'
                    + '<div><span>'+getDateAbbr(day)+'</span></div>'
                    // front store hours
                    + (h_json[day]['FS'].TimeOpen.length>0
                        ? '<div><span>'+h_json[day]['FS'].TimeOpen+' - '+h_json[day]['FS'].TimeClose+'</span></div>'
                        : '<div><span>CLOSED</span></div>')
                    // pharmacy hours
                    + (h_json[day]['Rx'].TimeOpen.length>0
                        ? '<div><span>'+h_json[day]['Rx'].TimeOpen+' - '+h_json[day]['Rx'].TimeClose+'</span></div>'
                        : '<div><span>CLOSED</span></div>')
                    + '</div>';
                this.$el.find(".detail-holiday-hours-section").append(html);
            }

        }else{
            // hide holiday hours section
            this.$el.find(".detail-holiday-hours-section").hide();
            this.$el.find(".detail-holiday-hours-section").next(".detail-divider").hide();
        }
    },

    /* set .preferred class to current view */
    setPreferred: function(){
        this.$el.find(".detail-address-section").addClass("preferred");
    },

    /* remove .preferred class from current view */
    removePreferred: function(){
        this.$el.find(".detail-address-section").removeClass("preferred");
    },

	/* Check whether the store is current store and change the set as My Store button to orange */
	checkCurrentStore: function() {
		if(this.model && this.model.get("isPreferred") == true ){
            this.setPreferred()
//			this.$el.find("#detail-address-make-default").css({"background-color": "#ED8C22"});
//			this.$el.find("#detail-address-make-default").find("p").css({"color": "white"});
//			this.$el.find("#detail-address-phone-p").find("img").attr("src", "image/store-locator-image/location-details-phone.png");
		}else{
            this.removePreferred();
        }
			
	},
	
	formatDistance: function() {
		var long = this.$el.find("#detail-address-distance").html();
		this.$el.find("#detail-address-distance").html(parseFloat(long).toFixed(2) + " KM");
	},
	
	getToday: function (id,storeHours) {
		var today = new Date();
		
		var day = today.getDay();
		
//		var storeHours = this.model.toJSON().hours;
		var start, end;
		switch(day)
			{
			case 1:
				if(storeHours.MondayOpen){
					start = storeHours.MondayOpen;
					end = storeHours.MondayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 2:
				if(storeHours.TuesdayOpen){
					start = storeHours.TuesdayOpen;
					end = storeHours.TuesdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 3:
				if(storeHours.WednesdayOpen){
					start = storeHours.WednesdayOpen;
					end = storeHours.WednesdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 4:
				if(storeHours.ThursdayOpen){
					start = storeHours.ThursdayOpen;
					end = storeHours.ThursdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 5:
				if(storeHours.FridayOpen){
					start = storeHours.FridayOpen;
					end = storeHours.FridayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 6:
				if(storeHours.SaturdayOpen){
					start = storeHours.SaturdayOpen;
					end = storeHours.SaturdayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			case 0:
				if(storeHours.SundayOpen){
					start = storeHours.SundayOpen;
					end = storeHours.SundayClose;
				}else{
					this.$el.find(id).html("CLOSED");
					start = -1;
				}
				break;
			default:
				start = -1;
				return "&nbsp;" + "&nbsp;-&nbsp;";
			}

        // over ride regular hours if holiday exception is in the response
        var exception = this.model.toJSON().Exceptions;
        if(exception && exception.length>0){
            // loop to check if today is a holiday
            var h = 0;
            for(h; h<exception.length; h++){
                // determine which activity to check
                if(id == "#pharmacy_open_close"){
                    var act = "Rx";
                }else{
                    var act = "FS";
                }
                // only check for the specific activity
                if(exception[h]['Activity']==act){
                    var holiday_year = parseInt(exception[h]['Date'].substr(0,4));  // get holiday year
                    var holiday_month = parseInt(exception[h]['Date'].substr(5,7)); // get holiday month
                    var holiday_day = parseInt(exception[h]['Date'].substr(8,10));  // get holiday day

                    if(holiday_year == today.getFullYear() &&
                        holiday_month == 1+today.getMonth() &&
                        holiday_day == today.getDate()){
                        if(exception[h]['TimeOpen'].length < 1){
                            // holiday close
                            this.$el.find(id).html("CLOSED");
                            start = -1;
                        }else{
                            // holiday open
                            start = exception[h]['TimeOpen'];
                            end = exception[h]['TimeClose'];
                        }
                    }
                }
            }
        }

		this.getOpen(start, end,id);
		
	},
	
	/*
	 * Determine while this store is currently open or not
	 */
	getOpen: function(start, end,id){
		if(start < 0){
			/* if not open at all */
			return;
		}
		
		/* Store end time */
		var finalEnd = end;
		/*check 12:00 AM*/
		var checkStore12AMStatus = checkStore12AM(start);
		if(checkStore12AMStatus){
			start = "00:00AM";
		}
		start = start.substr(0, start.length-2);
		end = end.substr(0, end.length-2);
		
		var s = start.split(":");
		var e = end.split(":");
	
		/* Create date with arbitrary year and month to compare time */
		var ss=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(s[0]),parseInt(s[1]),parseInt("0"));
		/* Afternoon time, need to revise parse ! */
		var ee=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(e[0]) + 12,parseInt(e[1]),parseInt("0"));
		var current = new Date();
		var cc = new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),current.getHours(), current.getMinutes(),parseInt("0"));
		
		/* Output result */
		if(ss.valueOf() < cc.valueOf() && cc.valueOf() < ee.valueOf()){
			this.$el.find(id).html("OPEN");
		}else{
			this.$el.find(id).html("CLOSED");
		}
	},
	showPDF: function(){

        //console.log(JSON.stringify(this.model));

		$("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");	
		var id ="#pdf-page";
		$.mobile.changePage(id, {transition: 'slide'});	
		//$("#pdf-url").attr("src","https://pharmacists.ab.ca/Content_Files/Files/PatientConcernPoster.pdf");
		
	},
	
    showPatientConcern : function() {
        var province = this.model.toJSON().Province;
        if (province == 'AB') { // Alberta store information section
            this.$el.find("#alberta-pharmacy-license-section").show();
            this.$el.find("#pharmacy-license-section").hide();
        }
        else {
            this.$el.find("#alberta-pharmacy-license-section").hide();
            this.$el.find("#pharmacy-license-section").show();
        }
    },

	/* Go to contact page */
	showContact: function() {
		/* Hide menu header */
		$("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");
		
      	var id = "#feedback-page";
		$.mobile.changePage(id, {transition: 'slide'});
	},

    /* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#detail-page-info").popup( "option", "history", false );
		$("#detail-page-info").popup({ transition: "pop" });
		$("#detail-page-info").popup("open");
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#detail-page-info").popup("close");
	},
	
	containsStr : function(str,substr,isIgnoreCase){
		if(isIgnoreCase)
		{
		 str=str.toLowerCase();
		 substr=substr.toLowerCase();
		}
		var startChar=substr.substring(0,1);
		var strLen=substr.length;
		for(var j=0;j<str.length-strLen+1;j++)
		{
			if(str.charAt(j)==startChar)
			{
				if(str.substring(j,j+strLen)==substr)
				{
					return true;
				}  
			}
		}
		return false;
	},
	
	showStoreHours : function(id,consolidatedHours){
		if(!consolidatedHours){
			return;
		}
		var hours = consolidatedHours.split("|");
		var result = "";
		for(var i=0;i<hours.length;i++){
		//	result = "<tr><td class='consolidated-hours'>"+this.splitHoursStr(hours[i])+"</td></tr>";
			
			if(this.containsStr(hours[i],"12:00 AM - 11:59 PM",true)){
				result = "<li>"+this.splitHoursStr(hours[i].replace("12:00 AM - 11:59 PM","24 Hours"))+"</li>";
			}else{
				result = "<li>"+this.splitHoursStr(hours[i])+"</li>";
			}
			
			$(id).append(result);
		}
	},
	
	 splitHoursStr : function(str){
		   var newStr = '';
		   if(str&&str.indexOf(":")!=-1){
			   var index = str.indexOf(":");
			   newStr = str.substring(0,index)+' :'+str.substring(index+1,str.length);
			}
		   if(newStr!=''){
			   return newStr;
		   }else{
			   return str;
		   }
		},
});

// Open the license PDF link
// Called directly from index.html
function windowOpenUrl(url){

    // Load page first so the link will seem to be more responsive to the user
    var id = "#licensePdf-page";
    $.mobile.changePage(id, {transition: 'slide'});
    // close menu bars
    appView.closeClosestStore();
    // load url
    document.getElementById('ios-licensePdf-container').src = null;
    document.getElementById('ios-licensePdf-container').src = url;

}

// An utility function that takes a date string and returns the abbreviation of the date
function getDateAbbr(s) {
    var month = s.substring(5, 7);
    var day = s.substring(8, 10);

    // replace month number with abbreviation
    if (month == '01') {
        month = "Jan.";
    } else if (month == '02') {
        month = "Feb.";
    } else if (month == '03') {
        month = "Mar.";
    } else if (month == '04') {
        month = "Apr.";
    } else if (month == '05') {
        month = "May.";
    } else if (month == '06') {
        month = "Jun.";
    } else if (month == '07') {
        month = "Jul.";
    } else if (month == '08') {
        month = "Aug.";
    } else if (month == '09') {
        month = "Sep.";
    } else if (month == '10') {
        month = "Oct.";
    } else if (month == '11') {
        month = "Nov.";
    } else if (month == '12') {
        month = "Dec.";
    } else {
        console.log("Error in getDateAbbr: unable to parse month <" + month + ">");
    }

    return month + " " + day;
}