var StoreDirectionView = Backbone.View.extend({
	
	el:$("#direction-page"),
	
	events: {
		"tap #direction-search-submit"		: "searchDirection",
		"keypress #direction-search-input"	: "keySearchDirection",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		// nothing to do here;
	},
	
	/* set up googles direction service */
	setupDirectionService: function() {
		if(!google.maps)
			return;
		/* Create DirectionsService object */
		this.directionService = new google.maps.DirectionsService();
		/* Create DirectionsRenderer object without showing default markers*/
		this.directionDisplay = new google.maps.DirectionsRenderer({suppressMarkers: true});
		/* Set the target map for direction service */
	},
	
	/* Show direction route */
	displayDirection: function(lat, lng) {
		/* Show the route on map */
		var self = this;

        /* Exception handler for connection break */
        if (!this.directionService || !this.directionDisplay) {
            this.setupDirectionService();
        }

              
		/* Reset mylocation's marker */
		if(this.myLocationMarker){
			this.myLocationMarker.setMap(null);
		}

        if (this.storeMarker)
        {
			this.storeMarker.setMap(null);
		}
       
		/* Add self location to the map */
		this.myLocationMarker = new google.maps.Marker({
				position: new google.maps.LatLng(lat, lng),
				map: this.map
		});

//        self.storeMarker = new google.maps.Marker({
//				position: new google.maps.LatLng(self.storeLocation.lat(), self.storeLocation.lng()),
//				map: self.map,
//                icon: iconimg
//           });
		
		/* Reset previous route */
		this.directionDisplay.setMap(null);
		this.directionDisplay.setMap(this.map);
		
/* Set route information panel, need to be discussed where to put */
//directionDisplay.setPanel(document.getElementById('directions-panel'));

		/* Request variables */
		var start = new google.maps.LatLng(lat, lng);
		var end = new google.maps.LatLng(this.storeLocation.lat(), this.storeLocation.lng());
		var mode = google.maps.DirectionsTravelMode.DRIVING;
		
		var request = {
				origin: start,
				destination: end,
				travelMode: mode
		};
		
		self.directionDisplay.markerOptions = self.storeMarker;
        self.directionDisplay.suppressMarkers = true;
         
		this.directionService.route(request, function(response, status) {
	        if (status == google.maps.DirectionsStatus.OK) {
	        	self.directionDisplay.setDirections(response);
	           
//               setTimeout(
//                self.storeMarker = new google.maps.Marker({
//				position: new google.maps.LatLng(self.storeLocation.lat(), self.storeLocation.lng()),
//				map: self.map,
//                icon: iconimg
//		        }), 100);
                
		
	          /*
	          response.routes[0].legs[0].start_location = start;
	          response.routes[0].legs[0].end_location = end;
	          */
	        }else{
	        	jAlert("Error getting directions to the store.","Please Try Again");
	        }
	    });
	},
	
	keySearchDirection : function (e) {
		if(e.keyCode === 13) {
			this.searchDirection();
		}
	},
	
	searchDirection: function () {
	    var self = this;
		var q = $("#direction-search-input").val();
		var JAlertProxy = function(msg,title) {
            self.JAlert(msg,title);
			};
			/* Search for the query location */
		if(q){
			 var geocoder = new google.maps.Geocoder();
			 var self = this;
			 geocoder.geocode( { 'address': q}, function(results, status) {
				    if (status == google.maps.GeocoderStatus.OK) { 
				      var searchLat = results[0].geometry.location.lat();
				      var searchLng = results[0].geometry.location.lng();
				      /* Display Direction */
				      self.displayDirection(searchLat, searchLng);
				      
				    } else {
				    if (status == google.maps.GeocoderStatus.ZERO_RESULTS) { 
				      $.alerts.alert('Provide a valid address.',"Please Try Again");
			      		}
			      	else
			      	  {
				      jAlert('Map Search was not successful for the following reason: ' + status,"Please Try Again");
				    }
				  }
				});
		}else{
			jAlert("Provide a valid address.","Please Try Again");
			return true;
		}
	},
	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
//		$("#locator-page-info").popup({ transition: "pop" });
//		$("#locator-page-info").popup("open");
		//this.infoScroll.refresh();
		$("#direction-page-info").popup( "option", "history", false );
		$("#direction-page-info").popup({ transition: "pop" });
		$("#direction-page-info").popup("open");

	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#direction-page-info").popup("close");
	},
	
	render: function() {
		//console.log(JSON.stringify(this.model));
         /* Empty Search box */
		$("#direction-search-input").val("");

       // var toAddress = this.model.toJSON().Address + ", " + this.model.toJSON().City + ", " + this.model.toJSON().Province + " " + this.model.toJSON().PostalCode;
        var toAddress = storeSubstring(this.model.toJSON().Address + ", " + this.model.toJSON().City + ", " + this.model.toJSON().Province + " " + this.model.toJSON().PostalCode,44);
        console.log(toAddress);
        $("#direction-to-address3").html(toAddress);
        

		/* Exception handler for connection break */
		if(!this.directionService || !this.directionDisplay){
			this.setupDirectionService();
		}
		
		var lat = this.model.toJSON().Latitude;
		var lng = this.model.toJSON().Longitude;
		
		this.storeLocation = new google.maps.LatLng(lat, lng);
		
		/* Default map settings */
		var mapOptions = {
				zoom: 15,			
				center: this.storeLocation,
				mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		/* Initialize new map */
		// Mike Map Change: in showMap to create map only if it do not exist.
		//
				if (!this.map)
				 {		
				this.map = new google.maps.Map(document.getElementById("locator-direction-div"), mapOptions);
				 }
				 this.map.setZoom(15);
				if (this.endpointMarker)
				  {
				  this.endpointMarker.setMap(null);
				  }
		// Mike Map Change End	
		
		/* Set the target map for direction service */
		this.directionDisplay.setMap(this.map);
		
         var iconimg = {
         	    url: 'image/store-locator-image/location-pin-teal.png',
         	    size: new google.maps.Size(82, 76),
         	    origin: new google.maps.Point(0,0),
         	    anchor: new google.maps.Point(22.5,40),
         	    scaledSize: new google.maps.Size(45, 40)
         	  };
        if (appView.showClinicDirection) {
            if (clinicStoreDetailPage.model.get("isPreferredClinic")) {
                iconimg = {
                 	    url: 'image/store-locator-image/location-pin-preferred-clinic.png',
                 	    size: new google.maps.Size(82, 76),
                 	    origin: new google.maps.Point(0,0),
                 	    anchor: new google.maps.Point(22.5,40),
                 	    scaledSize: new google.maps.Size(45, 40)
                 	  };
            }
            else {
                iconimg = {
                 	    url: 'image/store-locator-image/clinic-location-pin-teal.png',
                 	    size: new google.maps.Size(82, 76),
                 	    origin: new google.maps.Point(0,0),
                 	    anchor: new google.maps.Point(22.5,40),
                 	    scaledSize: new google.maps.Size(45, 40)
                 	  };
            }
        }
        else if (storeDetailPage.model.get("isPreferred")) {
            iconimg = {
             	    url: 'image/store-locator-image/location-pin-preferred.png',
             	    size: new google.maps.Size(82, 76),
             	    origin: new google.maps.Point(0,0),
             	    anchor: new google.maps.Point(22.5,40),
             	    scaledSize: new google.maps.Size(45, 40)
             	  };
        }

		/* Add marker */
		var marker = new google.maps.Marker({
			position: this.storeLocation,
			map: this.map,
			icon: iconimg, 
		});
		this.endpointMarker = marker;
	},
});