//var serviceList=[];
var StoreFilterView = Backbone.View.extend({
	
	initialize: function () {
	  /* Initialize store service scroller */
      this.storeFilterScroller = new iScroll("store-service-filter-div", {
    	  	hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
      });
      
      /* remember the filter list */
      this.serviceList = new Array();
      this.filterChanged = false;      
//      this.render();           
	},
	
	el: $("#store-service-filter"),
	template: Handlebars.compile($("#locator-filter-template").html()),
	events: {
	    "tap #filterClear"      : "filterReset",
		"tap #filterDone" 		: "filterStores",
		"tap #filterHide"       : "filterHide",
		"tap .store-service-filter-item"	: "toggleFilterItem",
	},
	
	setModel:function(model) {
		this.model = model;
	},
	
	/* Toggle the check box of filter items */
	toggleFilterItem: function(e) {
		if($(e.target).prop("tagName").toUpperCase() == "INPUT"){
			return;	/* Let html tag do the job if tap on input */
		}
		var checkBox = $(e.target).find('input');
		checkBox.prop("checked", !checkBox.prop("checked"));
	},
	
	filterStores : function() {	
		/* Remeber previous list to compare, !! the compare is redundant now since filterReset is called every time the filter is closed */
		var previous = this.serviceList;
		/* new empty array list */
		var list = [];
	    /* get the checked store service */
		$("[name='filterCheckbox']:checked").each(function(index, value){
			list[index] = $(value).val();
    	});

		this.serviceList = list;
		/* Compare to check difference */
		if(this.notSameList(list, previous)){
			if($("#locator-search-input").val()){
				/* use search input */
				storeLocatorView.searchStores("filterSearch");
			}else if(this.model){
				/* use geolocation */
                storeLocatorView.fromPage = "filterSearch";
				this.model.fetchDataWithDefaultLocation();
					
			}
		}
				
    	$("#store-service-filter").slideUp('normal');

         this.filterChanged = false;  
	},
	
	filterReset :function(){
	    $("[name='filterCheckbox']").attr("checked",false);
	    this.serviceList = [];

        this.filterChanged = true;  
	},
	
	filterHide :function(){
	  //slideToggle("slow"); 
	  $("#store-service-filter").slideUp('normal');
	  var list = [];
        /* get the checked store service */
        $("[name='filterCheckbox']:checked").each(function(index, value){
	        list[index] = $(value).val();
        });

        this.serviceList = list;
	},
	
	/* Compare two filter list, return ture if they are not the same */
	notSameList: function(a, b){
		if(!a || !b)
			return;
		
		/* Compare lenght */
		if(a.length != b.length || this.filterChanged)
			return true;
		/* Compare content */
		var i = 0;
		for(i = 0; i < a.length; i++){
			if(a[i] != b[i])
				return true;
		}
		return false;
	},
	render : function(){

		var current = this;
		$("#locator-page").find(".rexall-page-header").html("Loading store service filter &nbsp;&nbsp  <div id='circleG'><div id='circleG_1' class='circleG'></div><div id='circleG_2' class='circleG'></div><div id='circleG_3' class='circleG'></div></div>");
		$.ajax({
            url:  getMyRexallWebserviceRoot()+"v3/standard/Rexall.svc/StoreServicesList/",
            type: 'get',
            data: {
					APIKey : getWebserviceAPIKey()
			      },
            dataType: 'json',
            success: function(data) {
                if (data.Success == 1)
                {
                	$("#store-service-filter-ul").html(current.template(current.sortObjectArray(data)));
            	}else
                {
                   jAlert("Can not process your request filter, please try again later.", "Something Went Wrong"); 
                }
                
            },
            error: function() {
            	jAlert("Can not process your request filter, please try again later.", "Something Went Wrong"); 
            },
            complete: function(XMLHttpRequest, textStatus){
            	storeFilterView.storeFilterScroller.refresh();
            	$("#locator-page").find(".rexall-page-header").html("<p>STORE LOCATOR</p><div class='rexall-page-header-info'></div>")
            }
        });
		
	},
	
	sortObjectArray : function(data){
		if(!data||data.ServicesList.length==0){
			return null;
		}
		var servicesList = data.ServicesList;
		for(var i=0;i<servicesList.length-1;i++){
			for(var j=i+1;j<servicesList.length;j++){
				if(servicesList[j].replace(/(^\s+)|(\s+$)/g,'').localeCompare(servicesList[i].replace(/(^\s+)|(\s+$)/g,''))<0){
					var t = servicesList[i];
					servicesList[i] = servicesList[j];
					servicesList[j] = t;
				}
			}
		}
		data.ServicesList = servicesList;
		return data;
	},
	
});

