var StoreListItemView = Backbone.View.extend({
	
	tagName: 'li',

	template: Handlebars.compile($("#locator-list-li").html()),
	
	events: {
		//"vmousedown .margin_bottom_1em"	: 	"mouseDownItem",
		//"vmouseup .margin_bottom_1em"	: 	"mouseUpItem",
		//"tap .margin_bottom_1em"		: 	"showDetail",
        //"tap .list-item-direction"		:	"showDirection", // removed after css cleanup
        //"tap .list-item-pointer"		: 	"showDirection"      // removed after css cleanup

        "tap .locator-list-item-top-left, .locator-list-item-bottom-right"	: 	"showDetail",
        "tap .item-route-img, .item-distance-img"    :   "showDirection"
	},
	
	initialize: function () {
		
		/* Render, note we have to render before listenTo 
		 * otherwise there will be no DOM to change.
		 */
		this.render();
		
		/* Listen to the isPreferred attribute of model */
		this.listenTo(this.model, "change:isPreferred", this.checkCurrentStore);
		this.listenTo(this.model, "change:isPreferredClinic", this.checkCurrentClinic);
		
		
	},
	
	render: function () {
		
		this.$el.html(this.template(this.model.toJSON()));
		/* Add style class to the list item */
		this.$el.addClass("locator-list-item");
		/* Handle value */
		this.getToday();
		this.formatDistance();
		this.checkCurrentStore();
		this.checkCurrentClinic();
		
		if (this.model.toJSON().StoreHours) {   /* In store locator ? */
			/* Rx24 = rexall-open24-fs-rx.png
			REX = REXALL-old.png
			PPD = PharmaPlus.png
			REXALL = REXALL.png	 */		
					var banner = this.model.toJSON().Banner;
					console.log("Banner is:" + banner);
					if (banner == "RX24")
					  {this.$el.find(".item-logo").find("img").attr("src", "image/store-locator-image/logos/rexall-open24-fs-rx.png");
					    console.log("RX24");}
					if (banner == "REX")
					  {this.$el.find(".item-logo").find("img").attr("src", "image/store-locator-image/logos/REXALL-old.png");
					    console.log("REX");}
					if (banner == "PPD")
					  {this.$el.find(".item-logo").find("img").attr("src", "image/store-locator-image/logos/PharmaPlus.png");
					    console.log("PPD");}
					if (banner == "REXALL")
					  {this.$el.find(".item-logo").find("img").attr("src", "image/store-locator-image/logos/REXALL.png");
					    console.log("REXALL");} 

		}else{	                                /* In clinic locator ? */
	        this.$el.addClass("clinic");
		}

		return this;
	},
	
	/* Press on list item */
//	mouseDownItem: function(e) {
//		if(!e.target.className.match("list-item-direction")
//			&& !e.target.className.match("list-item-pointer")){
//			$(e.target).closest(".margin_bottom_1em").addClass("pressed");
//		}
//	},
//	/* Release list item */
//	mouseUpItem: function(e) {
//		if(!e.target.className.match("list-item-direction")
//			&& !e.target.className.match("list-item-pointer")){
//			$(e.target).closest(".margin_bottom_1em").removeClass("pressed");
//		}
//	},
//	/* Press on direction icon */
//	mouseDownDirection: function(e) {
//		$(e.target).closest(".list-item-direction").addClass("pressed");
//	},
//	/* Release on direction icon */
//	mouseUpDirection: function(e) {
//		$(e.target).closest(".list-item-direction").removeClass("pressed");
//	},
	/* Hide the <li> tag */
	hideItem: function() {
		this.$el.hide();
	},
	/* Show the <li> tag */
	showItem: function() {
		this.$el.show();
	},
	

	formatDistance: function() {
		var long = this.$el.find(".item-distance-info p").html();
		var distance = parseFloat(long).toFixed(2);
		this.$el.find(".item-distance-info p").html(distance+"KM");
	},
	
	showDetail:	function (e) {

		if(!e){	/* calling from self, no need to go to detail page, just create detail page model */
			
			/* Create Detail page */
			if(location.hash == "#clinic-page"){
				/* Clinic Detail */
				clinicStoreDetailPage.setModel(this.model);
				clinicStoreDetailPage.render();
				                
			    $("#clinic-locator-menu ul li[class='locator-detail']").css("visibility","visible");
			    $("#clinic-locator-menu ul li[class='locator-first']").css("visibility","visible");
			
			    /* Copy from MainRouter detail page .... */
			    /* Show map view button */
			    $("#clinic-map-view").removeClass("locator-menu-hide");	
			    /* Hide detail view button */
			    $("#clinic-detail-view").addClass("locator-menu-hide");
			    /* Hide list view button */
			    $("#clinic-list-view").addClass("locator-menu-hide");
			    /* Show locator-detail button group */
			    $("#clinic-locator-menu ul li[class='locator-detail']").show(200);
			

			}else{
				/* Store detail */
			storeDetailPage.setModel(this.model);
			storeDetailPage.render();
			
			$("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
			$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
			
			/* Copy from MainRouter detail page .... */
			/* Show map view button */
			$("#map-view").removeClass("locator-menu-hide");	
			/* Hide detail view button */
			$("#detail-view").addClass("locator-menu-hide");
			/* Hide list view button */
			$("#list-view").addClass("locator-menu-hide");
			/* Show locator-detail button group */
			$("#locator-menu ul li[class='locator-detail']").show(200);
			$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
			/* Check if has refill button */
			if(storeDetailPage.model.hasRefill()){
				$("#online-refill").show(200);
				}
			}
			
		}else if(e.target.nodeName !== "A" 
			//&& !e.target.className.match("list-item-pointer")   // removed after css cleanup
			//&& !e.target.className.match("list-item-direction") // removed after css cleanup
            && !e.target.className.match("item-route-img")
            && !e.target.className.match("item-distance-img")
            ){
			if(location.hash == "#clinic-page"){
				clinicStoreDetailPage.fromMapPage(false);
				this.showClinicDetail();			
			}else{
				storeDetailPage.fromMapPage(false);
				/* Store detail */
				var id = "#detail-page";
				$.mobile.changePage(id, {transition: 'slide'});
				/* Change appView currentPage */
				appView.currentPage = id;
				/* Create Detail page */
				storeDetailPage.setModel(this.model);
				storeDetailPage.render();
				$("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
				$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
		}		
		}		
	},

    showClinicDetail:function() {
            /* Clinic detail */
			var id = "#clinic-detail-page";
			$.mobile.changePage(id, {transition: 'slide'});
			/* Change appView currentPage */
			appView.currentPage = id;
			/* Create Detail page */
			clinicStoreDetailPage.setModel(this.model);
			clinicStoreDetailPage.render();

            $("#clinic-locator-menu ul li[class='locator-detail']").css("visibility","visible");
			$("#clinic-locator-menu ul li[class='locator-first']").css("visibility","visible");
            //show direction
            $("#clinic-show-direction").removeClass("locator-menu-hide");	
			/* Hide my clinic button */
			$("#my-clinic").addClass("locator-menu-hide");
            $("#clinic-detail-view").addClass("locator-menu-hide");
            console.log("showClinicDetail");
    },
	
	/* Show direction of this store */
    showDirection: function(e) {
        e.preventDefault();
		
        var currentPage = location.hash;

        console.log(" showDirection location.hash =" + currentPage);
       
        /* Go detail page first */
        this.showDetail();
		
        if (currentPage == "#clinic-page") {
            if (appView) {
            	$(".locator-menu ul li>p").css("color","#6d6e6e");
            	$("#clinic-show-direction>p").css("color","rgba(24, 199, 189)");
                this.showClinicDirection();
            }
        }
        else {
            /* Ask appview to show the direction */
            if (appView) {
            	$(".locator-menu ul li>p").css("color","#6d6e6e");
            	$("#show-direction>p").css("color","rgba(24, 199, 189)");
                appView.showDirection({'isFromListView': true});
            }
        }
        //		var id = "#direction-page";
        //		$.mobile.changePage(id, {transition: 'slide'});
        //	
        //		/* creat direction page */
        //		var directionPage = new StoreDirectionView({"model" : storeDetailPage.model});
        //		directionPage.render();
        //		/* Search by default, from search location */
        //		var lt = storeDetailList.lat;
        //		var lg = storeDetailList.lng;
        //		directionPage.displayDirection(lt, lg);
    },

    showClinicDirection: function() {
		
		appView.showClinicDirection = true;
        clinicLocatorView.directionFromListView = true;
		var id = "#direction-page";
		$.mobile.changePage(id, {transition: 'slide'});
        $("#direction-page-title").html("MEDICAL CLINIC LOCATOR");
		
	},
	
	getToday: function () {
		
		var today = new Date();
		
		var day = today.getDay();

		var storeHours = this.model.toJSON().StoreHours;
		if (this.model.toJSON().ClinicHours)
		 storeHours = this.model.toJSON().ClinicHours;
		
		var start, end;
		
		if (!(storeHours.MondayOpen || storeHours.TuesdayOpen || storeHours.WednesdayOpen || storeHours.ThursdayOpen 
		   || storeHours.FridayOpen || storeHours.SaturdayOpen || storeHours.SundayOpen))
			{		
			this.$el.find(".todayOpenHour").html("&nbsp;");
			return;
			}
		
		switch(day)
			{
			case 1:
				if(storeHours.MondayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:" + storeHours.MondayOpen + "&nbsp;-&nbsp;" + storeHours.MondayClose);
					start = storeHours.MondayOpen;
					end = storeHours.MondayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 2:
				if(storeHours.TuesdayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.TuesdayOpen + "&nbsp;-&nbsp;" + storeHours.TuesdayClose);
					start = storeHours.TuesdayOpen;
					end = storeHours.TuesdayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 3:
				if(storeHours.WednesdayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.WednesdayOpen + "&nbsp;-&nbsp;" + storeHours.WednesdayClose);
					start = storeHours.WednesdayOpen;
					end = storeHours.WednesdayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 4:
				if(storeHours.ThursdayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.ThursdayOpen + "&nbsp;-&nbsp;" + storeHours.ThursdayClose);
					start = storeHours.ThursdayOpen;
					end = storeHours.ThursdayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 5:
				if(storeHours.FridayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.FridayOpen + "&nbsp;-&nbsp;" + storeHours.FridayClose);
					start = storeHours.FridayOpen;
					end = storeHours.FridayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 6:
				if(storeHours.SaturdayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.SaturdayOpen + "&nbsp;-&nbsp;" + storeHours.SaturdayClose);
					start = storeHours.SaturdayOpen;
					end = storeHours.SaturdayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			case 0:
				if(storeHours.SundayOpen){
					this.$el.find(".todayOpenHour").html("TODAY:&nbsp;" + storeHours.SundayOpen + "&nbsp;-&nbsp;" + storeHours.SundayClose);
					start = storeHours.SundayOpen;
					end = storeHours.SundayClose;
				}else{
					this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
					start = -1;
				}
				break;
			default:
				start = -1;
				return "&nbsp;" + "&nbsp;-&nbsp;";
			}

        // over ride regular hours if holiday exception is in the response
        var exception = this.model.toJSON().Exceptions;
        if(exception && exception.length>0){
            // loop to check if today is a holiday
            var h = 0;
            for(h; h<exception.length; h++){
                // only check for store hours
                if(exception[h]['Activity']=="FS"){
                    var holiday_year = parseInt(exception[h]['Date'].substr(0,4));  // get holiday year
                    var holiday_month = parseInt(exception[h]['Date'].substr(5,7)); // get holiday month
                    var holiday_day = parseInt(exception[h]['Date'].substr(8,10));  // get holiday day
                    // match holiday
                    if(holiday_year == today.getFullYear() &&
                        holiday_month == 1+today.getMonth() &&
                        holiday_day == today.getDate()){
                        if(exception[h]['TimeOpen'].length < 1){
                            // holiday close
                            this.$el.find(".todayOpenHour").html("<span class='teal-font'>TODAY:CLOSED</span>");
                            start = -1;
                        }else{
                            // holiday open
                            start = exception[h]['TimeOpen'];
                            end = exception[h]['TimeClose'];
                        }
                        break;
                    }
                }
            }
        }
		
		this.getOpen(start, end);
		
	},
	
	/*
	 * Determine while this store is currently open or not
	 */
	getOpen: function(start, end){
		
		if(start < 0){
			/* if not open at all */
			return;
		}
		
		/* Store end time */
		var finalEnd = end;
		/*check 12:00 AM*/
		var checkStore12AMStatus = checkStore12AM(start);
		if(checkStore12AMStatus){
			start = "00:00AM";
		}
		/*check 11:59 PM*/
		var checkStore12PMStatus = checkStore12PM(finalEnd);
		if(checkStore12PMStatus&&checkStore12AMStatus){
			this.$el.find(".todayOpenHour").html("<span class='teal-font'>OPEN </span>24 Hours");
			return;
		}
		start = start.substr(0, start.length-2);
		end = end.substr(0, end.length-2);
		
		var s = start.split(":");
		var e = end.split(":");
	
		/* Create date with arbitrary year and month to compare time */
		var ss=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(s[0]),parseInt(s[1]),parseInt("0"));
		/* Afternoon time, need to revise parse ! */
		var ee=new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),parseInt(e[0]) + 12,parseInt(e[1]),parseInt("0"));
		var current = new Date();
		var cc = new Date(parseInt("2001"),(parseInt("01"))-1,parseInt("01"),current.getHours(), current.getMinutes(),parseInt("0"));
		
		/* Output result */
		if(ss.valueOf() < cc.valueOf() && cc.valueOf() < ee.valueOf()){
			this.$el.find(".todayOpenHour").html("<span class='teal-font'>OPEN</span> Until " + finalEnd + " Today");
		}else{
			this.$el.find(".todayOpenHour").html("<span class='teal-font'>NOW CLOSED</span>");
		}
	},
	
	/* Check whether this is the current store */
	checkCurrentStore: function(){
        if (location.hash == "#clinic-page" || location.hash == "#clinic-detail-page")
            return false;                               /* Discard for Clinic page */

        if(this.model.get("isPreferred") === true){ 	/* Is preferred store */
            this.$el.addClass("preferred");
        }else{                                          /* Not preferred store */
            this.$el.removeClass("preferred");
        }
	},

    /* Check whether this is the current clinic */
    checkCurrentClinic: function() {
        if(location.hash != "#clinic-page" && location.hash != "#clinic-detail-page")
            return false;                               /* discard for Store Locator Page */

        if(this.model.get("isPreferredClinic") == true){/* Is preferred clinic */
            this.$el.addClass("preferred");
        }else{										    /* Not preferred clinic */
            this.$el.removeClass("preferred");
        }
    },

   
	
});

function checkStore12AM(startHour){
	if(startHour.substring(startHour.length-2, startHour.length).toUpperCase()=='AM'&&
			parseInt(startHour.substring(0, startHour.length-2))==12){
		return true;
	}else{
		return false;
	}
};

function checkStore12PM(endHour){
	if(endHour.substring(endHour.length-2, endHour.length).toUpperCase()=='PM'&&
			$.trim(endHour.substring(0, endHour.length-2))=="11:59"){
		return true;
	}else{
		return false;
	}
	
};