var StoreListMapView = Backbone.View.extend({
	
	tagName: 'div',
	
	//el: $("locator-map-div"),
	el:$("#locator-map-div"),
	
	events: {
		
	},
	
	initialize: function () {
						
		/* Initialize new map */
		//this.map = 
		
		/* Initialize marker container */
		this.markers = new Array();
		
		/* Add listeners */
		this.listenTo(this.collection, "reset", this.resetMarkers);
		//this.listenTo(this.collection, "add", this.addMarker);

	},
	
	showMap: function() {
	    
        
		/* Default map settings */
		var mapOptions = {
				zoom: 10,	
				mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		
		/* create new map */
		
		// Mike Map Change: in showMap to create map only if it do not exist.
		//
//				if (!this.map)
//				 {
//				this.map = new google.maps.Map(document.getElementById("locator-map-div"), mapOptions);
//				 }
//				 else
//				 {
//				 this.resetMarkers();
//				 }
//				 this.map.setZoom(10);
        if (!this.map)
        {
            this.map = new google.maps.Map(document.getElementById("locator-map-div"), mapOptions);
        }
        else
        {
            this.resetMarkers();
        }
        this.map.setZoom(10);
		// Mike Map Change End
		
		/* Exception handling: No previous success geo search */
		if(!this.myLocation){
			/* Don't have a center location, set Britannia headoffice as default location */
			this.map.setCenter(new google.maps.LatLng(57.657158, -101.777344));
			this.map.setZoom(4);
			return;
		}
		
		/* Set map center with searched location */
		this.map.setCenter(this.myLocation);
		
		/* Add markers */
		this.addMarkers();
		
		/* center map */
		this.centerMap(this.map, this.markers)
	},
	
	resetCenter:function () {
		this.map.setCenter(this.myLocation);
	},
	
	resetMarkers: function() { 
		
		/* remove from map */
		$.each(this.markers, function(index, value) {
			value.setMap(null);
		});
		/* empty array */
		this.markers.length = 0;
		
		/* reset the center of the map */
		this.myLocation = new google.maps.LatLng(this.collection.lat, this.collection.lng);
		
		/* push to markers array */
		//this.markers.push(newCenter);
	},
	
//	addMarker: function(item) {
//		/* Get location values */
//		var long = item.toJSON().Longitude;
//		var lat = item.toJSON().Latitude;
//		
//		/* Create new location */
//		var latitudeAndLongitude = new google.maps.LatLng(lat, long);
//		
//		/* push marker */
//		this.markers.push(marker);
//	},
	
	addMarkers: function(){
		
		
		var markers = this.markers;
		var map = this.map;
		
		/* Add self location to the map */
		var myLocationMarker = new google.maps.Marker({
				position: this.myLocation,
				map: this.map
		});
		this.markers.push(myLocationMarker);
		
		/* Filling marker container */
		$.each(this.collection.models, function (index, value) {
			var long = value.toJSON().Longitude;
			var lat = value.toJSON().Latitude;

            //console.log(JSON.stringify(value));

			var latitudeAndLongitude = new google.maps.LatLng(lat, long);

			/* Create new marker */

            var mapicon = {
            	    url: 'image/store-locator-image/location-pin-teal.png',
            	    size: new google.maps.Size(82, 76),
            	    origin: new google.maps.Point(0,0),
            	    anchor: new google.maps.Point(22.5,40),
            	    scaledSize: new google.maps.Size(45, 40)
            	  };
            if (value.toJSON().isPreferred) {
                mapicon = {
                	    url: 'image/store-locator-image/storelocator-mystore-pin-teal.png',
                	    size: new google.maps.Size(82, 76),
                	    origin: new google.maps.Point(0,0),
                	    anchor: new google.maps.Point(22.5,40),
                	    scaledSize: new google.maps.Size(45, 40)
                	  };
            }

			var marker = new google.maps.Marker({
				position: latitudeAndLongitude,
				map: map,
				//icon: 'http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld='+ (index+1) + '|0FB0A8|FFFFFF'
				icon: mapicon
			});

			/* Add listener for a click on the marker */
			google.maps.event.addListener(marker, 'click', function () {
				storeDetailPage.fromMapPage(true);
				var id = "#detail-page";
				$.mobile.changePage(id, {transition: 'slide'});
				/* Change appView currentPage */
				appView.currentPage = id;
				/* Create Detail page */
				storeDetailPage.setModel(value);
				storeDetailPage.render();
				$("#locator-menu ul li[class='locator-detail']").css("visibility","visible");
				$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
			});
		
			/* Insert marker */
			markers.push(marker);
			
		});
	},
	
	/*
	 * Center map and set zoom level so that all markers are visible
	 * Source: http://www.adick.at/2008/12/30/set-zoom-level-of-a-google-map-so-that-all-markers-are-visible/
	 */
	centerMap: function(map, markers) {

		/* Calculate the maximum latitude and longitude */
		for(var i in markers) {
			var this_lat = markers[i].getPosition().lat() || null;
			var this_lng = markers[i].getPosition().lng() || null;
		 
			if(
			(this_lat && !isNaN(this_lat)) &&
			(this_lng && !isNaN(this_lng))
			) {
				var minLat = minLat || this_lat;
				var maxLat = maxLat || this_lat;
				var minLng = minLng || this_lng;
				var maxLng = maxLng || this_lng;
				 
				/* get min and max markers and save in variables */
				minLat = Math.min(minLat, this_lat);
				maxLat = Math.max(maxLat, this_lat);
				minLng = Math.min(minLng, this_lng);
				maxLng = Math.max(maxLng, this_lng);
			}
		}
	 	 
		/* Avg of the coordinates */
		var centerLat = minLat + ((maxLat - minLat) / 2);
		var centerLng = minLng + ((maxLng - minLng) / 2);
	 	 
		/* What's the distance of our coordinates? (in kilometers) */
		var dist = (6371 *
			Math.acos(
					Math.sin(minLat / 57.2958) *
					Math.sin(maxLat / 57.2958) + (
							Math.cos(minLat / 57.2958) *
							Math.cos(maxLat / 57.2958) *
							Math.cos(maxLng / 57.2958 - minLng / 57.2958)
												 )
					)	
		);
		 
		/* Default zoom level */
		var zoomLvl = 10;
		 
		/* determine the zoom level out of the calculated distance */
		if(dist < 24576)
		zoomLvl = 1;
		if(dist < 12288)
		zoomLvl = 2;
		if(dist < 6144)
		zoomLvl = 3;
		if(dist < 3072)
		zoomLvl = 4;
		if(dist < 1536)
		zoomLvl = 5;
		if(dist < 768)
		zoomLvl = 6;
		if(dist < 384)
		zoomLvl = 7;
		if(dist < 192)
		zoomLvl = 8;
		if(dist < 96)
		zoomLvl = 9;
		if(dist < 48)
		zoomLvl = 10;
		if(dist < 24)
		zoomLvl = 11;
		if(dist < 11)
		zoomLvl = 12;
		if(dist < 4.8)
		zoomLvl = 13;
		if(dist < 3.2)
		zoomLvl = 14;
		if(dist < 1.6)
		zoomLvl = 15;
		if(dist < 0.8)
		zoomLvl = 16;
		if(dist < 0.3)
		zoomLvl = 17;
		 
		/* Set center point of the map */
		map.setCenter(new google.maps.LatLng(centerLat, centerLng));	
		/* Set zoom level of the map */
		map.setZoom(zoomLvl);	
		
	},
//	getTextIcon: function(){
//		alert(111);
//        var icon = new google.maps.Icon();
//        icon.image = "image/icon-locator-green.png";
//        icon.iconSize = new GSize(37,37 );
//        icon.iconAnchor = new GPoint(0, 40);
//        icon.infoWindowAnchor = new GPoint(5, 1);
//        alert(icon);
//        return icon;
//    }
	setDetailPageModel: function(detailPageModel){
		this.detailPageModel = detailPageModel;
	},

	showMapFromDetailPage: function(){
//		alert(JSON.stringify(this.detailPageModel.toJSON()));
//        var markers = this.markers;
//		var map = this.map;
//		
//		/* Add self location to the map */
//		var myLocationMarker = new google.maps.Marker({
//				position: this.myLocation,
//				map: this.map
//		});
//		this.markers.push(myLocationMarker);
//		
		// Mike Map Change: in showMapFromDetailPage to use this.detailMap to store map so that it can be reused.
	//  create map only if it do not exist.
	        var detailMapMarkers = this.markers;
	// Mike Map Change End

		var long1 = this.detailPageModel.toJSON().Longitude;
		var lat =  this.detailPageModel.toJSON().Latitude;
		/* reset the center of the map */
		var latitudeAndLongitude = new google.maps.LatLng(lat, long1);
		/* Default map settings */
		var mapOptions = {
				zoom: 10,	
				mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		/* create new map */
		// Mike Map Change: create map only if it do not exist. But clear all pins
				if (!this.map)
				 {
				 this.map  = new google.maps.Map(document.getElementById("locator-map-div"), mapOptions);
				 }
				 else
				 {
				   $.each(detailMapMarkers, function(index, value) {
					value.setMap(null);
				      });
				  detailMapMarkers.length = 0;
				 }
		// Mike Map Change End
				 
		this.map.setCenter(latitudeAndLongitude);
		
       var mapicon = {
       	    url: 'image/store-locator-image/location-pin-teal.png',
       	    size: new google.maps.Size(82, 76),
       	    origin: new google.maps.Point(0,0),
       	    anchor: new google.maps.Point(22.5,40),
       	    scaledSize: new google.maps.Size(45, 40)
       	  };
        if (this.detailPageModel.toJSON().isPreferred) {
            mapicon = {
               	    url: 'image/store-locator-image/storelocator-mystore-pin-teal.png',
               	    size: new google.maps.Size(82, 76),
               	    origin: new google.maps.Point(0,0),
               	    anchor: new google.maps.Point(22.5,40),
               	    scaledSize: new google.maps.Size(45, 40)
               	  };
        }

        /* Create new marker */
		var markerCenter = new google.maps.Marker({
			position: latitudeAndLongitude,
			map:  this.map,
			icon: mapicon
		});

		// Mike Change: Track Marker for later deletion
		 detailMapMarkers.push(markerCenter);
//Mike Map Change End
		 
		google.maps.event.addListener(markerCenter, 'click', function (self) {
			appView.goBack();
//			var id = "#detail-page";
//			$.mobile.changePage(id, {transition: 'slide'});
//			/* Change appView currentPage */
//			appView.currentPage = id;
//			/* Create Detail page */
//			storeDetailPage.setModel(this.detailPageModel.toJSON());
//			storeDetailPage.render();
			
		});

        var myLocationMarker = new google.maps.Marker({
			position: this.myLocation,
			map: this.map
		});
		
     // Mike Map Change: Track Marker for later deletion
		  detailMapMarkers.push(myLocationMarker);
//Mike Map Change End
		
	},
});