var StoreListView = Backbone.View.extend({
	
	tagName: "ul",
	
	el: $("#locator-list-ul"),
	
	events:	{
		
	},
	
	initialize: function () {
		/* Array that stores all the item views */
		this.itemViews = new Array();
		
		this.listenTo(this.collection, "add", this.addOne);
		this.listenTo(this.collection, "reset", this.cleanUp);
		
		/* Create iScroller for store list */
		var self = this;
		var pullUpEl = document.getElementById('pullUp');
		var pullUpOffset = pullUpEl.offsetHeight;
		var scroller = new iScroll('locator-list-div',
									{//snap:'li', 
									hScroll:false,  
									vScroll:true, 
									vScrollbar: true, 
									hScrollbar: false, 
									fadeScrollbar: true, 
									hideScrollbar:true,
									onRefresh: function () {
										if (pullUpEl.className.match('loading')) {
											pullUpEl.className = '';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Pull up to load more...';
										}
									},
									onScrollMove: function () {this.maxScrollY = this.maxScrollY;
										if (this.y < (this.maxScrollY - 40) && !pullUpEl.className.match('flip')) {
											pullUpEl.className = 'flip';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Release to refresh...';
											this.maxScrollY = this.maxScrollY-80;
										} else if (this.y > (this.maxScrollY + 40) && pullUpEl.className.match('flip')) {
											pullUpEl.className = '';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Pull up to load more...';
											this.maxScrollY = pullUpOffset;
										}
									},
									onScrollEnd: function () { 
										if(pullUpEl.className.match('flip')){
											pullUpEl.className = 'loading';
											pullUpEl.querySelector('.pullUpLabel').innerHTML = 'Loading...';
											self.addMore();
										}
									},
									});
		this.listScroller = scroller;
		/* clean up */
		this.cleanUp();
	},
	
	addMore: function()	{
		this.collection.fetchMore();		
	},
	
//	addOne: function (item) {
//		var storeListItemView = new StoreListItemView({model : item});
//		this.$el.append(storeListItemView.render().el);
//		this.listScroller.refresh();
//		/* push to container array */
//		this.itemViews.push(storeListItemView);
//	},
	
	addOne: function (item) {
	    /* Add to list */
		var storeListItemView = new StoreListItemView({model : item});	/* Create item view */
		this.$el.append(storeListItemView.el);							/* Insert Item view to list */
		this.itemViews.push(storeListItemView);							/* Push to storage */
		
		/* Filter this item */
		//this.filterStore(storeListItemView);
		
		/* Refresh list scroller, should not doing it here!!.. */
		//this.listScroller.scrollTo(0,0,0);
		this.listScroller.scrollTo(0, this.listScroller.maxScrollY+60,true);
		this.listScroller.refresh();
		
		/* Show pullup icon */
		$("#pullUp").show();
		
		/* Show map - not.. this is the memory leak bug */
		//storeListMapView.showMap();
	},
	
	cleanUp: function () {
		this.$el.html("");
		/* Empty itemViews */
		this.itemViews.length=0;
		/* Hide pullup icon */
		$("#pullUp").hide();
        // reset scroller
        this.listScroller.scrollTo(0, this.listScroller.maxScrollY+60,true);
        this.listScroller.refresh();
	},
	
	showRefill: function() {
		var filter = "Online Refill";
		$.each(this.itemViews, function(index, value) {
			//if(value.model.toJSON().StoreServices.indexOf(filter) >= 0){
			if(index > 2){
				// do nothing
			}else{
				/* Hide the stores that don't have online refill service */
				value.$el.removeClass("list-item-show").addClass("list-item-hide");
			}
		});
		this.listScroller.refresh();
	},
	
	showAll: function() {
		$.each(this.itemViews, function(index, value) {
				/* Make All Stores Visible */
				value.$el.removeClass("list-item-hide").addClass("list-item-show");
		});
		this.listScroller.refresh();
	},
	
	/* Filter a single store */
	filterStore: function(itemView) {
		//alert("filter : " + storeFilterView.serviceList.toString());
		var i = 0, match = true;
		for(i; i<storeFilterView.serviceList.length; i++){
			if(itemView.model.toJSON().StoreServices.indexOf(storeFilterView.serviceList[i]) < 0){
				//alert("miss : " + storeFilterView.serviceList[i] + "\n" + itemView.model.toJSON().StoreServices);
				match = false;	/* Found a miss, no need to continue */
				break;
			}
		}
		//alert("match=" + match);
		if(match){/* All services are found */
			itemView.showItem();
		}else{
			itemView.hideItem();
		}
	},
	
	/* Filter a list of store */
	filterStoreList: function() {alert("filter stores");return;
		/* First need to filter out the stores without the services */
		if(serviceList.length>0)
		{
			if(item.toJSON().StoreServices.indexOf(serviceList[0]) >= 0){
				/* Create item view */
				var storeListItemView = new StoreListItemView({model : item});
				/* Insert Item view to list */
				this.$el.append(storeListItemView.render().el);
			}
		}else{
			/* Create item view */
		    var storeListItemView = new StoreListItemView({model : item});
		    /* Insert Item view to list */
		    this.$el.append(storeListItemView.render().el);
		}
		/* Move up the scroller */
		var max = this.listScroller.maxScrollY;
		this.listScroller.scrollTo(0, max);
	},
	
});