var TransferView = Backbone.View.extend({

	

	el: $("#transfer-page"),

	

	events: {

		"tap #transfer-showTransferFrom"	: "showTransferFrom",

		"tap #transfer-showTransferTo"		: "showTransferTo",

		"tap #transfer-showRequest"			: "showRequest",

		"tap #transfer-backTransferTo"		: "backTransferTo",

		"tap #transfer-backTransferFrom"	: "backTransferFrom",

		"tap #transfer-backPatientInfo"		: "backPatientInfo",

		

		"tap #transfer-input-find-another"	: "findAnother1",

		//"tap #transfer-input-cancel-another": "cancelAnother",

		"tap #transfer-search-location"		: "searchByLocation",

		"tap #transfer-search-phone"		: "searchByPhone",

		//"tap #transfer-radio-all"			: "hidePrescriptionList",

		//"tap #transfer-radio-list"			: "showPrescriptionList",

		"tap #transfer-add-prescription-button": "addPrescription",

		"tap .fill-now-other"				: "showOther",

		"tap .transfer-remove-prescription"	: "removePrescription",

		"tap #transfer-show-privacy-policy"	: "readRexallPage",
		"tap #transfer-read-rexall-page-prescription"	: "readRexallPagePrescription",

		"tap #transfer-form-submit"			: "submitTransfer",

		"tap #view-transfer-login"          : "loginfromTransfer",	

		"tap .rexall-page-header-info"			: "showInfo",

		"tap .rexall-page-info-popup-close"		: "closeInfo",
        
	},

   
	/* Patient information form for the user who don't have a MyRexall profile */

	//patientInfoTemplate: Handlebars.compile($("#transfer-patient-info-template").html()),

    loginfromTransfer: function() {
        if (!localStorage.getItem("JanRainLogin")) {
            //			loginView.setFromRefill(loginView.checkFromRefillValue());
            //			loginView.setFromTransfer(true);
            var id = "#login-page";
            $.mobile.changePage(id, {transition: 'slide'});
            appView.setStepsToGobackForRecord(3);
         //   console.log("TransferView.loginfromTransfer");
        }
        else {
            jAlert("You have already logged on!", "Transfer Prescription");
        }
    },

	initialize: function ( ) {

		

		/* Listen to profiles change */

		this.listenTo(this.model, "change", this.render);

		

		/* Set onchange functions for select tag transfer-form-existing-pharmacy */

		$("#transfer-form-existing-pharmacy").on("change", function() {

			if(this.value == "Other"){		/* Enable other field */

				$("#transfer-pharmacy-other").prop('disabled', false);
				/*$("#transfer-pharmacy-other").show();
				$("label[for=transfer-pharmacy-other]").show();*/
				/* Show require star */

				$("label[for=transfer-pharmacy-other]").find(".transfer-require-star").html("&nbsp;*<img src='image/pharmacy-image/icon-warning.png'>");

				/* Focus on the Other input field */

				$("#transfer-pharmacy-other").focus();

			}else{							/* Disable other field */	

			    $("#transfer-pharmacy-other").prop('disabled', true);
//
				$("#transfer-pharmacy-other").val("");	/* Clean input field */

				/* Remove require star */

				$("label[for=transfer-pharmacy-other]").find(".transfer-require-star").html("");
				
				/*$("#transfer-pharmacy-other").hide();
				$("label[for=transfer-pharmacy-other]").hide();*/

				/* Remove warning */

				$("label[for='transfer-pharmacy-other']").removeClass("rexall-warning-label");

			}

		});

        

		/* Set up popup information scroller */

		this.infoScroll = new iScroll("transfer-info-scroll",{

			hScroll:false, 

			vScroll:true, 

			vScrollbar: true, 

			hScrollbar: false, 

			fadeScrollbar: true, 

			hideScrollbar:true,

			});

		

		this.pharcyPolicyScroll = new iScroll("transfer-privacy-policy-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		
		this.pharcyPolicyScrollPrescription = new iScroll("transfer-privacy-policy-scroll-online",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});

		

		/* Set up the scroller for form list */

		this.transferScroll = new iScroll("transfer-scroll",{

			hScroll:false, 

			vScroll:true, 

			vScrollbar: true, 

			hScrollbar: false, 

			fadeScrollbar: true, 

			hideScrollbar:true,

			onBeforeScrollStart: function (e) { 

				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				
				/* There seem to be a bug with the inputmask (or "requirements")
				   These have to be here, and in this order, otherwise:
				     - the birth date field magically remembers the previous input when you click on the field
				     - the birth date line bugs up the telephone and the postal fields, and you cannot enter data into those fields */
				setHTML5DateFormat("transfer-birth-date");		
//				$("#transfer-home-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
//				$("#transfer-mobile-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
//				$("#transfer-patient-postal").inputmask("mask", {"mask": "a9a 9a9"}); 
				 setInputmaskPostalCode("transfer-patient-postal");
				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
					// commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
					// from hidding after user unfocus an input field
					//e.preventDefault();
				}else{	/* Auto scroll up for the input field */
					
					var selfScroll = this;
					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}	
					
					}, 800);
					
				} 

				},

			});

		

		this.transferScroll2 = new iScroll("transfer-scroll2",{

			hScroll:false, 

			vScroll:true, 

			vScrollbar: true, 

			hScrollbar: false, 

			fadeScrollbar: true, 

			hideScrollbar:true,

			onBeforeScrollStart: function (e) { 

				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				
//				$("#transfer-pharmacy-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 

				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */
					
					var selfScroll = this;
					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}	
					
					}, 800);
					
				} 

				},

			});

		

		this.transferScroll3 = new iScroll("transfer-scroll3",{

			hScroll:false, 

			vScroll:true, 

			vScrollbar: true, 

			hScrollbar: false, 

			fadeScrollbar: true, 

			hideScrollbar:true,

			onBeforeScrollStart: function (e) { 

				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				
//				$("#transfer-search-input-phone").inputmask("mask", {"mask": "(999) 999-9999"});  

				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */
					
					var selfScroll = this;
					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}	
					
					}, 800);
					
				} 

				},

			});

		

		this.transferScroll4 = new iScroll("transfer-scroll4",{

			hScroll:false, 

			vScroll:true, 

			vScrollbar: true, 

			hScrollbar: false, 

			fadeScrollbar: true, 

			hideScrollbar:true,

			onBeforeScrollStart: function (e) { 

				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");

				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */
					
					var selfScroll = this;
					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}	
					
					}, 800);
					
				} 

				},

			});

			

		/* Render the forms */

		//this.render();

	},

	

	/* Number of prescriptions being transfer */

	transferPrescriptions: 1,

	

	/* Prefill the transfer form if patient profile is available */

	render: function() {


		/* Clean up all input fields */

		this.cleanUp();

		

		/* Hide all pages */
		$("#transfer-scroll").hide();
		$("#transfer-scroll2").hide();
		$("#transfer-scroll3").hide();
		$("#transfer-scroll4").hide();

//		$("#transfer-scroll").removeClass("in reverse").addClass("turn out");	/* Patient info form */
//
//		$("#transfer-scroll2").removeClass("in reverse").addClass("turn out");	/* transfer location form */
//
//		$("#transfer-scroll3").removeClass("in reverse").addClass("turn out");	/* transfer to form */
//
//		$("#transfer-scroll4").removeClass("in reverse").addClass("turn out");	/* comfirm page */

		

		/* Handle patient information */

		/* if(localStorage.getItem("RexallProfile")){ */		/* Has patient profile */
		if(localStorage.getItem("JanRainLogin")&&profile.hasProfile&&profile.hasRecord()) {	

			this.showTransferFrom();							/* Show to transfer location form */
			$("#transfer-backPatientInfo").hide();				/* hide back button to info form */
			
			if(loginView.goToTransferPage){
				 var id = "#transfer-page";
	           $.mobile.changePage(id, {transition: 'slide'});
	           loginView.goToTransferPage = false;
			}

		}else{												/* Don't have patient profile */

			this.backPatientInfo();								/* Show patient info form */

			$("#transfer-backPatientInfo").show();				/* Show back button to info form */

		}



		/* change button number */

		

		/* Fill Home store */

		this.cancelAnother();	/* Search location form */


		if(localStorage.getItem("RexallProfileHomeStore") 

		|| localStorage.getItem("CurrentStore")){			/* Has home store from file or preferred store */

			$("#transfer-form-to-default").show();				/* Show default address */

			$("#transfer-form-to-search").hide();				/* Hide the search form */

			$("#transfer-form-to-seperator1").hide();			/* and seperators */

			$("#transfer-form-to-seperator2").hide();			

			$("#transfer-form-to-select").hide();				/* Hide the search result form */

			/* Prefill pharmacy address */

			if(localStorage.getItem("RexallProfileHomeStore")){	/* Use profile store (must have login) */

				var store = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));

			}else{												/* Use preferred store */

				/* Change label name */ 

				$("label[for='transfer-to-pharmacy-address-default']").html("Preferred Pharmacy<span class='transfer-require-star'>&nbsp;*<img src='image/pharmacy-image/icon-warning.png'></span>");

				var store = JSON.parse(localStorage.getItem("CurrentStore"));
			
				$("#transfer-form-to-search").hide();				/* Hide the search form */

				$("#transfer-form-to-seperator1").hide();			/* and seperators */

				$("#transfer-form-to-seperator2").hide();			

				$("#transfer-form-to-select").hide();				/* Hide the search result form */
			
			}
			$("#transfer-to-pharmacy-address-default").val(storeSubstring(store.StoreName + ", " +store.Address + ", " + store.City+", "+store.Province,35));
		}else{										/* Don't have home store from file and preferred store */

			$("#transfer-form-to-default").hide();				/* Hide default address */

			$("#transfer-form-to-search").show();				/* Show the search form */

			$("#transfer-form-to-seperator1").show();			/* and seperators */

			$("#transfer-form-to-seperator2").hide();

			$("#transfer-form-to-select").hide();				/* Hide the search result form */

		}

	

		/* Hide the add prescription list */

		this.hidePrescriptionList();

		

		/* Hide the other input field */

		this.hideOtherList();

		

		/* Sort form step numbers */

		this.sortForms();

		if(janrainLogin.get("hasLogin") && localStorage.getItem("JanRainLogin")){

			/* Logged in, do not show */
			$("#view-transfer-login").hide();

			$("#transfer-complete-steps-below").hide();


		}else{

			/* not Logged in, show login button */

			$("#view-transfer-login").show();

			$("#transfer-complete-steps-below").show();

		}		

		/* Refresh scroller */
		setTimeout(function(){
		transferView.transferScroll.refresh();

		transferView.transferScroll2.refresh();

		transferView.transferScroll3.refresh();

		transferView.transferScroll4.refresh();
		},240);

	},

	

	/**

	 * Validate functions

	 */

	/* Validates the inputs from the patient info form, return true is all pass */

	checkPatientInfo: function() {


		var result = true;

		var validDOB = true;	/* Another flag to indicate whether the input DOB is valid */

		/* Check first name */

		if($("#transfer-patient-first-name").val().length <= 0){

			$("label[for='transfer-patient-first-name']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-patient-first-name']").removeClass("rexall-warning-label");

		}

		/* Check last name */

		if($("#transfer-patient-last-name").val().length <= 0){

			$("label[for='transfer-patient-last-name']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-patient-last-name']").removeClass("rexall-warning-label");

		}

//		/* Check birthday */

//		if($("#transfer-birth-day").val().length <= 0 

//				|| $("#transfer-birth-month").val().length <= 0 

//				|| $("#transfer-birth-year").val().length <= 0){alert("here");

//			$("label[for='transfer-birth-date']").addClass("rexall-warning-label");

//			result &= false;

//		}else{

//			$("label[for='transfer-birth-date']").removeClass("rexall-warning-label");

//		}

		

		/* Check birth date */
		var birthDate = getHTML5Date("transfer-birth-date");
		if(getHTML5DateLength("transfer-birth-date") != 8||
		    !appView.checkDateOfBirth(birthDate)){
			
			$("label[for='transfer-birth-date']").addClass("rexall-warning-label");
			result &= false;
		}else{
			$("label[for='transfer-birth-date']").removeClass("rexall-warning-label");
		}
//		var birthDate = $("#transfer-birth-day").val();
//
//		var birthMonth = $("#transfer-birth-month").val();
//
//		var birthYear = $("#transfer-birth-year").val();
//
//		if(birthDate.length <= 0 || birthMonth.length <= 0 || birthYear.length <= 0){
//
//			$("label[for='transfer-birth-date']").addClass("rexall-warning-label");
//
//			result &= false;
//
//		}else if(birthMonth > 12){
//
//			$("label[for='transfer-birth-date']").removeClass("rexall-warning-label");
//
//			//result &= false;
//
//			validDOB &=false;
//
//		}else{	
//
//			$("label[for='transfer-birth-date']").removeClass("rexall-warning-label");
//
//			if(birthMonth == 1 || birthMonth == 3  || birthMonth == 5  || birthMonth == 7  ||
//
//					  birthMonth == 8  || birthMonth == 10  || birthMonth == 12 ){
//
//				  if (birthDate > 31){
//
//					  validDOB &=false;
//
//				  }
//
//			}else{
//
//				if(birthMonth == 2  ){
//
//					if (birthDate > 28){
//
//						validDOB &=false;
//
//					}
//
//				}
//
//				if(birthDate > 30){
//
//					validDOB &=false;
//
//				}
//			}
//			
//			/* Check year */
//			var currentYear = new Date().getFullYear(); 
//
//			if((birthYear < 1910) || (birthYear > currentYear)) { 
//
//				validDOB &=false;
//
//			}
//
//		}

		



		/* Check email */

		if($("#transfer-patient-email").val().length <= 0){
			$("label[for='transfer-patient-email']").addClass("rexall-warning-label");
			result &= false;
		}else{
		 if (!this.validateEmail($("#transfer-patient-email").val()))
			{$("label[for='transfer-patient-email']").addClass("rexall-warning-label");
			result &= false;
		      }else{			
		     $("label[for='transfer-patient-email']").removeClass("rexall-warning-label");
   		     }
		}

		/* Check phone number */

		if($("#transfer-home-phone").val().length != 14){

			$("label[for='transfer-home-phone']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-home-phone']").removeClass("rexall-warning-label");

		}
		
		/* Check mobile phone number */
		var mobilePhoneLength = $("#transfer-mobile-phone").val().length;
		 
		if(!(mobilePhoneLength == 14 || mobilePhoneLength <= 0)){

			$("label[for='transfer-mobile-phone']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-mobile-phone']").removeClass("rexall-warning-label");

		}
		
		/* Check address */

		if($("#transfer-patient-address").val().length <= 0){

			$("label[for='transfer-patient-address']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-patient-address']").removeClass("rexall-warning-label");

		}

		/* Check city */

		if($("#transfer-patient-city").val().length <= 0){

			$("label[for='transfer-patient-city']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-patient-city']").removeClass("rexall-warning-label");

		}

		/* Check province */

		if($("#transfer-form-existing-province").val() == "ChooseFromList"){

			$("label[for='transfer-form-existing-province']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-form-existing-province']").removeClass("rexall-warning-label");

		}

		/* Check postal code */
		if($("#transfer-patient-postal").val().length != 7){

			$("label[for='transfer-patient-postal']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-patient-postal']").removeClass("rexall-warning-label");

		}

		

		if(!result){			/* Has incompleted field */

			jAlert("Complete the information highlighted in red.", "Please Try Again");

		}else if(!validDOB){	/* Has invalid Date of Birth */	

			jAlert("Provide a valid birthdate.", "Please Try Again");

		}else{

//			if(!appView.checkDateOfBirthAfter18(birthDate))
//			  {console.log("Birthdate is less than 18 years");
//			  jAlert("You must be at least 18 years of age to request to transfer your prescription.", "Please Try Again");
//			 $("label[for='transfer-birth-date']").addClass("rexall-warning-label");
//			  result &= false;
//			  }

		}

	

		return (result && validDOB);

	},

	

	/* Validate transfer from form */

	checkTransferFrom: function() {

		var result = true;

	/*	if($("#transfer-form-existing-pharmacy").val() == "Other"

			&& $("#transfer-pharmacy-other").val().length <= 0){

			$("label[for='transfer-form-existing-pharmacy']").removeClass("rexall-warning-label");

			$("label[for='transfer-pharmacy-other']").addClass("rexall-warning-label");

			result &= false;

		}else if($("#transfer-form-existing-pharmacy").val() == "ChooseFromList"){

			$("label[for='transfer-pharmacy-other']").removeClass("rexall-warning-label");

			$("label[for='transfer-form-existing-pharmacy']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-form-existing-pharmacy']").removeClass("rexall-warning-label");

			$("label[for='transfer-pharmacy-other']").removeClass("rexall-warning-label");

		}*/

		

		if($("#transfer-form-existing-pharmacy").val() == "ChooseFromList"){

			/* Nothing has been chose from list */

			$("label[for='transfer-form-existing-pharmacy']").addClass("rexall-warning-label");

			$("label[for='transfer-pharmacy-other']").removeClass("rexall-warning-label");

			result &= false;

		}else if($("#transfer-form-existing-pharmacy").val() == "Other"

					&& $("#transfer-pharmacy-other").val().length <= 0){

			/* "Other" has been selected but Other's input field is empty */

			$("label[for='transfer-pharmacy-other']").addClass("rexall-warning-label");

			$("label[for='transfer-form-existing-pharmacy']").removeClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-form-existing-pharmacy']").removeClass("rexall-warning-label");

			$("label[for='transfer-pharmacy-other']").removeClass("rexall-warning-label");

		}

		

		/* Check phone number */

		if($("#transfer-pharmacy-phone").val().length != 14 ){

			$("label[for='transfer-pharmacy-phone']").addClass("rexall-warning-label");

			result &= false;

		}else{

			$("label[for='transfer-pharmacy-phone']").removeClass("rexall-warning-label");

		}

		if(!result)	jAlert("Complete the information highlighted in red.", "Please Try Again");

		

		return result;

	},

	

	/* Validate transferTo from form */

	checkTransferToFrom: function() {

		var result = false;

		

//		if($("#transfer-to-pharmacy-address-default").val().length <= 0 

//				&& (!$("#transfer-search-location-result").val() || $("#transfer-search-location-result").val() == "ChooseFromList")){

//			$("label[for='transfer-to-pharmacy-address-default']").addClass("rexall-warning-label");

//			//$("label[for='transfer-search-location-result']").addClass("rexall-warning-label");

//			result &= false;

//		}else{

//			$("label[for='transfer-to-pharmacy-address-default']").removeClass("rexall-warning-label");

//			$("label[for='transfer-search-location-result']").removeClass("rexall-warning-label");

//		}

		

		var transferToResult = $("#transfer-search-location-result").val();

		var transferToDefault = $("#transfer-to-pharmacy-address-default").val();

		

		if($("#transfer-form-to-search").is(":visible")

			&& (transferToResult == null)){	

			/* Need to finish search */

			$("#transfer-form-to-header").addClass("rexall-warning-label");

			$("label[for='transfer-search-location-result']").removeClass("rexall-warning-label");

			$("label[for='transfer-to-pharmacy-address-default']").removeClass("rexall-warning-label");

		}else if( $("#transfer-form-to-search").is(":visible")

			&& $("#transfer-form-to-select").is(":visible") 

			&& (transferToResult == "ChooseFromList" || transferToResult.length <= 0)){

			/* Need to select from search result */

			$("#transfer-form-to-header").removeClass("rexall-warning-label");

			$("label[for='transfer-to-pharmacy-address-default']").removeClass("rexall-warning-label");

			$("label[for='transfer-search-location-result']").addClass("rexall-warning-label");

		}else if(!$("#transfer-form-to-search").is(":visible") && transferToDefault.length <= 0 ){

			/* Default field is enabled and is empty */

			$("#transfer-form-to-header").removeClass("rexall-warning-label");

			$("label[for='transfer-search-location-result']").removeClass("rexall-warning-label");

			$("label[for='transfer-to-pharmacy-address-default']").addClass("rexall-warning-label");

		}else{

			$("#transfer-form-to-header").removeClass("rexall-warning-label");

			$("label[for='transfer-search-location-result']").removeClass("rexall-warning-label");

			$("label[for='transfer-to-pharmacy-address-default']").removeClass("rexall-warning-label");

			result = true;

		}

		

		

		if(!result)	jAlert("Select a pharmacy location to transfer your prescriptions to.", "Please Try Again");

		

		return result;

	},

	

	/* Validate prescription information */

	checkPrescriptionFrom: function() {

		var result = true;

		if(!$("#transfer-transfer-all").prop("checked")){
			
			if(!$("#transfer-transfer-list").prop("checked")){
				$("#be-transferred").addClass("rexall-warning-label");
				result &= false;
			}else{
				$("#be-transferred").removeClass("rexall-warning-label");
				for(i=1; i<=this.transferPrescriptions; i++){
					
					if($("#transfer-add-drug"+i).val().length <= 0){
	
						$("label[for='transfer-add-drug"+i+"']").addClass("rexall-warning-label");
	
						result &= false;
	
					}else{
	
						$("label[for='transfer-add-drug"+i+"']").removeClass("rexall-warning-label");
	
					}
	
					
	
					if($("#transfer-add-rx"+i).val().length <= 0){
	
						$("label[for='transfer-add-rx"+i+"']").addClass("rexall-warning-label");
	
						result &= false;
	
					}else{
	
						$("label[for='transfer-add-rx"+i+"']").removeClass("rexall-warning-label");
	
					}
	
				}
			}
		}
		if(!$("input[name='agree-transfer']").prop("checked")){
			jAlert("You must agree to the Prescription Transfer Terms and Conditions to continue.","Please Try Again");
			return;
		}
		if(!result)	jAlert("Complete the information highlighted in red.", "Please Try Again");

		

		return result;

	},

	

	/**

	 * GO TO FUNCTIONS 

	 */

	/* Go to Pharmacy Location step*/

	showTransferFrom: function(e) {

		if(e){	
			e.preventDefault(); 

			/* Only check the inputs if the function is triggered by user tapping action */

			if(!this.checkPatientInfo())

				return;

		}



		/* Show verbiage if transfer from medication record */

		if(localStorage.getItem("RexallProfile")){			/* Has patient profile */

			$("#record-transfer-verbiage").show();

		}else{												/* Don't have patient profile */

			$("#record-transfer-verbiage").hide();

		}

		$("#transfer-scroll").hide();
		$("#transfer-scroll2").show();
		 setTimeout(function(){
	            transferView.transferScroll2.refresh();
	        },240);  
//		$("#transfer-scroll").removeClass("in reverse").addClass("out");
//
//		$("#transfer-scroll2").removeClass("out reverse").addClass("in");

	},

	

	/* Go to transfer to form */

	showTransferTo: function(e) {
		if(e){	
			e.preventDefault(); 

			/* Only check the inputs if the function is triggered by user tapping action */

			if(!this.checkTransferFrom())

				return;

		}
		$("#transfer-scroll2").hide();
		$("#transfer-scroll3").show();
		setTimeout(function(){
            transferView.transferScroll3.refresh();
        },240);  
//        if ($("#transfer-input-find-another").hasClass( "transfer-input-button1" ))
//          {
//			/* special flag to bypass double click problem */ this.dialogIsClosedDoNotOpen = true;
//			setTimeout(function(){
//          	/* special flag to bypass double click problem. Do not process click in the first second */ transferView.dialogIsClosedDoNotOpen = false;
//          },1000);  
//        }
//		$("#transfer-scroll2").removeClass("in reverse").addClass("out");
//
//		$("#transfer-scroll3").removeClass("out reverse").addClass("in");

	},

	

	/* Go to showRequest form */

	showRequest: function(e) {

		if(e){
			e.preventDefault(); 

			/* Only check the inputs if the function is triggered by user tapping action */

			if(!this.checkTransferToFrom())

				return;

		}
		$("#transfer-scroll3").hide();
		$("#transfer-scroll4").show();
		
		setTimeout(function(){
            transferView.transferScroll4.refresh();
        },240); 
//		$("#transfer-scroll3").removeClass("in reverse").addClass("out");
//
//		$("#transfer-scroll4").removeClass("out reverse").addClass("in");

	},

	

	/**

	 * GO BACK FUNCTIONS

	 */

	/* Go back to Patient info page */

	backPatientInfo: function() {

		$("#transfer-scroll2").hide();
		$("#transfer-scroll").show();
//		$("#transfer-scroll2").removeClass("in").addClass("out reverse");
//
//		$("#transfer-scroll").removeClass("out").addClass("in reverse");
//		this.transferScroll.scrollTo(0,0,200);
		setTimeout(function(){
            transferView.transferScroll.refresh();
        },240);
		
	},

	

	/* Go back to backTransferFrom page */

	backTransferFrom: function() {
		
		$("#transfer-scroll3").hide();
		$("#transfer-scroll2").show();
//		$("#transfer-scroll3").removeClass("in").addClass("out reverse");
//
//		$("#transfer-scroll2").removeClass("out").addClass("in reverse");
//		this.transferScroll2.scrollTo(0,0,200);
		setTimeout(function(){
            transferView.transferScroll2.refresh();
        },240);
	},

	

	/* Go back to TransferTo page */

	backTransferTo: function() {

		$("#transfer-scroll4").hide();
		$("#transfer-scroll3").show();
		
//		$("#transfer-scroll4").removeClass("in").addClass("out reverse");
//
//		$("#transfer-scroll3").removeClass("out").addClass("in reverse");
//		this.transferScroll3.scrollTo(0,0,200);
		setTimeout(function(){
            transferView.transferScroll3.refresh();
             },240);
	},

	findAnother1: function() {
	  // alert("bypass to check that it is backbone causing the double tap");
	      		this.findAnother();
       },	

	/* Show search store form */

	findAnother: function() {
       
		var anotherClass = $("#transfer-input-find-another").attr("class");

		if(anotherClass=="transfer-input-button1"){

			/* Rotate button arrow */

			$("#transfer-input-find-another").removeClass("transfer-input-button1").addClass("refill-input-button1");

			/* Disable editable input */

			$("#transfer-to-pharmacy-address-default").prop('disabled', true);	

			/* Switch require star */

			$("#transfer-form-to-header").find(".transfer-require-star").html("&nbsp*<img src='image/pharmacy-image/icon-warning.png'>");

			$("label[for=transfer-to-pharmacy-address-default]").find(".transfer-require-star").html("&nbsp");

			

			$("#transfer-form-to-seperator1").show(200);		/* and seperators */

			$("#transfer-form-to-search").show(200);			/* Show the search form */

		}else{

//			/* Rotate button arrow */

//			$("#transfer-input-find-another").removeClass("refill-input-button1").addClass("transfer-input-button1");

//			/* Enable editable input */

//			$("#transfer-to-pharmacy-address-default").prop('disabled', false);

//			

//			$("#transfer-form-to-seperator1").hide(200);		/* Hide seperators */

//			$("#transfer-form-to-search").hide(200);			/* Hide the search form */

//			$("#transfer-form-to-seperator2").hide(200);		/* and seperators */

//			$("#transfer-form-to-select").hide(200);			/* and results */

			this.cancelAnother();

		}

		

		/* refresh the form scroller */

		this.transferScroll.refresh();

	},

	

	/* Cancel search store form */

	cancelAnother: function() {

		/* Rotate button arrow */

		$("#transfer-input-find-another").removeClass("refill-input-button1").addClass("transfer-input-button1");

		/* Enable editable input */

		$("#transfer-to-pharmacy-address-default").prop('disabled', false);

		/* Switch require star */

		$("#transfer-form-to-header").find(".transfer-require-star").html("&nbsp");

		$("label[for=transfer-to-pharmacy-address-default]").find(".transfer-require-star").html("&nbsp*<img src='image/pharmacy-image/icon-warning.png'>");

		

		$("#transfer-form-to-seperator1").hide();		/* Hide seperators */

		$("#transfer-form-to-search").hide();			/* Hide the search form */

		$("#transfer-form-to-seperator2").hide();		/* and seperators */

		$("#transfer-form-to-select").hide();			/* and results */



		//$("#transfer-input-cancel-another").hide();			/* Show cancel button */

		

		/* Clean search result */

		$("#transfer-search-location-result").html("");

		

		/* refresh the form scroller */

		this.transferScroll.refresh();

	},

	

	/* Get the user's prefered store and automatically fill it in the PHARMACY ADDRESS field */

	fillCurrentStore: function() {

		

		if(currentStoreView.model){

			var a = currentStoreView.model.get("Address") + " " +

					currentStoreView.model.get("City") + ", " +

					currentStoreView.model.get("Province") + " " +

					currentStoreView.model.get("PostalCode");

							

			$("#transfer-to-pharmacy-address").val(a);

		}

	},

	

	/* Sort the step number of the forms */

	sortForms: function() {

		

		this.$el.find(".large-page-scroller").each(function(index, value){

			if(localStorage.getItem("RexallProfile")&&profile.hasRecord()&&profile.hasProfile()){	

				index -= 1;	/* have profile, doesn't count patient info page */

			}

			/* Sort form number */

			$(value).find(".transfer-form-section-number").html(index + 1);

			/* Sort button number */

			$(value).find(".transfer-step-number").html(index + 2);

		});

		

	},

	

	/* Search transfer to store by location */

	searchByLocation: function() {

		/* Get search query */

		var q = $("#transfer-search-location-input").val();

	    if (!q){

	    	jAlert("Enter a valid address.","Please Try Again");

	    	return;

	    }

		/* Clean up the history list first */

		$("#transfer-search-location-result").html('<option value="ChooseFromList">Choose from the list below</option>');

        $("#transfer-search-input-phone").val("");

		/* Create a new store collection */

		var searchResult = new StoreDetailList();

		/* Create view */

		this.transferToStoreList = new RefillStoreListView({"collection" : searchResult});

		this.transferToStoreList.setEl("#transfer-search-location-result");

		/* Fetch data */

		searchResult.fetchDataWithInput(q);

		/* Display the result form

		$("#transfer-form-to-seperator2").show(200);

		$("#transfer-form-to-select").show(200); */

		/* refresh the form scroller */

		setTimeout(function() {

			transferView.transferScroll3.refresh();

		}, 240);

	},

	

	/* Search transfer to store by Phone number */

	searchByPhone: function() {

		/* Clean up the history list first */

		$("#transfer-search-location-result").html('<option value="ChooseFromList">Choose from the list below</option>');

		$("#transfer-search-location-input").val("");

		/* Read in phone number */
			var contactPhoneLength = $("#transfer-search-input-phone").val().length;
            if(!(contactPhoneLength == 14))
            {
                $("label[for='transfer-search-input-phone']").addClass("rexall-warning-label");
                $.alerts.alert("The phone number is invalid.", "Please Try Again");
            }
            else{$("label[for='transfer-search-input-phone']").removeClass("rexall-warning-label");		
		
				var phoneInput = $("#transfer-search-input-phone").val();
				var p1 = phoneInput.substring(1,4);
				var p2 = phoneInput.substring(6,9);
					var p3 = phoneInput.substring(10,14);
				var phoneNumber = p1 + "-" + p2 + "-" + p3;

				/* Create a new store collection */
				var searchResult = new StoreDetailList();

				/* Create view */
				this.transferToStoreList = new RefillStoreListView({"collection" : searchResult});
				this.transferToStoreList.setEl("#transfer-search-location-result");

				/* Fetch data */
				searchResult.fetchDataWithPhone(phoneNumber);

				/* Display the result form 
				$("#transfer-form-to-seperator2").show(200);
				$("#transfer-form-to-select").show(200);*/

				/* refresh the form scroller */
				setTimeout(function() {
					transferView.transferScroll3.refresh();
				}, 240);

			}
	},

	

	/* Show the prescription form */

	showPrescriptionList: function() {

		/* Show list */

		var i;

		for(i=0; i<=this.transferPrescriptions; i++){

			/* Show add prescription form */

			$("#transfer-add-prescription-seperator" + i).show(200);

			$("#transfer-add-prescription" + i).show(200);

			/* Remove warning labels */

			$("#transfer-add-prescription" + i).find(".rexall-warning-label").removeClass("rexall-warning-label");

		}

		/* Show add prescription button */

		if(this.transferPrescriptions < 3)

			$("#transfer-add-prescription-button").show(200);

		/* refresh the form scroller */

		setTimeout(function() {

			transferView.transferScroll4.refresh();

		}, 240);

	},

	

	/* Hide the prescription form */

	hidePrescriptionList: function() {

		/* Hide list */

		var i;

		for(i=0; i<=3; i++){

			$("#transfer-add-prescription" + i).hide(200);

		}

		/* Hide add prescription button */

		$("#transfer-add-prescription-button").hide(200);

		/* refresh the form scroller */

		setTimeout(function() {

			transferView.transferScroll4.refresh();

		}, 240);

	},

	

	/* Hide the other boxes */

	hideOtherList: function() {

		/* Hide list */

		var i;

		for(i=1; i<=3; i++){

			if($("input[name=fill-now"+i+"][value=other]").prop("checked")){

				$("#fill-now"+i+"-other").show();

			}else{

				$("#fill-now"+i+"-other").hide();

			}

		}

	},

	

	/* Add a prescription form */

	addPrescription: function() {

		if(this.transferPrescriptions == 3)

			return;

		/* Show another prescription form */

		this.transferPrescriptions += 1;

		$("#transfer-add-prescription-seperator" + this.transferPrescriptions).show(200);

		$("#transfer-add-prescription" + this.transferPrescriptions).show(200);

		/* Remove warning labels */

		$("#transfer-add-prescription" + this.transferPrescriptions).find(".rexall-warning-label").removeClass("rexall-warning-label");

		/* Hide previous prescriptions' remove button */

		if($("#transfer-add-prescription" + (this.transferPrescriptions - 1)).find(".transfer-remove-prescription"))

			$("#transfer-add-prescription" + (this.transferPrescriptions - 1)).find(".transfer-remove-prescription").hide(200);

		/* Hide the add button if all 3 prescription form are shown */

		if(this.transferPrescriptions == 3){

			$("#transfer-add-prescription-button").hide(200);

		}

		/* refresh the form scroller */

		setTimeout(function() {

			transferView.transferScroll4.refresh();

		}, 240);

	},

	

	removePrescription: function(e){

		/* Remove input */

		/* Hide section */

		var id = $(e.target).parent().prop("id");

//		var n = parseInt(id);

//		alert(n);

//		if(n != this.transferPrescriptions){

//			alert("do something here");

//		}

		$("#transfer-add-drug" + this.transferPrescriptions).val(" ") ;
		$("#transfer-add-rx" + this.transferPrescriptions).val(" ")  ;
		$("#fill-notes" + this.transferPrescriptions).val(" ")  ;
		$('input[name="fill-now' + this.transferPrescriptions+ '"][value="fill"]').prop('checked',true) ;	
		$("#fill-other" + this.transferPrescriptions).val(" ") ;

		$("#"+id).hide(200);

		/* Reduce prescription number */

		this.transferPrescriptions -= 1;

		/* Show current prescriptions' remove button */

		if($("#transfer-add-prescription" + this.transferPrescriptions).find(".transfer-remove-prescription"))

			$("#transfer-add-prescription" + this.transferPrescriptions).find(".transfer-remove-prescription").show(200);

		/* Show add prescription button */

		if(this.transferPrescriptions < 3)

			$("#transfer-add-prescription-button").show(200);	/* Show the add button if less 3 prescription form are shown */

		/* refresh the form scroller */

		setTimeout(function() {

			transferView.transferScroll4.refresh();

		}, 240);

	},

	

	/* Show privacy policy */

	showPrivacy: function() {

		alert("Under construction");

	},

	

	/* Submit transfer request */

	submitTransfer: function(e) {

		if(e){

			/* Only check the inputs if the function is triggered by user tapping action */

			if(!this.checkPrescriptionFrom())

				return;

		}

		

		/* Create new transfer object */

        //alert(JSON.stringify(localStorage.getItem("RexallProfileHomeStore")));

        var TransferToStore = localStorage.getItem("RexallProfileHomeStore");

		var transfer = new Transfer(TransferToStore);

		/* Request transfer */

		transfer.requestTransfer();

		

	},

	

	/* Show the input box for other */

	showOther: function(e){

		/* Get radio button value */

		var t = $(e.target);

		var id = "#"+t.parent(".fill-now-other").find("input").prop("name") + "-other";



		if(t.parent(".fill-now-other").find("input").prop("value") == "other"){

			$(id).show();

		}else{

			$(id).hide();

		}

	},

	

	/* Pop up information */

	showInfo: function(e) {

		//e.preventDefault();

		/* Modify info content */

		if(localStorage.getItem("RexallProfile")){			/* Has patient profile */

			$("#transfer-page-info").find("p").html("Transfer your prescriptions to Rexall using your MyRexall account. Simply request to transfer your prescriptions to the Rexall store that is connected to your MyRexall account. Complete the required information on the form: transferring pharmacy information and the prescriptions you would like transferred. ");

		}else{												/* Don't have patient profile */

			$("#transfer-page-info").find("p").html("Transfer your prescriptions from another pharmacy or between Rexall or Rexall Pharma Plus locations by using our mobile request form. Simply enter your personal information, transferring pharmacy location, the Rexall pharmacy location you are transferring to and which prescriptions you would like transferred.<br/><br/>If you have a store selected, this store location(s) will be prepopulated in the Rexall pharmacy being transferred to section. If you wish to use a different location from what is listed, select change location.");

		}

        // Close keyboard if it's open
        if(cordova.plugins.Keyboard.isVisible){
            $('input').blur();  // unfocus input
            cordova.plugins.Keyboard.close();   // close keyboard

            var self = this;
            setTimeout(function(){  // set a 0.5 sec delay to allow keyboard close first
                $("#transfer-page-info").popup( "option", "history", false );
                $("#transfer-page-info").popup({ transition: "pop" });
                $("#transfer-page-info").popup("open");
                self.infoScroll.refresh();
            }, 500);
        }else{
            $("#transfer-page-info").popup( "option", "history", false );
            $("#transfer-page-info").popup({ transition: "pop" });
            $("#transfer-page-info").popup("open");
            this.infoScroll.refresh();
        }
	},

	

	/* Close information */

	closeInfo: function(e) {

		e.preventDefault();

		$("#transfer-page-info").popup("close");

		$("#transfer-rexall-privacy-policy").popup("close");
		$("#transfer-privacypolicy-page-prescription").popup("close");

	},

	

	/* Clean up all the input field */

	cleanUp: function() {

		

		/* Remove warning class */

		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");

		

		/* Clean up textarea field */

		this.$el.find("textarea").each(function(index, value){

			$(value).val("");

		});

		

		/* Clean up input field */

		this.$el.find("input").each(function(index, value){

			

			if($(value).prop("type") != "radio"&&
					$(value).prop("type") != "checkbox"&&
					$(value).prop("id")!="transfer-to-pharmacy-address-default"){

				/* text, number, textarea */
				$(value).val("");
			}else{
				$(value).prop("checked",false);
			}

		});

		
		setHTML5DateFormat("transfer-birth-date");	
//		$("#transfer-home-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
//		$("#transfer-mobile-phone").inputmask("mask", {"mask": "(999) 999-9999"});
//		$("#transfer-patient-postal").inputmask("mask", {"mask": "a9a 9a9"}); 
		 setInputmaskPostalCode("transfer-patient-postal");
//		$("#transfer-pharmacy-phone").inputmask("mask", {"mask": "(999) 999-9999"}); 
//		$("#transfer-search-input-phone").inputmask("mask", {"mask": "(999) 999-9999"});
		/* Clean up select input field */

		this.$el.find("option[value=ChooseFromList]").prop("selected", true);

		/* trigger change event to update Other input field */

		$("#transfer-form-existing-pharmacy").change();

		

		/* Reset all radio selections */

		$("#transfer-transfer-all").prop("checked", true);

		$(".fill-now-default").prop("checked", true);

		

		/* Reset prescription form */

		this.transferPrescriptions = 1;

	},

	

	/* Show privacy policy */

	readRexallPage: function(e){

		e.preventDefault();

		/* Open privacy policy box */

		$("#transfer-rexall-privacy-policy").popup( "option", "history", false );

		$("#transfer-rexall-privacy-policy").popup({ transition: "pop" });

		$("#transfer-rexall-privacy-policy").popup("open");

		

		this.pharcyPolicyScroll.refresh();
		



	},
	
	readRexallPagePrescription: function(e){
		e.preventDefault();	
		$("#transfer-privacypolicy-page-prescription").popup( "option", "history", false );
		$("#transfer-privacypolicy-page-prescription").popup({ transition: "pop" });
		$("#transfer-privacypolicy-page-prescription").popup("open");
		this.pharcyPolicyScrollPrescription.refresh();
		
	},

	validateEmail: function(email) { 
  // http://stackoverflow.com/a/46181/11236
  
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
	}


});

/* hide Prescription List*/
function hidePrescriptions (){
	
	transferView.hidePrescriptionList();
	
};
/* show Prescription List*/
function showPrescriptions (){
	
	transferView.showPrescriptionList();
	
};